package base;

/* EN DESARROLLO (probado, slo funcionan algunas opciones) */

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import javax.mail.Message;
import javax.mail.search.AndTerm;
import javax.mail.search.BodyTerm;
import javax.mail.search.FromStringTerm;
import javax.mail.search.HeaderTerm;
import javax.mail.search.MessageIDTerm;
import javax.mail.search.OrTerm;
import javax.mail.search.RecipientStringTerm;
import javax.mail.search.SearchTerm;
import javax.mail.search.SubjectTerm;

/******************************************************************************
 *																	          * 
 *  Copyright 2004 Jordi Oliveras & Marcos Valerio. 						  *
 * 																			  *
 *  This file is part of Ogre.												  *
 *																			  *
 *  Ogre is free software; you can redistribute it and/or modify			  *
 *  it under the terms of the GNU General Public License as published by	  *
 *  the Free Software Foundation; either version 2 of the License, or		  *
 *  (at your option) any later version.										  *
 *																			  *
 *  Ogre is distributed in the hope that it will be useful,					  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of			  *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			  *
 *  GNU General Public License for more details.							  *
 *                       													  *
 *  You should have received a copy of the GNU General Public License         *
 *  along with Ogre; if not, write to the Free Software                       *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 * 																			  *
 ******************************************************************************
 * 																			  *
 * BuscadorMail - Clase encargada de buscar determinados correos en la cuenta *
 * de correo remota (en servidor de correo), filtrando segn determinadas	  *
 * cabeceras o contenidos de los mismos.									  *
 * 																			  *
 ******************************************************************************/

public final class BuscadorMail {

	static int n;
	static String linea;
	static SearchTerm buscador;

	public BuscadorMail(){
	}

	/* ---Mtodo entrada--- */
	/* Mtodo genrico de entrada de texto. */
	private static String entrada(){
		try {
			InputStreamReader isr = new InputStreamReader(System.in);
			BufferedReader br = new BufferedReader(isr);
			linea = br.readLine();
		} catch (IOException ioex){
			System.out.println("Error entrada(): "+ioex.getMessage());
			ioex.printStackTrace();
		}
		return linea;
	}

	/* ---Mtodo buscador--- */
	/* Compara las cabeceras de los mails del servidor con las especificadas por
	 * el usuario. Recupera los mails solicitados teniendo en cuenta los criterios
	 * establecidos por el usuario en lo referente a las cabeceras de los correos. */
	public static void buscador(){
		
		int i=0;
		String elementos[] = {""}, valores[] = {""}; // Inicializaciones necesarias
		String expresionLogica;
			
		// Establecimiento de la expresin lgica de bsqueda
		System.out.print("Expresin lgica de la bsqueda [And/Or/Not]: ");
		linea=entrada();
		expresionLogica = linea;

		do {		
			// Establecimiento del elemento de bsqueda
			System.out.println("----------LEYENDA DE ELEMENTOS----------");
			System.out.println("Body, From, Header, Message-ID");
			System.out.println("MessageNumber, ReceivedDate");
			System.out.println("Recipient, SentDate, Size, Subject");
			System.out.println("----------------------------------------");
			System.out.print("Elemento a buscar: ");
			elementos[i]=entrada();
			
			// Establecimiento del valor del elemento de bsqueda
			System.out.print("Valor del elemento "+elementos[i]+": ");
			valores[i]=entrada();
			
			System.out.print("Introducir otro elemento de bsqueda? [Y/N]: ");
			linea=entrada();
			
			if(linea.equalsIgnoreCase("Y")){
				i++;
			}
		} while(linea.equalsIgnoreCase("Y"));
		
		// Construimos el SearchTerm
		parser_elementos(elementos, valores, expresionLogica);		
	}
	
	/* ---Mtodo parser_elementos--- */
	/* Analiza las cadenas y crea una subclase SearchTerm apropiada para cada uno
	 * de ellos. Con al array de searchterms obtenidos, se crea la SearchTerm completa,
	 * que ser devuelta. */
	public static void parser_elementos(String elementos[], String valores[], String expresionLogica){
		
		int i=0;
		String nombreCabecera = null;
		SearchTerm arraySearchTerms[] = {new FromStringTerm(valores[i])}; // Inicializacin necesaria
		
		for(i=0; i<elementos.length; i++){
		
			if(elementos[i].equalsIgnoreCase("Body")){
				BodyTerm bodyTerm = new BodyTerm(valores[i]);
				arraySearchTerms[i] = bodyTerm;
			} else if(elementos[i].equalsIgnoreCase("From")){
				FromStringTerm fromStringTerm = new FromStringTerm(valores[i]);
				arraySearchTerms[i] = fromStringTerm;
			} else if(elementos[i].equalsIgnoreCase("Header")){
				HeaderTerm headerTerm = new HeaderTerm(nombreCabecera, valores[i]);
				arraySearchTerms[i] = headerTerm;
			} else if(elementos[i].equalsIgnoreCase("Message-ID")){
				MessageIDTerm messageIDTerm = new MessageIDTerm(valores[i]);
				arraySearchTerms[i] = messageIDTerm;
			} else if(elementos[i].equalsIgnoreCase("MessageNumber")){
				//MessageNumber messageNumber = new MessageNumberTerm((Integer) valores[i]);
				//arraySearchTerms[i] = messageNumberTerm;
			} else if(elementos[i].equalsIgnoreCase("ReceivedDate")){
				//ReceivedDateTerm receivedDateTerm = new ReceivedDateTerm(valores[i]);
				//arraySearchTerms[i] = receivedDateTerm;
			} else if(elementos[i].equalsIgnoreCase("Recipient")){
				RecipientStringTerm recipientStringTerm = new RecipientStringTerm(Message.RecipientType.TO ,valores[i]);
				arraySearchTerms[i] = recipientStringTerm;
			} else if(elementos[i].equalsIgnoreCase("SentDate")){
				//SendDateTerm sendDateTerm = new SentDateTerm(valores[i]);
				//arraySearchTerms[i] = sentDateTerm;
			} else if(elementos[i].equalsIgnoreCase("Size")){
				//SizeTerm sizeTerm = new SizeTerm(valores[i]);
				//arraySearchTerms[i] = sizeTerm;
			}else if(elementos[i].equalsIgnoreCase("Subject")){
				SubjectTerm subjectTerm = new SubjectTerm(valores[i]);
				arraySearchTerms[i] = subjectTerm;
			}
		}
		
		if(expresionLogica.equalsIgnoreCase("and")){
			buscador = new AndTerm(arraySearchTerms);
		} else if(expresionLogica.equalsIgnoreCase("or")){
			buscador = new OrTerm(arraySearchTerms);
		} else if(expresionLogica.equalsIgnoreCase("not")){
			//buscador = new NotTerm(arraySearchTerms); <-- no acepta un array de SearchTerms
		}
	}
}
