package base;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.ListIterator;

/******************************************************************************
 * 																			  *
 *  Copyright 2004 Jordi Oliveras & Marcos Valerio. 						  *
 * 																			  *
 *  This file is part of Ogre.												  *
 *																			  *
 *  Ogre is free software; you can redistribute it and/or modify			  *
 *  it under the terms of the GNU General Public License as published by	  *
 *  the Free Software Foundation; either version 2 of the License, or		  *
 *  (at your option) any later version.										  *
 *																			  *
 *  Ogre is distributed in the hope that it will be useful,					  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of			  *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			  *
 *  GNU General Public License for more details.							  *
 *                       													  *
 *  You should have received a copy of the GNU General Public License         *
 *  along with Ogre; if not, write to the Free Software                       *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 *																			  * 
 ******************************************************************************
 * 																			  *
 * Contacto - Clase que representa un contacto de la agenda.				  *
 * 																			  *
 ******************************************************************************/	

public final class Contacto implements Serializable{
	
	String nombre, direccion, email, fijo, movil, comentarios, ruta_foto;
	
	public Contacto() {
	}

/*	
	public String getComentarios() {
		return comentarios;
	}

	public String getDireccion() {
		return direccion;
	}

	public String getEmail() {
		return email;
	}

	public String getFijo() {
		return fijo;
	}

	public String getMovil() {
		return movil;
	}

	public String getNombre() {
		return nombre;
	}

	public String getRuta_foto() {
		return ruta_foto;
	}

	public void setComentarios(String string) {
		comentarios = string;
	}

	public void setDireccion(String string) {
		direccion = string;
	}

	public void setEmail(String string) {
		email = string;
	}

	public void setFijo(String string) {
		fijo = string;
	}

	public void setMovil(String string) {
		movil = string;
	}

	public void setNombre(String string) {
		nombre = string;
	}

	public void setRuta_foto(String string) {
		ruta_foto = string;
	}
*/	

	/* ---Mtodo aadir_contacto--- */
	/* Aade un contacto a la Agenda. */
	public static void aadir_contacto(ListRestorer agendaRest, ArrayList agendaMemoria, Contacto unContacto){
		
		// Backup de la agenda actual
		agendaRest.backup(agendaMemoria);
		
		// Adicin de unContacto a la lista
		agendaMemoria.add(unContacto);
		
		System.out.println("\nContacto aadido...\n");
	}
	
	/* ---Mtodo buscar_contacto--- */
	/* Busca un contacto dado en la Agenda. */
	public static void buscar_contacto(ArrayList agendaMemoria, String nombre){
		
		int found = 0;
		ListIterator iterator = agendaMemoria.listIterator();
		Contacto unContacto_aux = new Contacto();
		
		while(iterator.hasNext()){
			unContacto_aux = (Contacto) iterator.next();
			if(unContacto_aux.nombre.equals(nombre))
			{
				found++;
				if(found==1){
					System.out.println("\n.....Contacto/s encontrado.....");
					System.out.println(unContacto_aux.nombre+", "+unContacto_aux.direccion+", "+unContacto_aux.email+", "+unContacto_aux.fijo+", "+unContacto_aux.movil+", "+unContacto_aux.comentarios+", "+unContacto_aux.ruta_foto);
				} else {
					System.out.println(unContacto_aux.nombre+", "+unContacto_aux.direccion+", "+unContacto_aux.email+", "+unContacto_aux.fijo+", "+unContacto_aux.movil+", "+unContacto_aux.comentarios+", "+unContacto_aux.ruta_foto);
					System.out.println(".............................\n");
				}
			}
		}
		
		if(found==0){
			System.out.println("\nContacto no encontrado.\n");
		} else {
			System.out.println("\n"+found+" contacto/s encontrados.\n");
		}
	}

	/* ---Mtodo eliminar_contacto--- */
	/* Elimina contactos de la Agenda. */
	public static void eliminar_contacto(ListRestorer agendaRest, ArrayList agendaMemoria, String nombre) {
		
		int found = 0;
		ListIterator iterator = agendaMemoria.listIterator();
		Contacto unContacto_aux = new Contacto();
		
		// Backup de la agenda actual
		agendaRest.backup(agendaMemoria);
		
		while(iterator.hasNext()){
			unContacto_aux = (Contacto) iterator.next();
			if(unContacto_aux.nombre.equals(nombre)){
				found++;
				iterator.remove(); // si uso el metodo remove() de lista peta! normal, iterator no se lo espera!
				System.out.println("\nContacto eliminado.\n");		
			}
		}
		if(found==0){
			System.out.println("\nContacto no encontrado.\n");
		} else {
			System.out.println("\n"+found+" contacto/s eliminados.\n");
		}
	}
	
	/* ---Mtodo mostrar_contactos--- */
	/* Muestra los contactos de la Agenda. */
	public static void mostrar_contactos(ArrayList agendaMemoria){
		
		Iterator iterator = agendaMemoria.iterator();
		Contacto unContacto_aux = new Contacto();
		
		System.out.println("\n.....Lista de contactos.....");
		while(iterator.hasNext()){
			unContacto_aux = (Contacto) iterator.next();
			System.out.println(unContacto_aux.nombre+", "+unContacto_aux.direccion+", "+unContacto_aux.email+", "+unContacto_aux.fijo+", "+unContacto_aux.movil+", "+unContacto_aux.comentarios+", "+unContacto_aux.ruta_foto);
		}
		System.out.println("............................\n");
		/*for(int i=0;i<lista.size();i++){
			System.out.println(lista.get(i).toString());
		}*/
	}
}
