package base;

import gui.OgreProgressBar;
import javax.mail.Transport;
import javax.mail.internet.MimeMessage;
import javax.swing.JOptionPane;

/******************************************************************************
 * 																			  *
 *  Copyright 2004 Jordi Oliveras & Marcos Valerio.							  *
 * 																			  *
 *  This file is part of Ogre.												  *
 *																			  *
 *  Ogre is free software; you can redistribute it and/or modify			  *
 *  it under the terms of the GNU General Public License as published by	  *
 *  the Free Software Foundation; either version 2 of the License, or		  *
 *  (at your option) any later version.										  *
 *																			  *
 *  Ogre is distributed in the hope that it will be useful,					  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of			  *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			  *
 *  GNU General Public License for more details.							  *
 *                       													  *
 *  You should have received a copy of the GNU General Public License         *
 *  along with Ogre; if not, write to the Free Software                       *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 * 																		      *
 ******************************************************************************
 * 																		      *
 * EmisorMail - Clase encargada de la emisin del correo.					  *
 *																			  *
 ******************************************************************************/

public final class EmisorMail {

	static String linea;
	CuentaMail cuentaMail;
	public static boolean enviando = false;

	/* ---Constructor1: enviar_mensajes()--- */
	public EmisorMail(CuentaMail aCuentaMail, MimeMessage[] arrayMensajes){
		
		cuentaMail = aCuentaMail;
		int i;
		
		try {
			
			Transport transport = null;
			IniciadorSesion is = new IniciadorSesion(cuentaMail);
				
			if(MainOgre.verboso) System.out.println("Enviando "+arrayMensajes.length+" correos de la Cuenta "+cuentaMail.nombreCuenta);
				
			for(i=0; i<arrayMensajes.length; i++){
				
				if(enviando==true){
				
					OgreProgressBar.setActiva(MailProperties.textos.getString("progressbar_enviando")+(i+1)+"/"+arrayMensajes.length);
						
					// Guardado en disco (en outbox).
					GestorLocalMail.guardar_mail_local(cuentaMail, arrayMensajes[i], "outbox");
					
					// Envo.
					arrayMensajes[i].saveChanges();
					transport = IniciadorSesion.session.getTransport("smtp");
					transport.connect(cuentaMail.hostSmtp, cuentaMail.nombreUsuario , cuentaMail.contrasea);
					transport.sendMessage(arrayMensajes[i], arrayMensajes[i].getAllRecipients());
				} else {
					if(MainOgre.verboso) System.out.println("Salgo de enviar mail..."); // DEBUG
					break;
				}
			}
			if(transport == null) transport.close();
					
			//EmisorMail.enviando = false; //!	
			OgreProgressBar.setDesactiva(); // Fin progressbar.
			if(MainOgre.verboso) System.out.println("\nE-mail/s enviado/s!\n"); //DEBUG
			
		} catch(Exception e){
			OgreProgressBar.setDesactiva(); // Fin progressbar.
			JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_enviar_mensajes")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
			e.getMessage();
			e.printStackTrace();
		}
	}

	/* ---Constructor2: responder_mensajes()--- */
//	public EmisorMail(MailProperties mailProperties, CuentaMail cuentaMail, Message message){
//		try {
//			String contenidoLinea = null;
//			try {
//				// Crear el reply
//				MimeMessage reply = (MimeMessage) message.reply(false);
//				reply.setHeader("X-Mailer", mailProperties.xmailer);
//				reply.setSentDate(new Date());
//				reply.setFrom(new InternetAddress(cuentaMail.email));
//			
//				// Establecer un reply to en caso de necesitarlo:
//				//Address[] address = {(Address) new InternetAddress(replyto)};
//				//reply.setReplyTo(address);
//			
//				// Crear el contenido del reply
//				MimeMessage orig = (MimeMessage) message;
//				System.out.print("Respuesta: ");
//				linea = entrada();
//				StringBuffer buffer = new StringBuffer();
//				buffer.append(linea);
//				buffer.append("\r\n\r\n");
//				
//				if(orig.isMimeType("text/plain")){
//					String contenidoOrig = (String) orig.getContent();
//					StringReader contenidoReader = new StringReader(contenidoOrig);
//					BufferedReader br = new BufferedReader(contenidoReader);
//					while((contenidoLinea = br.readLine()) != null){
//						buffer.append("> ");
//						buffer.append(contenidoLinea);
//						buffer.append("\r\n");
//					}
//				}
//				
//				reply.setText(buffer.toString());
//				
//				guardar_mensaje(mailProperties, cuentaMail, reply);
//				
//				Transport.send(reply);
//				
//			} catch(MessagingException me){
//				System.out.println("Error responder_mensajes(): "+me.getMessage());
//				me.printStackTrace();
//			}		
//		} catch (Exception e){
//			JOptionPane.showMessageDialog(null, e.getMessage(), "Error en responder_mensajes()", JOptionPane.ERROR_MESSAGE);
//			//System.out.println("Error en responder_mensajes(): "+e.getMessage());
//			e.printStackTrace();
//		}
//	}

	/* ---Constructor3: reenviar_mensajes()--- */
//	public EmisorMail(MailProperties mailProperties, CuentaMail cuentaMail, Session session, Message message){
//		try {
//			// Crear el mensaje a reenviar
//			Message forward = new MimeMessage(session);
//			
//			// Rellenar la cabecera
//			forward.setHeader("X-Mailer", mailProperties.xmailer);
//			forward.setSentDate(new Date());
//			forward.setSubject("Fwd: "+message.getSubject());
//			forward.setFrom(new InternetAddress(cuentaMail.email));
//			forward.addRecipient(Message.RecipientType.TO, new InternetAddress(cuentaMail.email));
//			
//			// Crear nuestra nueva parte del mensaje
//			BodyPart messageBodyPart = new MimeBodyPart();
//			messageBodyPart.setText("Mensaje original: \n\n");
//			
//			// Crear una multi-part para combinar las partes
//			Multipart multipart = new MimeMultipart();
//			multipart.addBodyPart(messageBodyPart);
//			
//			// Crear y copiar la parte del contenido forwarded
//			messageBodyPart = new MimeBodyPart();
//			messageBodyPart.setDataHandler(message.getDataHandler());
//			
//			// Aadir la parte al multi-part
//			multipart.addBodyPart(messageBodyPart);
//			
//			// Asociar el multi-part con el mensaje
//			forward.setContent(multipart);
//			
//			// Guardar mensaje
//			guardar_mensaje(mailProperties, cuentaMail, forward);
//			
//			// Enviar el mensaje
//			Transport.send(forward);
//		
//		} catch(Exception e){
//			JOptionPane.showMessageDialog(null, e.getMessage(), "Error en reenviar_mensajes()", JOptionPane.ERROR_MESSAGE);
//			//System.out.println("Error en reenviar_mensajes(): "+e.getMessage());
//			e.printStackTrace();
//		}
//	}
	
}
