package base;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import javax.mail.Message;
import javax.mail.MessagingException;

/******************************************************************************
 * 																			  *
 *  Copyright 2004 Jordi Oliveras & Marcos Valerio. 						  *
 * 																			  *
 *  This file is part of Ogre.												  *
 *																			  *
 *  Ogre is free software; you can redistribute it and/or modify			  *
 *  it under the terms of the GNU General Public License as published by	  *
 *  the Free Software Foundation; either version 2 of the License, or		  *
 *  (at your option) any later version.										  *
 *																			  *
 *  Ogre is distributed in the hope that it will be useful,					  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of			  *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			  *
 *  GNU General Public License for more details.							  *
 *                       													  *
 *  You should have received a copy of the GNU General Public License         *
 *  along with Ogre; if not, write to the Free Software                       *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 * 																			  *
 ******************************************************************************
 *     																		  *
 * GestorLocalMail - Clase que engloba algunas operaciones que se pueden      *
 * llevar a cabo sobre el correo almacenado localmente.						  *
 * 																			  *
 ******************************************************************************/

public final class GestorLocalMail {
	
	/* ---Mtodo guardar_mail_local---*/
	/* Esto ya lo hacen tanto EmisorMail como ReceptorMail, si bien estara mejor estructurado
	 * ponerlo en esta clase (y quitarlo de las otras). */
	public static void guardar_mail_local(CuentaMail cuentaMail, Message message, String nodo) throws IOException, MessagingException{
		
		String filename = null;
			
		String filepath = MailProperties.path_ogre+cuentaMail.nombreCuenta+"/"+nodo+"/";
		
		if(nodo.equalsIgnoreCase("outbox"))
			filename = "OgreMail_sent_file";
		else if(nodo.equals("inbox"))
			filename = "OgreMail_received_file";
			
		File file = new File(filepath+filename);
		for(int i=0; file.exists(); i++)
			file = new File(filepath+filename+i);
			
		FileOutputStream receivedFile = new FileOutputStream(file);
		BufferedOutputStream bos = new BufferedOutputStream(receivedFile);
			
		message.writeTo(bos);
		bos.flush();
		bos.close();
		receivedFile.close();
	}
	
	/* ---Metodo recuperar_mail_local--- */
	/* Obtiene una lista de ficheros que representan los e-mails locales existentes
	 * en un determinado directorio, y la devuelve. */
	public static String[] recuperar_mail_local(CuentaMail cuentaMail, String directorio){
		
		String mensajes[] = null;
		
		if(MainOgre.verboso) System.out.println(MailProperties.path_ogre+cuentaMail.nombreCuenta+"/"+directorio+"/"); // DEBUG
		File file = new File(MailProperties.path_ogre+cuentaMail.nombreCuenta+"/"+directorio+"/");
		mensajes = file.list();
		
		return mensajes;
	}

}
