package base;

import java.util.Properties;
import javax.mail.Authenticator;
import javax.mail.Session;

/******************************************************************************
 * 																			  *
 *  Copyright 2004 Jordi Oliveras & Marcos Valerio. 						  *
 * 																			  *
 *  This file is part of Ogre.												  *
 *																			  *
 *  Ogre is free software; you can redistribute it and/or modify			  *
 *  it under the terms of the GNU General Public License as published by	  *
 *  the Free Software Foundation; either version 2 of the License, or		  *
 *  (at your option) any later version.										  *
 *																			  *
 *  Ogre is distributed in the hope that it will be useful,					  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of			  *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			  *
 *  GNU General Public License for more details.							  *
 *                       													  *
 *  You should have received a copy of the GNU General Public License         *
 *  along with Ogre; if not, write to the Free Software                       *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 *																			  *
 ******************************************************************************
 * 																			  *
 * IniciadorSesion - Clase que prepara la aplicacin para iniciar una sesin  *
 * con el servidor de correo, ya sea para enviar como para recibir correo.    *    
 * 																			  *          
 ******************************************************************************/

public final class IniciadorSesion {

	CuentaMail cuentaMail;
	public static Session session;

	/* Constructor */
	public IniciadorSesion(CuentaMail aCuentaMail){
		cuentaMail = aCuentaMail;
		
		// Coger las system properties.
		Properties props = establecer_properties();
		
		// Establecer el Authenticator.
		Authenticator auth = new MyAuthenticatorMail(cuentaMail);
		
		// Creamos una sesion.
		session = Session.getDefaultInstance(props, auth);
	}
	
	/* ---Mtodo establecer_properties--- */
	private Properties establecer_properties(){
		
		Properties props;
		
		props = System.getProperties(); // Coge el Properties actual del sistema.
		props.put("mail.smtp.host", cuentaMail.hostSmtp);
		
		return props;
	}
}
