package base;

import java.util.Comparator;

/******************************************************************************
 * 																			  *
 *  Copyright 2004 Jordi Oliveras & Marcos Valerio. 						  *
 * 																			  *
 *  This file is part of Ogre.												  *
 *																			  *
 *  Ogre is free software; you can redistribute it and/or modify			  *
 *  it under the terms of the GNU General Public License as published by	  *
 *  the Free Software Foundation; either version 2 of the License, or		  *
 *  (at your option) any later version.										  *
 *																			  *
 *  Ogre is distributed in the hope that it will be useful,					  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of			  *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			  *
 *  GNU General Public License for more details.							  *
 *                       													  *
 *  You should have received a copy of the GNU General Public License         *
 *  along with Ogre; if not, write to the Free Software                       *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 * 																			  *
 ******************************************************************************
 * 																			  *
 * ListComparator - Clase de tipo helper para la clase Contacto. Establece un *
 * comparador. Se preve que ser eliminada y transformada a mtodo de la     *
 * propia clase Contacto. 												      *
 * 																			  *
 ******************************************************************************/

public final class ListComparator implements Comparator {
	
	/* ---Mtodo compare--- */
	/* Compara 2 objetos del tipo Contacto. */
	public int compare(Object o1, Object o2){
		
		Contacto unContacto = (Contacto) o1;
		Contacto otroContacto = (Contacto) o2;
		
		return unContacto.nombre.compareTo(otroContacto.nombre);
	}

	/* ---Mtodo equals--- */
	public boolean equals(Object o) {
   		return this == o;
   }
	
}
