package base;

import java.util.ArrayList;

/******************************************************************************
 * 																			  *
 *  Copyright 2004 Jordi Oliveras & Marcos Valerio. 						  *
 * 																			  *
 *  This file is part of Ogre.												  *
 *																			  *
 *  Ogre is free software; you can redistribute it and/or modify			  *
 *  it under the terms of the GNU General Public License as published by	  *
 *  the Free Software Foundation; either version 2 of the License, or		  *
 *  (at your option) any later version.										  *
 *																			  *
 *  Ogre is distributed in the hope that it will be useful,					  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of			  *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			  *
 *  GNU General Public License for more details.							  *
 *                       													  *
 *  You should have received a copy of the GNU General Public License         *
 *  along with Ogre; if not, write to the Free Software                       *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 * 																			  *
 ******************************************************************************
 * 																		      *
 * ListRestorer - Clase que ofrece un mtodo de restaurar la agenda de        *
 * contactos hasta un cierto nmero de pasos previos a la modificacin de la  *
 * Agenda. Es posible que con esta clase se haya reinventado la rueda, pues   *
 * parecen existir clases de la API de Java estndard que hacen este trabajo, *
 * generalizando ms en concepto de lo que se puede hacer/deshacer, y         *
 * ofreciendo un mejor soporte para toda este serie de operaciones. Es por    *
 * ello que puede que esta clase se suprima en favor de las existentes        *
 * (cuando se aprenda a usarlas).											  *
 * 																			  *
 ******************************************************************************/

public final class ListRestorer {
		
	int numelems = 0, ultimoelem = 0;
	ArrayList copyOfList = new ArrayList();
	ArrayList[] arrayDeListas = new ArrayList[10];
	
	public ListRestorer() {
	}
	
	/* ---Mtodo backup--- */
	/* Hace una copia de seguridad de las 10 ultimas modificaciones en la Agenda. */
	public void backup(ArrayList agenda){
		
		if(ultimoelem<10){
			copyOfList = new ArrayList(agenda); // copyOfList es una copia de lista
			arrayDeListas[ultimoelem] = copyOfList;
			ultimoelem++;
		} else {
			ultimoelem = 0;
			copyOfList = new ArrayList(agenda); // copyOfList es una copia de lista
			arrayDeListas[ultimoelem] = copyOfList;
			ultimoelem++;
		}
		
		if(numelems<10)
			numelems++;
		
		System.out.println("He hecho el backup!");
		System.out.println("ultimoelem: "+ultimoelem+"; numelems: "+numelems+"\n");
	}
	
	/* ---Mtodo restore--- */
	/* Restaura un estado anterior de la Agenda. */
	public ArrayList restore(ArrayList agenda){
		
		if(numelems>0){
			if(ultimoelem>0){
				numelems--;
				ultimoelem--;	
				agenda = arrayDeListas[ultimoelem];
			} else {
				numelems--;
				ultimoelem = 9;
				agenda = arrayDeListas[ultimoelem];
			}
			//numelems--;
			//ultimoelem--;
			
			System.out.println("He hecho el restore.");
			System.out.println("ultimoelem: "+ultimoelem+"; numelems: "+numelems+"\n");
		}
		else
			System.out.println("No se ha hecho el restore; no hay ms acciones que deshacer o el lmite de 10 superado.");
		
		return agenda;
	}
	
}
