package base;

import javax.mail.Authenticator;
import javax.mail.PasswordAuthentication;

/******************************************************************************
 * 																			  *
 *  Copyright 2004 Jordi Oliveras & Marcos Valerio. 						  *
 * 																			  *
 *  This file is part of Ogre.												  *
 *																			  *
 *  Ogre is free software; you can redistribute it and/or modify			  *
 *  it under the terms of the GNU General Public License as published by	  *
 *  the Free Software Foundation; either version 2 of the License, or		  *
 *  (at your option) any later version.										  *
 *																			  *
 *  Ogre is distributed in the hope that it will be useful,					  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of			  *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			  *
 *  GNU General Public License for more details.							  *
 *                       													  *
 *  You should have received a copy of the GNU General Public License         *
 *  along with Ogre; if not, write to the Free Software                       *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 * 																			  *
 ******************************************************************************
 * 																			  *
 * MyAuthenticatorMail - Clase encargada de construir un elemento que ayude a *
 * autenticar al usuario siempre que se necesite para enviar/recibir correo.  *
 * 																			  *
 ******************************************************************************/

public final class MyAuthenticatorMail extends Authenticator {
	
    public static String username, password;
	
	/* ---Constructor--- */
	/* Provee una forma de autenticarse ante el servidor de correo. */
	public MyAuthenticatorMail(CuentaMail cuentaMail) {
		super(); // Debe hacerse antes de nada (al ppio. del constructor), sino no va!
		username = cuentaMail.nombreUsuario;
		password = cuentaMail.contrasea;
	}
	
	/* ---Mtodo getPasswordAuthentication--- */
	/* Provee otra forma de autenticarse ante el servidor de correo. */
	public PasswordAuthentication getPasswordAuthentication() {
     
		return new PasswordAuthentication(username, password);
	}
}
