package base;

import gui.OgreProgressBar;
import java.io.IOException;
import java.io.InputStream;
import javax.mail.Flags;
import javax.mail.BodyPart;
import javax.mail.Folder;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Multipart;
import javax.mail.Store;
import javax.swing.JOptionPane;

/******************************************************************************
 * 																			  *
 *  Copyright 2004 Jordi Oliveras & Marcos Valerio. 						  *
 * 																			  *
 *  This file is part of Ogre.												  *
 *																			  *
 *  Ogre is free software; you can redistribute it and/or modify			  *
 *  it under the terms of the GNU General Public License as published by	  *
 *  the Free Software Foundation; either version 2 of the License, or		  *
 *  (at your option) any later version.										  *
 *																			  *
 *  Ogre is distributed in the hope that it will be useful,					  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of			  *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			  *
 *  GNU General Public License for more details.							  *
 *                       													  *
 *  You should have received a copy of the GNU General Public License         *
 *  along with Ogre; if not, write to the Free Software                       *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 * 																			  *
 ******************************************************************************
 *																			  *
 * ReceptorMail - Clase encargada de la recepcin del correo.				  *
 *																			  *
 ******************************************************************************/

public final class ReceptorMail {

	public int numMensajes;
	static String linea;
	public static boolean recibiendo = false;

	/* ---Constructor--- */
	public ReceptorMail(CuentaMail cuentaMail){
		
		int i, n;
		Message message[] = null;
		
		try {
			
			// Crea un Properties, Authenticator y una Session.			
			IniciadorSesion is = new IniciadorSesion(cuentaMail);
			// Queremos debug? IniciadorSesion.session.setDebug(true);
			
			// Obtenemos el store.
			Store store = IniciadorSesion.session.getStore("pop3");
			
			// Conectamos con el store.
			store.connect(cuentaMail.hostPop, MyAuthenticatorMail.username, MyAuthenticatorMail.password);
			
			// Folder para leer los mensajes que hay en el interior.
			Folder folder = store.getDefaultFolder(); // Para cojer la root folder.
			if(folder == null) throw new Exception("No hay folder por defecto!\n");
			folder = store.getFolder("INBOX"); // Para cojer la folder INBOX.
			if(folder == null) throw new Exception("No existe el folder INBOX!\n");		
			folder.open(Folder.READ_WRITE); // Apertura modo R/W para poder borrar mensajes.
			
			numMensajes = folder.getMessageCount();
			if(MainOgre.verboso) System.out.println("N Total de Mensajes: "+numMensajes+"."); // DEBUG
			
			// --> System.out.print("Descarga (1)completa o (2)con criterios de seleccin?: ");
			// --> linea=entrada();
			linea = "1";
			
			if(linea.equalsIgnoreCase("1")){
				message = folder.getMessages();
			} else if(linea.equalsIgnoreCase("2")){
				//
				// AQUI IRIA BUSCADORMAIL.
				BuscadorMail.buscador();
				message = folder.search(BuscadorMail.buscador);
				//	
			} else {
				if(MainOgre.verboso) System.out.println("Opcin desconocida! Abortando..."); // DEBUG
				System.exit(0);
			}
			
			for(i=0, n=message.length;i<n;i++){
					
				if(recibiendo==true){		
			
					OgreProgressBar.setActiva(MailProperties.textos.getString("progressbar_recibiendo")+(i+1)+"/"+n);
//						
//					Object obj = message[i].getContent();
//					if(obj instanceof String){
//						if(MainOgre.verboso){
//							System.out.println("*String message*"); // DEBUG
//							System.out.println((String) obj); // DEBUG
//						}		
//					}
//					else if(obj instanceof InputStream){
//						if(MainOgre.verboso){
//							System.out.println("*InputStream message*"); // DEBUG
//							System.out.println("Fichero "+message[i].getFileName()+" guardado!"); // DEBUG
//						}
//					}
//					else if(obj instanceof Multipart){
//						gestion_multipart(obj);
//					}
//					else
//						if(MainOgre.verboso) System.out.println("No se qu tipo de objeto casa con este mensaje!"); // DEBUG
						
					// Guardar localmente el mensaje.
					GestorLocalMail.guardar_mail_local(cuentaMail, message[i], "inbox");	
							
					if(MailProperties.jck1)
						borrar_mensajes_remotos(message[i]);
					
				} else {
					if(MainOgre.verboso) System.out.println("Salgo de recibir mail..."); // DEBUG
					break;
				}

			}
			
			if(n == message.length)
				if(MainOgre.verboso) System.out.println("\nNo hay ms mensajes.\n");
			else if(i == 0)
				if(MainOgre.verboso) System.out.println("\nNo hay ningn mensaje.\n");
		
			// Cerramos la conexin.
			folder.close(true); // Pasamos el booleano true para purgar los mensajes borrados.
			store.close();
			
		} catch (Exception e){
			OgreProgressBar.setDesactiva(); // Fin progressbar.
			JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_recibir_mensajes")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
			e.getMessage();
			e.printStackTrace();
		}	
	}

	/* ---Mtodo gestion_multipart--- */
	/* Gestiona las diferentes partes de un mensaje multipart. */
	private static void gestion_multipart(Object obj) throws IOException, MessagingException{

		if(MainOgre.verboso) System.out.println("*Multipart message/part*");
		Multipart multipart = (Multipart) obj;
		int partes = multipart.getCount();
		if(MainOgre.verboso) System.out.println("Tiene "+partes+" partes.");
							
		for(int j=0; j<partes; j++){
			BodyPart bodypart = multipart.getBodyPart(j);
			String tipoMime = bodypart.getContentType();
			if(MainOgre.verboso) System.out.println("Parte "+j+": "+tipoMime);
			Object obj2 = bodypart.getContent();
							
			if(obj2 instanceof String){
				if(MainOgre.verboso){
					System.out.println("*String part*"); // DEBUG
					System.out.println((String) obj2); // DEBUG
				}		
			}
			else if(obj2 instanceof InputStream){
				if(MainOgre.verboso){
					System.out.println("*InputStream part*"); // DEBUG
					System.out.println("Fichero "+bodypart.getFileName()+" guardado!"); // DEBUG
				}
			}
			else if(obj2 instanceof Multipart){
				gestion_multipart(obj2);
			}
			else
				if(MainOgre.verboso) System.out.println("No se qu tipo de objeto casa con esta parte del mensaje!"); // DEBUG
		}
	}

	/* ---Mtodo borrar_mensajes_remotos--- */
	/* Borra los mensajes seleccionados del servidor de correo. */
	public static void borrar_mensajes_remotos(Message message) throws MessagingException{
		message.setFlag(Flags.Flag.DELETED, true);
	}
}
