package gui;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Toolkit;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Timer;
import java.util.TimerTask;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.UIManager;
import base.MailProperties;
import base.MainOgre;

/******************************************************************************
 * 																			  *
 *  Copyright 2004 Jordi Oliveras & Marcos Valerio.							  *
 * 																			  *
 *  This file is part of Ogre.												  *
 *																			  *
 *  Ogre is free software; you can redistribute it and/or modify			  *
 *  it under the terms of the GNU General Public License as published by	  *
 *  the Free Software Foundation; either version 2 of the License, or		  *
 *  (at your option) any later version.										  *
 *																			  *
 *  Ogre is distributed in the hope that it will be useful,					  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of			  *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			  *
 *  GNU General Public License for more details.							  *
 *                       													  *
 *  You should have received a copy of the GNU General Public License         *
 *  along with Ogre; if not, write to the Free Software                       *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 * 																			  *
 ******************************************************************************
 * 																			  *
 * OgreAbout - Clase que representa un dilogo que muestra determinada        *
 * informacin al usuario, relativa a los autores, a la licencia usada por el *
 * programa, al sistema del usuario y a la propia aplicacin.				  *
 * 																			  *
 ******************************************************************************/
 
public final class OgreAbout extends JFrame {
	
	JScrollPane jsp;
	int scroll = -35;
	float red = (float)1.0, green = (float)1.0, blue = (float)1.0;
	Timer timer;
	
	OgreAbout() throws IOException{
		
		super(MailProperties.textos.getString("titulo_about_ventana"));
		super.setResizable(false);
		
		// Gestion L&F (multi-arquitectura).
		try {
			UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
		} catch(Exception e){
			JOptionPane.showMessageDialog(null, e.getMessage(), MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
			e.getMessage();
			e.printStackTrace();
		}
		
		/* 1 - Pestaa 'Crditos' */
		// Sobreescritura del mtodo paint() del JPanel.
		JPanel panel = new JPanel(){
			
			public void paint(Graphics g){
				g.setFont(new Font("SansSerif", Font.CENTER_BASELINE, 12));
				g.setColor(new Color(red, green, blue));
				g.drawString(MailProperties.textos.getString("programadoresactivos_about"), 40, scroll-60);
				g.setFont(new Font("SansSerif", Font.BOLD, 16));
				g.drawString(" Jordi Oliveras Palacios", 30, scroll-30);
				
				g.setFont(new Font("SansSerif", Font.CENTER_BASELINE, 12));
				g.drawString(MailProperties.textos.getString("otrosprogramadores_about"), 30, scroll);
				g.setFont(new Font("SansSerif", Font.BOLD, 16));
				g.drawString(" Marcos Valerio Cardenas", 30, scroll+30);
				
				g.setFont(new Font("SansSerif", Font.CENTER_BASELINE, 12));
				g.drawString(MailProperties.textos.getString("traductores_about"), 340, scroll-60);
				g.setFont(new Font("SansSerif", Font.BOLD, 16));
				g.drawString("  [Max]", 350, scroll-30);
				g.drawString("Sr_Dedo", 350, scroll-10);
				g.drawString("Jordi Oliveras Palacios", 300, scroll+10);
			}
		};
		
		panel.setBorder(BorderFactory.createRaisedBevelBorder());
		jsp = new JScrollPane(panel);
		jsp.setPreferredSize(new Dimension(500,150));
		jsp.setMaximumSize(new Dimension(500,150));
		
		JTabbedPane tabbedPane = new JTabbedPane();
		tabbedPane.addTab(MailProperties.textos.getString("pestaa_about_creditos"), (Component) jsp);
		tabbedPane.setSelectedIndex(0);
		
		/* 2 - Pestaa 'Licencia' */
		final JTextArea jta = new JTextArea();
		jta.setLineWrap(true);
		
		Runnable r = new Runnable(){
			public void run(){
				try { 
					// Introducir el texto de la licencia gpl.
					InputStreamReader isr = new InputStreamReader(getClass().getResourceAsStream("/ayuda/gpl.txt"));
					BufferedReader br = new BufferedReader(isr);
					
					// Lectura linea a linea.
					String S, S2 = new String();
					while((S = br.readLine()) != null){
						S2 += S + "\n";
					}				
					br.close();
					isr.close();
					jta.setText(S2);
					jta.setCaretPosition(0);
					jta.setEditable(false);
				} catch(Exception e){
					JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_mostrar_licencia")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
					e.getMessage();
					e.printStackTrace();
				}
			} 
		};
		Thread t = new Thread(r);
		t.start();
		
		JScrollPane jp2 = new JScrollPane(jta);
		jp2.setPreferredSize(new Dimension(500,150));
		jp2.setMaximumSize(new Dimension(500,150));
		tabbedPane.addTab(MailProperties.textos.getString("pestaa_about_licencia"), (Component) jp2);
		
		/* 3 - Pestaa 'Acerca de' */
		JPanel panel2 = new JPanel();
		JLabel label = new JLabel(new ImageIcon(getClass().getResource("/images/OgreMini.png")));
		label.setPreferredSize(new Dimension(200, 141));
		label.setToolTipText("Groaaar!");
		panel2.add(label);
		String cadena = "<html>" +
						"<B><font size=18>"+MailProperties.xmailer+"</font></B><br><br>" +
						MailProperties.textos.getString("nota_soft")+
						MailProperties.textos.getString("nota_arch")+System.getProperty("os.arch")+"<br>"+
						MailProperties.textos.getString("nota_so")+System.getProperty("os.name")+"<br>"+
						MailProperties.textos.getString("nota_version")+System.getProperty("os.version")+"<br>"+
						"</html>";
		JLabel label2 = new JLabel(cadena);
		panel2.add(label2);
		panel2.setBorder(BorderFactory.createRaisedBevelBorder());
		tabbedPane.addTab(MailProperties.textos.getString("pestaa_about_acercade"), (Component) panel2);
		
		getContentPane().add(tabbedPane);
		
		// Posicionamiento ventana.
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		Dimension frameSize = getPreferredSize();
		setLocation(screenSize.width/2 - (frameSize.width/2), screenSize.height/2 - (frameSize.height/2));
		
		// Listener para el cerrado de ventana.
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				// Liberamos la ventana.
				timer.cancel();
				setVisible(false);
				dispose();
			}
		});
		
		pack();
		setVisible(true);
		
		timer = new Timer();
		timer.schedule(new TaskCreditos(timer), 0, 50);
	}
	
	/* TaskCreditos- Representa una clase que define la tarea a realizar por
	 * el Timer en un hilo de ejecucin separado. */
	private class TaskCreditos extends TimerTask {
		
		Timer timer;
		
		TaskCreditos(Timer unTimer){
			timer = unTimer;
		}
		
		public void run(){
			if(scroll<=90)
				scroll++;
			
			if(red>0.025)
				red -= (float)0.025;
			else if(green>0.025)
				green -= (float)0.025;
			else if(blue>0.025)
				blue -= (float)0.025;
			else {
				red = (float)1.0;
				green = (float)1.0;
				blue = (float)1.0;
			}
			
			jsp.invalidate();
			jsp.repaint();
		}
	}

}
