package gui;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.IOException;
import java.util.Timer;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.UIManager;
import base.MailProperties;
import base.MainOgre;

/******************************************************************************
 * 																			  *
 *  Copyright 2004 Jordi Oliveras.											  *
 * 																			  *
 *  This file is part of Ogre.												  *
 *																			  *
 *  Ogre is free software; you can redistribute it and/or modify			  *
 *  it under the terms of the GNU General Public License as published by	  *
 *  the Free Software Foundation; either version 2 of the License, or		  *
 *  (at your option) any later version.										  *
 *																			  *
 *  Ogre is distributed in the hope that it will be useful,					  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of			  *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			  *
 *  GNU General Public License for more details.							  *
 *                       													  *
 *  You should have received a copy of the GNU General Public License         *
 *  along with Ogre; if not, write to the Free Software                       *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 * 																			  *
 ****************************************************************************** 
 * 																			  *
 * OgreConfiguracin - Clase que representa el dilogo que asiste al usuario  *
 * para la configuracin de algunos aspectos de la aplicacin.                *
 * 																			  *
 ******************************************************************************/

public final class OgreConfiguracion extends JFrame {

	Container contentPane = getContentPane();
	JCheckBox jck1, jck2, jck3, jck4, jck5, jck6;
	JComboBox jcb1, jcb2;
	static long miliseconds = 0;
	boolean terminado = false, guardado = false;

	public OgreConfiguracion() throws IOException{
		
		// Gestion L&F (multi-arquitectura).
		try {
			UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
		} catch(Exception e){
			JOptionPane.showMessageDialog(null, e.getMessage()+MainOgre.mensajeErrorEstandard, "Error", JOptionPane.ERROR_MESSAGE);
			e.getMessage();
			e.printStackTrace();
		}
		
		super.setTitle(MailProperties.textos.getString("titulo_preferencias_ventana"));
		super.setResizable(false);
		
		// Creamos un tabbedPane.
		JTabbedPane tabbedPane = new JTabbedPane();
		
		// Panel de la PRIMERA PESTAA de configuracin (General).
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
				
		MailProperties.leer_properties(); // Importante; restaura las ltimas preferencias.
				
		jck1 = new JCheckBox(MailProperties.textos.getString("checkbox_borrar_mensajes_servidor"));
		jck1.setToolTipText(MailProperties.textos.getString("tooltip_borrar_mensajes_servidor"));
		if(MailProperties.jck1) jck1.setSelected(true);
		panel.add(jck1);
		
		jck2 = new JCheckBox(MailProperties.textos.getString("checkbox_cargar_html"));
		jck2.setToolTipText(MailProperties.textos.getString("tooltip_cargar_html"));
		if(MailProperties.jck2) jck2.setSelected(true);
		panel.add(jck2);
		
		jck3 = new JCheckBox(MailProperties.textos.getString("checkbox_borrar_cuenta"));
		jck3.setToolTipText(MailProperties.textos.getString("tooltip_borrar_cuenta"));
		if(MailProperties.jck3) jck3.setSelected(true);
		panel.add(jck3);
		
		// Lo aadimos a un JScrollPane.
		//JScrollPane jscrollpane1 = new JScrollPane(panel);
		//jscrollpane1.setPreferredSize(new Dimension(350,140)); // Tamao default.
		
		// Aadimos esta primera pestaa al tabbedPane.
		tabbedPane.addTab(MailProperties.textos.getString("pestaa_preferencias_general"), (Component) panel);
		tabbedPane.setSelectedIndex(0);
		
		
		// Panel de la SEGUNDA PESTAA de configuracin (Enviar/Recibir).
		panel = new JPanel();
		panel.setLayout(new GridBagLayout());
		jck4 = new JCheckBox(MailProperties.textos.getString("checkbox_enviarrecibir_todo"));
		jck4.setToolTipText(MailProperties.textos.getString("tooltip_enviarrecibir_todo"));
		if(MailProperties.jck4) jck4.setSelected(true);
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 0;
		gridBagConstraints.gridwidth = GridBagConstraints.REMAINDER;
		gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints.anchor = GridBagConstraints.NORTHWEST;
		panel.add(jck4, gridBagConstraints);
		
		jck5 = new JCheckBox(MailProperties.textos.getString("checkbox_autoenviarrecibir"));
		jck5.setToolTipText(MailProperties.textos.getString("tooltip_autoenviarrecibir"));
		CheckBoxListener myCheckBoxListener = new CheckBoxListener();
		jck5.addItemListener(myCheckBoxListener);
		if(MailProperties.jck5) jck5.setSelected(true);
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.gridwidth = GridBagConstraints.RELATIVE;
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		panel.add(jck5, gridBagConstraints);
		
		String[] tiempo = {MailProperties.textos.getString("combobox_5mins"),
						   MailProperties.textos.getString("combobox_10mins"),
						   MailProperties.textos.getString("combobox_15mins"),
						   MailProperties.textos.getString("combobox_30mins"), 
						   MailProperties.textos.getString("combobox_1h"),
						   MailProperties.textos.getString("combobox_2h"),
						   MailProperties.textos.getString("combobox_3h"),
						   MailProperties.textos.getString("combobox_6h"),
						   MailProperties.textos.getString("combobox_12h"),
						   MailProperties.textos.getString("combobox_1dia")};
		jcb1 = new JComboBox(tiempo);
		if(!MailProperties.jck5)
			jcb1.setEnabled(false);
		else
			jcb1.setSelectedItem(MailProperties.jcb1);
		
		gridBagConstraints.gridx = 1;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.gridwidth = GridBagConstraints.REMAINDER;
		gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
		panel.add(jcb1, gridBagConstraints);
		
		// Lo aadimos a un JScrollPane.
		//JScrollPane jscrollpane2 = new JScrollPane(panel);
		//jscrollpane2.setPreferredSize(new Dimension(350,140)); // Tamao default.
		
		// Aadimos esta segunda pestaa al tabbedPane.
		tabbedPane.addTab(MailProperties.textos.getString("pestaa_preferencias_enviarrecibir"), (Component) panel);
		
		
		// Panel de la TERCERA PESTAA de configuracin (Lenguaje).
		panel = new JPanel();
		panel.setLayout(new GridBagLayout());
		jck6 = new JCheckBox(MailProperties.textos.getString("checkbox_lenguaje"));
		jck6.addItemListener(myCheckBoxListener);
		jck6.setToolTipText(MailProperties.textos.getString("tooltip_lenguaje"));
		if(MailProperties.jck6) jck6.setSelected(true);
		GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
		gridBagConstraints2.gridx = 0;
		gridBagConstraints2.gridy = 0;
		gridBagConstraints2.gridwidth = GridBagConstraints.RELATIVE;
		//gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		panel.add(jck6, gridBagConstraints2);
		
		String[] lenguajes = {MailProperties.textos.getString("combobox_castellano"),
							  MailProperties.textos.getString("combobox_gallego"),
							  MailProperties.textos.getString("combobox_catalan"),
							  MailProperties.textos.getString("combobox_ingles")};
		jcb2 = new JComboBox(lenguajes);
		if(!MailProperties.jck6)
			jcb2.setEnabled(false);
		else
			jcb2.setSelectedItem(MailProperties.jcb2);
		
		gridBagConstraints2.gridx = 1;
		gridBagConstraints2.gridy = 0;
		gridBagConstraints2.gridwidth = GridBagConstraints.REMAINDER;
		gridBagConstraints2.fill = GridBagConstraints.HORIZONTAL;
		panel.add(jcb2, gridBagConstraints2);
		
		JLabel nota = new JLabel(MailProperties.textos.getString("etiqueta_advertencia"));
		gridBagConstraints2.gridx = 0;
		gridBagConstraints2.gridy = 1;
		gridBagConstraints2.gridwidth = java.awt.GridBagConstraints.REMAINDER;
		gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
		panel.add(nota, gridBagConstraints2);
		
		// Aadimos esta tercera pestaa al tabbedPane.
		tabbedPane.addTab(MailProperties.textos.getString("pestaa_preferencias_lenguaje"), (Component) panel);
				
		
		// Botones inferiores (Guardar/Cerrar).
		JButton guardar = new JButton(MailProperties.textos.getString("boton_preferencias_guardar"));
		guardar.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				// Accin de guardado de las opciones (en Ogre.properties?).
				try {
					guardarOpciones();
					guardado = true;
					terminado = true;
				} catch (IOException e1) {
					JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_seleccionar_cuenta")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
					e1.getMessage();
					e1.printStackTrace();
				}
			}
		}
		);
		
		JButton cerrar = new JButton(MailProperties.textos.getString("boton_preferencias_cerrar"));
		cerrar.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				// Liberamos la ventana.
				terminado = true;
				setVisible(false);
				dispose();
			}
		}
		);
		
		// Panel para los botones inferiores (Guardar y Cerrar).
		panel = new JPanel();
		panel.add(cerrar);
		panel.add(guardar);
		
		// Aadimos el tabbedPane al panel de contenido.
		contentPane.add(tabbedPane, BorderLayout.CENTER);
		contentPane.add(panel, BorderLayout.SOUTH);
		
		/* 
		 * Desde que NO usamos un contenedor de alto nivel para hacer de content pane
		 * (como un JPanel), si queremos poder tocar los bordes, debemos hacer un cast
		 * (a un JComponent) de lo que nos devuelve el frame al pedirle su content pane.
		 * De esta forma ya podemos operar con los bordes.
		 * */
		JComponent contentPaneCast = (JComponent) getContentPane();
		contentPaneCast.setBorder(BorderFactory.createEmptyBorder(
		5, //top
		5, //left
		0, //bottom
		5) //right
		);
		
		// Posicionamiento ventana.
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		Dimension frameSize = getPreferredSize();
		setLocation(screenSize.width/2 - (frameSize.width/2), screenSize.height/2 - (frameSize.height/2));

		// Listener para el cerrado de ventana.
		addWindowListener(new WindowAdapter(){
			public void windowClosing(WindowEvent e){
				// Liberamos la ventana.
				terminado = true;
				setVisible(false);
				dispose();
			}
		});
		
		pack();
		setVisible(true);
		
	}
	
	/////////////
	// MT0D0S //
	/////////////
	
	/* ---Mtodo guardarOpciones--- */
	/* Activado cuando se pulsa 'guardar', sobreescribe las opciones existentes por
	 * las actuales. Esto es, comprobar el estado de todas las opciones, y las guardar 
	 * tal y como las encuentre. */
	private void guardarOpciones() throws IOException{
		
		Timer timer;
		
		if(jck1.isSelected())
			MailProperties.jck1 = true;
		else
			MailProperties.jck1 = false;
		
		if(jck2.isSelected())
			MailProperties.jck2 = true;
		else
			MailProperties.jck2 = false;
		
		if(jck3.isSelected())
			MailProperties.jck3 = true;
		else
			MailProperties.jck3 = false;
			
		if(jck4.isSelected())
			MailProperties.jck4 = true;
		else
			MailProperties.jck4 = false;
			
		if(jck5.isSelected()){
			MailProperties.jck5 = true;
			MailProperties.jcb1 = (String) jcb1.getSelectedItem();
			
			miliseconds = getTiempo(MailProperties.jcb1);
//			if(MailProperties.jcb1.equalsIgnoreCase(MailProperties.textos.getString("combobox_5mins")))
//				//miliseconds = 5*60*1000;
//				miliseconds = 30000; // rate fijo de pruebas...
//			else if(MailProperties.jcb1.equalsIgnoreCase(MailProperties.textos.getString("combobox_10mins")))
//				miliseconds = 10*60*1000;
//			else if(MailProperties.jcb1.equalsIgnoreCase(MailProperties.textos.getString("combobox_15mins")))
//				miliseconds = 15*60*1000;
//			else if(MailProperties.jcb1.equalsIgnoreCase(MailProperties.textos.getString("combobox_30mins")))
//				miliseconds = 30*60*1000;
//			else if(MailProperties.jcb1.equalsIgnoreCase(MailProperties.textos.getString("combobox_1h")))
//				miliseconds = 60*60*1000;
//			else if(MailProperties.jcb1.equalsIgnoreCase(MailProperties.textos.getString("combobox_2h")))
//				miliseconds = 120*60*1000;
//			else if(MailProperties.jcb1.equalsIgnoreCase(MailProperties.textos.getString("combobox_3h")))
//				miliseconds = 180*60*1000;
//			else if(MailProperties.jcb1.equalsIgnoreCase(MailProperties.textos.getString("combobox_6h")))
//				miliseconds = 360*60*1000;
//			else if(MailProperties.jcb1.equalsIgnoreCase(MailProperties.textos.getString("combobox_12h")))
//				miliseconds = 720*60*1000;
//			else if(MailProperties.jcb1.equalsIgnoreCase(MailProperties.textos.getString("combobox_1dia")))
//				miliseconds = 1440*60*1000;
			
			if(MainOgre.verboso) System.out.println("miliseconds (): "+miliseconds);
			
			// Arrancar un thread con un Timer "scheduledAtFixedRate".
//			timer = new Timer();
//			timer.scheduleAtFixedRate(new TaskAutomatizar(timer), miliseconds, miliseconds);
		} else
			MailProperties.jck5 = false;
			
		if(jck6.isSelected()){
			MailProperties.jck6 = true;
			//MailProperties.jcb2 = (String) jcb2.getSelectedItem();
			MailProperties.jcb2 = (String) jcb2.getSelectedItem();
			
			if(MailProperties.jcb2.equalsIgnoreCase(MailProperties.textos.getString("combobox_castellano"))){
				MailProperties.lang = "es";
			} else if(MailProperties.jcb2.equalsIgnoreCase(MailProperties.textos.getString("combobox_gallego"))){
				MailProperties.lang = "gl";
			} else if(MailProperties.jcb2.equalsIgnoreCase(MailProperties.textos.getString("combobox_catalan"))){
				MailProperties.lang = "ca";
			} else if(MailProperties.jcb2.equalsIgnoreCase(MailProperties.textos.getString("combobox_ingles"))){
				MailProperties.lang = "en";
			}
		} else
			MailProperties.jck6 = false;
		
		MailProperties.escribir_properties(); // Las escribimos...
		
		// Liberamos la ventana.
		setVisible(false);
		dispose();
		
		MailProperties.leer_properties(); // ...y recargamos la configuracion.
		
	}
	
	/* ---Metodo getMiliseconds--- */
	/* Devuelve los miliseconds calculados. */
	public long getMiliseconds(){
		return miliseconds;
	}
	
	/* ---Mtodo getTiempo--- */
	/* Devuelve el tiempo en milisegundos asociado a un label determinado. */
	public static long getTiempo(String label) {
		if(MailProperties.jcb1.equalsIgnoreCase(MailProperties.textos.getString("combobox_5mins")))
			miliseconds = 5*60*1000;
			//miliseconds = 30000; --> test
		else if(MailProperties.jcb1.equalsIgnoreCase(MailProperties.textos.getString("combobox_10mins")))
			miliseconds = 10*60*1000;
		else if(MailProperties.jcb1.equalsIgnoreCase(MailProperties.textos.getString("combobox_15mins")))
			miliseconds = 15*60*1000;
		else if(MailProperties.jcb1.equalsIgnoreCase(MailProperties.textos.getString("combobox_30mins")))
			miliseconds = 30*60*1000;
		else if(MailProperties.jcb1.equalsIgnoreCase(MailProperties.textos.getString("combobox_1h")))
			miliseconds = 60*60*1000;
		else if(MailProperties.jcb1.equalsIgnoreCase(MailProperties.textos.getString("combobox_2h")))
			miliseconds = 120*60*1000;
		else if(MailProperties.jcb1.equalsIgnoreCase(MailProperties.textos.getString("combobox_3h")))
			miliseconds = 180*60*1000;
		else if(MailProperties.jcb1.equalsIgnoreCase(MailProperties.textos.getString("combobox_6h")))
			miliseconds = 360*60*1000;
		else if(MailProperties.jcb1.equalsIgnoreCase(MailProperties.textos.getString("combobox_12h")))
			miliseconds = 720*60*1000;
		else if(MailProperties.jcb1.equalsIgnoreCase(MailProperties.textos.getString("combobox_1dia")))
			miliseconds = 1440*60*1000;
			
		return miliseconds;
	}
	
//	/* TaskCreditos- Representa una clase que define la tarea a realizar por
//	 * el Timer en un hilo de ejecucin separado. */
//	private class TaskAutomatizar extends TimerTask {
//		
//		Timer timer;
//		
//		TaskAutomatizar(Timer unTimer){
//			timer = unTimer;
//		}
//		
//		public void run(){
//			// Auto-enviar/recibir cada X tiempo.
//			EmisorMail.enviando = true;
//			OgrePrincipal.desactivacionBotonesCriticos();
//			//OgrePrincipal.OgreMenuBar.enviarMail();
//			EmisorMail.enviando = false;
//			OgrePrincipal.activacionBotonesCriticos();
//			OgrePrincipal.activacionParar();
//		}
//	}
	
	
	///////////////
	// LISTENERS //
	///////////////
	
	/* CheckBoxListener - Listener de los checkboxes que nos interesan para habilitar/
	 * deshabilitar ciertos componentes relacionados con otros. Se usa bsicamente para
	 * la interfaz grfica de este dilogo de configuracin. */
	private class CheckBoxListener implements ItemListener {
	
		public void itemStateChanged(ItemEvent e) {
	
			Object source = e.getSource();
				
			if(source.equals(jck5)) {
				if(jcb1 != null){
					if(e.getStateChange() == ItemEvent.SELECTED)
						jcb1.setEnabled(true);
					else
						jcb1.setEnabled(false);
				}
			} else if(source.equals(jck6)) {
				if(jcb2 != null){
					if(e.getStateChange() == ItemEvent.SELECTED)
						jcb2.setEnabled(true);
					else
						jcb2.setEnabled(false);
				}
			}
		}
	}

}
