package gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.Date;
import java.util.LinkedList;
import javax.activation.DataHandler;
import javax.activation.DataSource;
import javax.activation.FileDataSource;
import javax.activation.MimetypesFileTypeMap;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;
import javax.mail.Address;
import javax.mail.BodyPart;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Multipart;
import javax.mail.Part;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextField;
import javax.swing.JTextPane;
import javax.swing.JToolBar;
import javax.swing.UIManager;
import javax.swing.event.TableModelEvent;
import base.CuentaMail;
import base.EmisorMail;
import base.IniciadorSesion;
import base.MailProperties;
import base.MainOgre;

/******************************************************************************
 * 																			  *
 *  Copyright 2004 Jordi Oliveras & Marcos Valerio.							  *
 * 																			  *
 *  This file is part of Ogre.												  *
 *																			  *
 *  Ogre is free software; you can redistribute it and/or modify			  *
 *  it under the terms of the GNU General Public License as published by	  *
 *  the Free Software Foundation; either version 2 of the License, or		  *
 *  (at your option) any later version.										  *
 *																			  *
 *  Ogre is distributed in the hope that it will be useful,					  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of			  *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			  *
 *  GNU General Public License for more details.							  *
 *                       													  *
 *  You should have received a copy of the GNU General Public License         *
 *  along with Ogre; if not, write to the Free Software                       *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 * 																			  *
 ******************************************************************************
 *  																		  *
 * OgreNuevoMail - Clase que representa el dilogo que permitir al usuario   *
 * la composicin de un correo electrnico, bien desde cero, o como resultado *
 * de una respuesta o reenvio de otro ya existente.                           *
 * 																			  *
 ******************************************************************************/

public final class OgreNuevoMail extends JFrame {

	JButton button;
	JButton para, Cc;
	JLabel asunto;
	JTextField paraTextField, CcTextField, asuntoTextField;
	JTextPane jtextpane;
	CuentaMail cuentaMail;
	OgreMailTableModel omtm;
	TableSorter2004 sorter;
	MimeMessage message;
	JTabbedPane tabbedPane;
	JPanel panel2, panel3; // Paneles de adjuntos e inlines.
	Multipart multipart = new MimeMultipart();
	ArrayList listaAdjuntos = new ArrayList(); // ArrayList de adjuntos (guarda objetos del tipo String con la ruta hacia el fichero).
	LinkedList listaBotonesADJ = new LinkedList(); // LinkedList de botones  representando adjuntos (guarda referencias a botones).
	ArrayList listaInlines = new ArrayList(); // ArrayList de inlines (guarda objetos del tipo String con la ruta hacia el fichero).
	LinkedList listaBotonesINL = new LinkedList(); // LinkedList de botones representando inlines (guarda referencias a botones).
	StringBuffer sb;
	static boolean contador = true;

	public OgreNuevoMail(CuentaMail aCuentaMail,
						 OgreMailTableModel aOmtm, TableSorter2004 aSorter,
						 MimeMessage replyMessage, String rutaAlFichero) throws IOException, MessagingException {
		
		super.setResizable(false);
		
		cuentaMail = aCuentaMail;
		omtm = aOmtm;
		sorter = aSorter;
		ZonaBotonListener botonListener = new ZonaBotonListener();
		
		// Gestion L&F (multi-arquitectura).
		try {
			UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
		} catch(Exception e){
			JOptionPane.showMessageDialog(null, e.getMessage()+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
			e.getMessage();
			e.printStackTrace();
		}
		
		/* 1) Hacer su barra de herramientas (por ahora no tendr barra de menus).
		 * Como habr pocas opciones, se puede solucionar con clases internas.
		 */
		JToolBar toolBar = new JToolBar();
		toolBar.setFloatable(false);
		
		// Menuitem y boton de ENVIAR CORREO.
		/* Se puede componer un correo mientras se est realizando una operacin crtica,
		 * como enviar, recibir o enviarrecibir. Sin embargo, si la operacin crtica en
		 * curso an permanece activa cuando se le da a mandar el correo recin compuesto,
		 * ste se encola. Si la tarea crtica acab antes de mandar el correo, entonces s
		 * se proceder directamente a enviar dicho correo. */
		Action accionEnviar = new AbstractAction(MailProperties.textos.getString("tooltip_nuevo_enviar"), new ImageIcon(getClass().getResource("/iconos/Enviar_25x20.png"))) {
			public void actionPerformed(ActionEvent e){
				
				if(cuentaMail.nombreCuenta != null){
				
					try {
						construir_mensaje();
						if(OgrePrincipal.operacionCritica == false){
							EmisorMail.enviando = true;
							OgrePrincipal.desactivacionBotonesCriticos();
							enviarMail();
							// Estos van abajo, en enviarMail().
							//EmisorMail.enviando = false;
							//OgrePrincipal.activacionBotonesCriticos();
							//OgrePrincipal.activacionParar();
						}
						else
							guardar_mensaje("Encolar");
					} catch(IOException e1) {
						EmisorMail.enviando = false;
						OgrePrincipal.activacionBotonesCriticos();
						OgrePrincipal.activacionParar();
						OgreProgressBar.setDesactiva(); // Fin progressbar.
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_enviar_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
						e1.getMessage();
						e1.printStackTrace();
					} catch(MessagingException e1) {
						EmisorMail.enviando = false;
						OgrePrincipal.activacionBotonesCriticos();
						OgrePrincipal.activacionParar();
						OgreProgressBar.setDesactiva(); // Fin progressbar.
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_enviar_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
						e1.getMessage();
						e1.printStackTrace();
					} catch(Exception exc){
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_destinatario"), MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
					}
				}
			}
		};
		button = toolBar.add(accionEnviar);
		button.addMouseListener(botonListener);
		button.setBorderPainted(false);
		button.setRolloverEnabled(true);
		button.setRolloverIcon(new ImageIcon(getClass().getResource("/iconos/Enviar_roll_25x20.png")));
		button.setToolTipText(MailProperties.textos.getString("tooltip_nuevo_enviar"));
		
		// Menuitem y boton de ENCOLAR CORREO.
		Action accionEncolar = new AbstractAction(MailProperties.textos.getString("tooltip_nuevo_encolar"), new ImageIcon(getClass().getResource("/iconos/Encolar_25x20.png"))) {
			public void actionPerformed(ActionEvent e){
				
				if(cuentaMail.nombreCuenta != null){
				
					try {
						construir_mensaje();
						guardar_mensaje("Encolar");
					} catch (IOException e1) {
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_encolar_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
						e1.getMessage();
						e1.printStackTrace();
					} catch (MessagingException e1) {
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_encolar_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
						e1.getMessage();
						e1.printStackTrace();
					} catch(Exception exc){
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_destinatario"), MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
					}
				}
			}
		};
		button = toolBar.add(accionEncolar);
		button.addMouseListener(botonListener);
		button.setBorderPainted(false);
		button.setRolloverEnabled(true);
		button.setRolloverIcon(new ImageIcon(getClass().getResource("/iconos/Encolar_roll_25x20.png")));
		button.setToolTipText(MailProperties.textos.getString("tooltip_nuevo_encolar"));
		
		// Menuitem y boton de GUARDAR CORREO.
		Action accionGuardar = new AbstractAction(MailProperties.textos.getString("tooltip_nuevo_guardar"), new ImageIcon(getClass().getResource("/iconos/Guardar_25x20.png"))) {
			public void actionPerformed(ActionEvent e){
				
				if(cuentaMail.nombreCuenta != null){
				
					try {
						construir_mensaje();
						guardar_mensaje("Guardar");
					} catch(IOException e1) {
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_guardar_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
						e1.getMessage();
						e1.printStackTrace();
					} catch(MessagingException e1) {
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_guardar_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
						e1.getMessage();
						e1.printStackTrace();
					} catch(Exception exc){
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_destinatario"), MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
					}
				}
			}
		};
		button = toolBar.add(accionGuardar);
		button.addMouseListener(botonListener);
		button.setBorderPainted(false);
		button.setRolloverEnabled(true);
		button.setRolloverIcon(new ImageIcon(getClass().getResource("/iconos/Guardar_roll_25x20.png")));
		button.setToolTipText(MailProperties.textos.getString("tooltip_nuevo_guardar"));
		
		// Menuitem y boton de INSERTAR elemento al CORREO.
		Action accionInsertar = new AbstractAction(MailProperties.textos.getString("tooltip_nuevo_insertar"), new ImageIcon(getClass().getResource("/iconos/Insertar_25x20.png"))) {
			public void actionPerformed(ActionEvent e){
				Runnable r = new Runnable(){
					public void run(){
						try { 
							apuntar_items("inline");
						} catch(Exception e){
							JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_insertar_elemento")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
							e.getMessage();
							e.printStackTrace();
						}
					} 
				};
				Thread t = new Thread(r);
				t.start();
			}
		};
		button = toolBar.add(accionInsertar);
		button.addMouseListener(botonListener);
		button.setBorderPainted(false);
		button.setRolloverEnabled(true);
		button.setRolloverIcon(new ImageIcon(getClass().getResource("/iconos/Insertar_roll_25x20.png")));
		button.setToolTipText(MailProperties.textos.getString("tooltip_nuevo_insertar"));
		
		// Menuitem y boton de ADJUNTAR elemento al CORREO.
		Action accionAdjuntar = new AbstractAction(MailProperties.textos.getString("tooltip_nuevo_adjuntar"), new ImageIcon(getClass().getResource("/iconos/Adjuntar_25x20.png"))) {
			public void actionPerformed(ActionEvent e){
				Runnable r = new Runnable(){
					public void run(){
						try { 
							apuntar_items("attach");
						} catch(Exception e){
							JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_adjuntar_elemento")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
							e.getMessage();
							e.printStackTrace();
						}
					} 
				};
				Thread t = new Thread(r);
				t.start();
			}
		};
		button = toolBar.add(accionAdjuntar);
		button.addMouseListener(botonListener);
		button.setBorderPainted(false);
		button.setRolloverEnabled(true);
		button.setRolloverIcon(new ImageIcon(getClass().getResource("/iconos/Adjuntar_roll_25x20.png")));
		button.setToolTipText(MailProperties.textos.getString("tooltip_nuevo_adjuntar"));
		

		// PARTE SUPERIOR //
		
		/* 2) Hacer los labels y campos de introduccin de texto. */
		para = new JButton(MailProperties.textos.getString("boton_para")/*, JLabel.LEFT*/);
		paraTextField = new JTextField(35);
		paraTextField.setAlignmentY(LEFT_ALIGNMENT);
		Cc = new JButton(MailProperties.textos.getString("boton_Cc")/*, JLabel.LEFT*/);
		CcTextField = new JTextField(35);
		asunto = new JLabel(MailProperties.textos.getString("etiqueta_asunto"), JLabel.LEFT);
		asuntoTextField = new JTextField(35);
		
		/* Sin un GridBagLayout, la distribucin de los componentes se hace imposible
		 * (al menos de la forma que se pretende).
		 */
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints constraints = new GridBagConstraints();
		JPanel panel = new JPanel(gridbag);
		
		// Definicin de los GridBagConstraints y adicin de los componentes al JPanel.
		constraints.gridx = 0;
		constraints.gridy = 0;
		constraints.gridwidth = 1;
		constraints.fill = GridBagConstraints.HORIZONTAL;
		gridbag.setConstraints(para, constraints);
		panel.add(para);
		
		constraints.gridx = 1;
		constraints.gridy = 0;
		//constraints.fill = GridBagConstraints.HORIZONTAL;
		constraints.gridwidth = GridBagConstraints.REMAINDER; // El componente es el ltimo de la fila.
		gridbag.setConstraints(paraTextField, constraints);
		panel.add(paraTextField);
		
		constraints.gridx = 0;
		constraints.gridy = 1;
		constraints.gridwidth = 1;
		//constraints.fill = GridBagConstraints.HORIZONTAL;
		gridbag.setConstraints(Cc, constraints);
		panel.add(Cc);
		
		constraints.gridx = 1;
		constraints.gridy = 1;
		//constraints.fill = GridBagConstraints.HORIZONTAL;
		constraints.gridwidth = GridBagConstraints.REMAINDER;
		gridbag.setConstraints(CcTextField, constraints);
		panel.add(CcTextField);
		
		constraints.fill = GridBagConstraints.NONE;
		
		constraints.gridx = 0;
		constraints.gridy = 2;
		constraints.gridwidth = 1;
		//constraints.fill = GridBagConstraints.HORIZONTAL;
		gridbag.setConstraints(asunto, constraints);
		panel.add(asunto);
		
		constraints.gridx = 1;
		constraints.gridy = 2;
		//constraints.fill = GridBagConstraints.HORIZONTAL;
		constraints.gridwidth = GridBagConstraints.REMAINDER;
		gridbag.setConstraints(asuntoTextField, constraints);
		panel.add(asuntoTextField);
		
		JScrollPane jscrollpane1 = new JScrollPane(panel);
		jscrollpane1.setPreferredSize(new Dimension(200,80)); // Tamao default.
		
		// PARTE INFERIOR //
		
		/* 3) Hacer el campo donde ir el cuerpo del mensaje de mail. */
		jtextpane = new JTextPane();
		JScrollPane jscrollpane2 = new JScrollPane(jtextpane);
		jscrollpane2.setPreferredSize(new Dimension(500,200)); // Tamao default.
		
		/* 4) Hacer el tabbed pane con 2 pestaas; una para el Contenido, y otra
		 * para los attachments (y los inlines?). */
		tabbedPane = new JTabbedPane();
		tabbedPane.addTab(MailProperties.textos.getString("pestaa_contenido"), new ImageIcon(getClass().getResource("/iconos/Contenido_25x20.png")), (Component) jscrollpane2, MailProperties.textos.getString("tooltip_pestaa_contenido"));
		tabbedPane.setSelectedIndex(0);
		
		/* 5) Un JPanel guardar cada panel que conforma cada inline. */
		panel2 = new JPanel();
		panel2.setLayout(new BoxLayout(panel2, BoxLayout.Y_AXIS));
		JScrollPane jscrollpane3 = new JScrollPane(panel2);
		jscrollpane3.setPreferredSize(new Dimension(500,140)); // Tamao default.
	
		/* 6) Y lo metemos en una tercera pestaa del JTabbedPane. */
		tabbedPane.addTab(MailProperties.textos.getString("pestaa_nuevo_inlines"), new ImageIcon(getClass().getResource("/iconos/Insertar_25x20.png")), (Component) jscrollpane3, MailProperties.textos.getString("tooltip_pestaa_nuevo_inlines"));
		tabbedPane.setEnabledAt(1, false);		
		
		/* 7) Otro JPanel guardar cada panel que conforma cada adjunto. */
		panel3 = new JPanel();
		panel3.setLayout(new BoxLayout(panel3, BoxLayout.Y_AXIS));
		JScrollPane jscrollpane4 = new JScrollPane(panel3);
		jscrollpane4.setPreferredSize(new Dimension(500,140)); // Tamao default.
		
		/* 8) Y lo metemos en una segunda y ultima pestaa del JTabbedPane. */
		tabbedPane.addTab(MailProperties.textos.getString("pestaa_adjuntos"), new ImageIcon(getClass().getResource("/iconos/Adjuntar_25x20.png")), (Component) jscrollpane4, MailProperties.textos.getString("tooltip_pestaa_adjuntos"));
		tabbedPane.setEnabledAt(2, false);
		
		/* 9) Crear el splitpane para meter en el frame, por un lado los labels 
		 * con los campos de intro de texto, y por otro, el editor de texto. */
		JSplitPane jsplitpane = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
		jsplitpane.setTopComponent(jscrollpane1);
		jsplitpane.setBottomComponent(tabbedPane);
		jsplitpane.setOneTouchExpandable(true);
		
		getContentPane().add(toolBar, BorderLayout.NORTH); // Aade la Toolbar al frame.
		getContentPane().add(jsplitpane, BorderLayout.CENTER);
		
		/* 
		 * Desde que NO usamos un contenedor de alto nivel para hacer de content pane
		 * (como un JPanel), si queremos poder tocar los bordes, debemos hacer un cast
		 * (a un JComponent) de lo que nos devuelve el frame al pedirle su content pane.
		 * De esta forma ya podemos operar con los bordes.
		 * */
		JComponent contentPane = (JComponent) getContentPane();
		contentPane.setBorder(BorderFactory.createEmptyBorder(
		2, //top
		5, //left
		5, //bottom
		5) //right
		);
		
		// Posicionamiento ventana.
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		Dimension frameSize = getPreferredSize();
		setLocation(screenSize.width/2 - (frameSize.width/2), screenSize.height/2 - (frameSize.height/2));
		
		/* Si se trata de un reply, trabajo extra para el Construtor. */
		if(replyMessage != null){
			super.setTitle(MailProperties.textos.getString("titulo_responder_ventana"));
			construir_reply(replyMessage); // Construye un mensaje del tipo reply.
		} else if(rutaAlFichero != null){ /* Forward, ms trabajo extra! */
			super.setTitle(MailProperties.textos.getString("titulo_reenviar_ventana"));
			construir_forward(rutaAlFichero); // Construye un mensaje del tipo forward.
		} else {
			super.setTitle(MailProperties.textos.getString("titulo_nuevo_ventana"));
		}
	
		// Listener para el cerrado de ventana.
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				// Liberamos la ventana.
				setVisible(false);
				dispose();
			}
		});
		
		pack();
		setVisible(true);
	}

	///////////////
	// LISTENERS //
	///////////////
	
	/* BotonEliminarListener - Oyente de los clics a los botones de los adjuntos procesados
	 * en un mensaje. Se encarga de quitar del panel de adjuntos y de la lista de adjuntos
	 * los elementos seleccionados. */
	private class BotonEliminarListener implements ActionListener {
		
		String tipoIcono;
		
		/* Constructor: Este constructor se asegura de que, pes a llamarse desde un mtodo
		 * que crea clases de este tipo (BotonEliminarListener) annimas, cada clase annima
		 * tenga una 'filiacin', ya sea con un tipoIcono (attach) u otro (inline). */
		public BotonEliminarListener(String tipoIcono){
			this.tipoIcono = tipoIcono;
		}

		public void actionPerformed(ActionEvent e) {
			
			int i;
			JButton button = (JButton) e.getSource();
			
			if(tipoIcono.equalsIgnoreCase("attach")){
				
				if(MainOgre.verboso) System.out.println("listaBotonesADJ.size(): "+listaBotonesADJ.size()); //DEBUG
				
				for(i=0; i<listaBotonesADJ.size(); i++){		
					if(((JButton) listaBotonesADJ.get(i)).equals(button)){
						if(MainOgre.verboso) System.out.println("El adjunto relacionado con este boton es "+listaAdjuntos.get(i)); //DEBUG
						listaAdjuntos.remove(i); // ?
						listaBotonesADJ.remove(i);
						panel3.remove(i);
						panel3.repaint(); // Si no repintamos aqu, mal asunto :)
						panel3.revalidate(); // Importante: actualiza el JPanel de adjuntos.
					
						if(listaBotonesADJ.size() == 0)
							tabbedPane.setEnabledAt(2, false);
						
						return;
					}
				}
			}
			else{
				
				if(MainOgre.verboso) System.out.println("listaBotonesINL.size(): "+listaBotonesINL.size()); //DEBUG
				
				for(i=0; i<listaBotonesINL.size(); i++){		
					if(((JButton) listaBotonesINL.get(i)).equals(button)){
						if(MainOgre.verboso) System.out.println("El inline relacionado con este boton es "+listaInlines.get(i)); //DEBUG
						listaInlines.remove(i); // ?
						listaBotonesINL.remove(i);
						panel2.remove(i);
						panel2.repaint(); // Si no repintamos aqu, mal asunto :)
						panel2.revalidate(); // Importante: actualiza el JPanel de inlines.
					
						if(listaBotonesINL.size() == 0)
							tabbedPane.setEnabledAt(1, false);
						
						return;
					}
				}
			}
		}
	}

	/////////////
	// MT0D0S //
	/////////////
	
	/* ---Mtodo construir_forward---*/
	/* Construye lo que constituye un reply en el gui. Como es una simple redireccin de
	 * un mensaje a una direccin definida por el usuario, el mensaje a reenviar es aadido
	 * como adjunto. */
	private void construir_forward(String rutaAlFichero) throws MessagingException, IOException{
		
		String subject;
		MimeMessage forwardMessage = new MimeMessage(null, new FileInputStream(rutaAlFichero));
		
		try {
			subject = forwardMessage.getSubject();
		} catch(NullPointerException npe){
			subject = "";
		}
		
		
		/* 1) Establecer el asunto (Fwd: Asunto antiguo). */
		if(forwardMessage.getSubject().startsWith("Fwd:")){
			asuntoTextField.setText(subject);
		}
		else
			asuntoTextField.setText("Fwd: "+subject);
				
		/* 2) Aadir el mensaje a redirigir como adjunto. */
		File file = new File(rutaAlFichero);
		listaAdjuntos.add(file.getCanonicalPath()); // Guardamos la ruta a cada adjunto.
		gestion_iconos(file, "attach");	 
	}
	
	/* ---Mtodo construir_reply---*/
	/* Construye lo que constituye un reply en el gui. Esto supone establecer un asunto 
	 * predefinido, y posiblemente tambin un cuerpo de mensaje predefinido al que luego 
	 * aadir la respuesta. Los adjuntos NO son aadidos. Una vez presentado el gui y 
	 * modificado por el usuario, el mensaje ser procesado como cualquier otro, por 
	 * construir_mensaje. */
	private void construir_reply(MimeMessage replyMessage) throws IOException, MessagingException{

		int i;
		Address[] remites = null;
		String asunto;

		/* 1) Establecer el destinatario. */
		try {
			remites =  replyMessage.getFrom();
			
			for(i=0; i<replyMessage.getFrom().length; i++){
				 if(remites[i] != null)
					break;
			}
			if(i!=replyMessage.getFrom().length)
				paraTextField.setText(remites[i].toString());
			
		} catch(NullPointerException npe){
			paraTextField.setText("");
		}
		
		/* 2) Establecer el asunto (Re: Asunto antiguo). */
		try {
			asunto = replyMessage.getSubject();
			if(asunto.startsWith("Re:"))
				asuntoTextField.setText(asunto);
			else
				asuntoTextField.setText("Re: "+asunto);
		} catch(NullPointerException npe){
			asuntoTextField.setText("");
		}
			
		/* 3) Establecer el texto antiguo "marcado" con > y el caret al principio del
	 	* jtextpane. */
	 	Part part = null;
	 	String linea;
	 	sb = new StringBuffer();
		 	
	 	/* Identificacin del tipo de contenido: nos quedamos con las partes del 
	 	 * mensaje que sean de tipo texto plano. Si no hay ninguna, no se adjuntar 
	 	 * nada en el jtextpane. */
	 	Object obj = replyMessage.getContent();
 		if(obj instanceof Multipart){
			buscar_texto_multipart((Multipart) obj);
 		} else {
			buscar_texto_part(replyMessage);
 		}
		 	
		if(MainOgre.verboso) System.out.println("sb.length(): "+sb.length()); // DEBUG
		if(sb != null){
			jtextpane.setText(sb.toString());
			jtextpane.setCaretPosition(0);
		}
			
		// Reseteo de variables.
		sb.delete(0, sb.length());
		contador = true;
	}
	
	/* ---Mtodo buscar_texto_part--- */
	/* Busca contenido instanceof String para usarlo como texto de reply en el jtextpane. */
	private void buscar_texto_part(Part part) throws IOException, MessagingException{
			
		if(MainOgre.verboso) System.out.println("En buscar_texto_part()"); //DEBUG
			
		Object obj = part.getContent();
		if(MainOgre.verboso) System.out.println("contentType: "+part.getContentType()); //DEBUG
		if(obj instanceof String){
				
			//System.out.println("Una instancia de String..."); //DEBUG
			//System.out.println("contentType: "+part.getContentType()); //DEBUG
			//System.out.println("content: "+obj.toString()); //DEBUG
				
			if(contador == true){
				sb.append("\r\n\r\n");
				contador = false;
			}
							
			String linea;			
			StringReader contenidoReader = new StringReader(obj.toString());
			BufferedReader br = new BufferedReader(contenidoReader);
			while((linea = br.readLine()) != null){
				sb.append("> ");
				sb.append(linea);
				sb.append("\r\n");
			}
		}
	}
	
	/* ---Mtodo buscar_texto_multipart--- */
	/* Descompone las entidades multipart y se las pasa desglosadas a buscar_texto_part 
	 * para que trabaje con ellas. */
	private void buscar_texto_multipart(Multipart multipart) throws MessagingException, IOException{
		
		Part part = null;
			
		for(int i=0; i<multipart.getCount(); i++){
			part = multipart.getBodyPart(i);
			Object obj = part.getContent();
			if(obj instanceof Multipart)
				buscar_texto_multipart((Multipart) obj);
			else
				buscar_texto_part(part);
		}
	}
	
	/* ---Metodo enviarMail--- */
	/* Construye de un fichero con formato apropiado para posteriormente ser
	 * cargado en un objeto MimeMessage. Este objeto ser cargado pasado a EmisorMail. */
	private void enviarMail(){
				
		// Pasrselo a EmisorMail con el constructor apropiado (threaded).
		Runnable r = new Runnable(){
			public void run(){
				 
				OgreProgressBar.setActiva(MailProperties.textos.getString("progressbar_enviando")); // Inicio progressbar.
			  	MimeMessage[] arrayMensajes = {message}; // Array de MimeMessage's de un slo mensaje.
				EmisorMail em = new EmisorMail(cuentaMail, arrayMensajes);
				EmisorMail.enviando = false;
				OgrePrincipal.activacionBotonesCriticos();
				OgrePrincipal.activacionParar();
				
				/* Debe averiguar si el nodo outbox esta seleccionado; si lo est, procede
				 * a la actualizacin de la tabla. Si no lo est, no la lleva a cabo.
				 */
				if((OgrePrincipal.node != null)&&(OgrePrincipal.node.toString().equalsIgnoreCase("outbox"))) {
					omtm.fireTableDataChanged(); // NO actualiza la tabla?
					sorter.fireTableChanged(new TableModelEvent(omtm)); // Ahora SI la actualiza.
					sorter.fireTableDataChanged();
				}
			} 
		};
		Thread t = new Thread(r);
		t.start();
			
		// Cerramos la ventana.
		setVisible(false);
		dispose();		
	}
	
	/* ---Mtodo construir_mensaje--- */
	/* Construye un objeto de tipo MimeMessage. */
	private void construir_mensaje() throws Exception {
		
		boolean validado = true;
		String tempString, direcciones = null;
		Address addresses[] = null;
		IniciadorSesion is = new IniciadorSesion(cuentaMail);
				
		// 1) Crear un mensaje con los datos (gracias a una sesin).
		message = new MimeMessage(IniciadorSesion.session);
				
		message.setHeader("X-Mailer", MailProperties.xmailer);
		message.setSentDate(new Date());
		if(MainOgre.verboso) System.out.println("sentdate: "+message.getSentDate().toString()); // DEBUG
				
		message.setFrom(new InternetAddress(cuentaMail.email));
		if(MainOgre.verboso) System.out.println("from: "+message.getFrom().toString()); // DEBUG
			
		String replyTo = new InternetAddress(cuentaMail.email).getAddress();
		addresses = InternetAddress.parse(replyTo, false);
		message.setReplyTo(addresses);
		if(MainOgre.verboso) System.out.println("replyTo: "+message.getReplyTo().toString()); // DEBUG
								
		/***TO***/
		/* Solucin para mltiples destinatarios. Parsear y obtener las direcciones
		* de mail por separado. */
		direcciones = paraTextField.getText();
		if(direcciones.equalsIgnoreCase("")){
			validado = false;
			throw new Exception();
		} else {
			// Aqu cabra llamar a una funcin que compruebe mnimamente la validez de la/s direccin/es.
			addresses = InternetAddress.parse(direcciones, false);
			message.addRecipients(Message.RecipientType.TO, addresses);
			if(MainOgre.verboso) System.out.println("recipient(TO): "+message.getRecipients(Message.RecipientType.TO)); // DEBUG
		}
	
		/***CC***/
		try {
			// Aqu cabra llamar a una funcin que compruebe mnimamente la validez de la/s direccin/es.
			addresses = InternetAddress.parse(CcTextField.getText(), false);
			message.addRecipients(Message.RecipientType.TO, addresses);
			if(MainOgre.verboso) System.out.println("recipients(CC): "+message.getRecipients(Message.RecipientType.CC)); // DEBUG
		} catch(Exception e){
			JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_Cc")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
			e.getMessage();
			e.printStackTrace();
		}
					
		/***SUBJECT***/
		try { 	 
			message.setSubject(asuntoTextField.getText());
			if(MainOgre.verboso) System.out.println("subject: "+message.getSubject()); // DEBUG
		} catch(Exception e){
			JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_asunto")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
			e.getMessage();
			e.printStackTrace();
		}												
				
		if(validado == true){
			BodyPart messageBodyPart = new MimeBodyPart();
			tempString = jtextpane.getText(); 
			if(tempString != null){
				// Crear parte principal del mensaje.
				messageBodyPart.setContent(jtextpane.getText(), "text/plain");
				messageBodyPart.setDisposition("INLINE");
				if(MainOgre.verboso) System.out.println("content: "+(String) messageBodyPart.getContent());
			}			
					
			// Aadir la parte principal al mensaje.
			multipart.addBodyPart(messageBodyPart);
					
			// Luego aadir los inlines y adjuntos, si los hay.
			anyadir_items(multipart);
					
			// Poner todas las partes en el mensaje.
			message.setContent(multipart);
		}
	}
	
	/* ---Mtodo apuntar_items--- */
	/* Guarda en un array las rutas hacia los inlines/attachments. No los aadimos desde
	 * principio por la nueva poltica de gestin de los mensajes de correo que hacen
	 * la vasta mayora de clientes de correo actuales: representar por pantalla, en primer
	 * lugar, la primera parte del correo que encuentran, y gestionar lo dems que no
	 * puede mostrarse simultneamente como adjunto. Por tanto, los adjuntos e inlines se 
	 * aadirn al mensaje justo al final. */
	private void apuntar_items(String item) throws IOException{
		
		JFileChooser fc = new JFileChooser();
		int val = fc.showOpenDialog(this);

		if(val == JFileChooser.APPROVE_OPTION) {
			File file = fc.getSelectedFile();
			if(item.equalsIgnoreCase("attach")){
				listaAdjuntos.add(file.getCanonicalPath()); // Guardamos la ruta a cada adjunto.
				gestion_iconos(file, "attach");
			}
			else {
				listaInlines.add(file.getCanonicalPath()); // Guardamos la ruta a cada inline.
				gestion_iconos(file, "inline");
			}
		}
	}
	
	/* ---Mtodo gestion_iconos--- */
	/* Identifica los tipos de archivo que se van poniendo inline o como adjunto, para
	 * representarlo en el panel respectivo (de inlines o de adjuntos). */
	private void gestion_iconos(File file, String tipoIcono) throws IOException{
			
		// Este panel(panelElemento) guarda el dueto boton + descripcion de un adjunto.
		FlowLayout fl = new FlowLayout(FlowLayout.LEFT);
		fl.setHgap(5);
		fl.setVgap(5);
		JPanel panelElemento = new JPanel(fl);
			
		String cadenaTamao;
		String icono;
		FileDataSource fds = new FileDataSource(file.getCanonicalPath());
		long tamao = fds.getFile().length();
			
		// Pequeo clculo de tamao.
		if(tamao<1024){
			cadenaTamao = new String(tamao+" byte/s");
		} else if(tamao<1048576){
			cadenaTamao = new String(tamao/1024+" Kbyte/s");
		} else {
			cadenaTamao = new String(tamao/1048576+" Mbyte/s");
		}
			
		/* Le establecemos un MimetypesFileTypeMap con adicin de nuevos tipos
		 * MIME para que sea un poc oms listo (no mucho ms, pues determina el
		 * tipo MIME de cada fichero por medio de la extensin). */
		MimetypesFileTypeMap mft = new MimetypesFileTypeMap();
		/* Todas estas nuevas definiciones MIME podran colocarse en el fichero
		 * META-INF/mime.types para quitar lo siguiente de la clase y clarificar
		 * la lectura del cdigo. */
		//mft.addMimeTypes("text/plain txt text TXT"); <- formato.
		mft.addMimeTypes("image/png png PNG");
		mft.addMimeTypes("image/bmp bmp BMP");
		mft.addMimeTypes("audio/mp3 mp3 MP3");
		mft.addMimeTypes("audio/wma wma wma");
		mft.addMimeTypes("audio/ra ra RA");
		mft.addMimeTypes("application/x-compressed zip ZIP");
		mft.addMimeTypes("application/x-zip-compressed zip ZIP");
		mft.addMimeTypes("application/zip zip ZIP");
		mft.addMimeTypes("application/arj arj ARJ");
		mft.addMimeTypes("application/x-bzip bz BZ");
		mft.addMimeTypes("application/x-bzip2 bz2 BZ2");
		mft.addMimeTypes("application/x-tar tar TAR");
		mft.addMimeTypes("application/gnutar tar TAR");
		mft.addMimeTypes("application/rar rar RAR");
		mft.addMimeTypes("application/ace ace ACE");
		mft.addMimeTypes("application/x-gzip gz gzip GZ GZIP");
		fds.setFileTypeMap(mft);
			
		String content = fds.getContentType();
		if(MainOgre.verboso) System.out.println("content: "+content); //DEBUG
			
		if(content.startsWith("text/")){
			if(content.equalsIgnoreCase("text/plain"))
				icono = "text_plain";
			else if(content.equalsIgnoreCase("text/richtext"))
				icono = "text_rich";
			else if(content.equalsIgnoreCase("text/html"))
				icono = "text_html";
			else
				icono = "text_plain";
		} else if(content.startsWith("image/")){
			icono = "image";
		} else if(content.startsWith("audio/")){
			icono = "audio";
		} else if(content.startsWith("video/")){
			icono = "video";
		} else if(content.startsWith("application/")){
			if((content.equalsIgnoreCase("application/arj"))||
			(content.equalsIgnoreCase("application/x-bzip"))||
			(content.equalsIgnoreCase("application/x-bzip2"))||
			(content.equalsIgnoreCase("application/x-compressed"))||
			(content.equalsIgnoreCase("application/x-gzip"))||
			(content.equalsIgnoreCase("application/x-tar"))||
			(content.equalsIgnoreCase("application/gnutar"))||
			(content.equalsIgnoreCase("application/x-zip-compressed"))||
			(content.equalsIgnoreCase("application/zip"))||
			(content.equalsIgnoreCase("application/rar"))||
			(content.equalsIgnoreCase("application/ace")))
				icono = "application_compressed";
			else if(content.equalsIgnoreCase("application/pgp-signature"))
				icono = "application_signature";
			else
				icono = "application";
		} else {
			icono = "unknown";
		}
		
		JButton button = new JButton(new ImageIcon(getClass().getResource("/images/"+icono)));
		button.setPreferredSize(new Dimension(55,70));
		button.setBorder(BorderFactory.createEmptyBorder());
		button.setToolTipText(MailProperties.textos.getString("tooltip_nuevo_clic_quitar"));
		button.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		button.setBorder(BorderFactory.createRaisedBevelBorder());
		button.addActionListener(new BotonEliminarListener(tipoIcono));
		panelElemento.add(button);
		
		if(tipoIcono.equalsIgnoreCase("attach"))
			listaBotonesADJ.add(button); // Almacenamiento botones en una linkedlist.
		else
			listaBotonesINL.add(button); // Almacenamiento botones en una linkedlist.

			
		// Posicionamiento de la informacin del archivo.
		JLabel label = new JLabel();
		if(!((fds.getName() == null)&&(fds.getContentType() == null))){
					
			StringBuffer sb = new StringBuffer();
			sb.append("<html>");
			if(fds.getName() != null)
				sb.append("<B>"+MailProperties.textos.getString("adjunto_nombre")+"</B> "+fds.getName()+" <br>");
			else
				sb.append("<B>"+MailProperties.textos.getString("adjunto_nombre")+"</B>- <br>");
					
			if(fds.getContentType() != null)
				sb.append("<B>"+MailProperties.textos.getString("adjunto_contenido")+"</B>"+fds.getContentType()+" <br>");
			else
				sb.append("<B>"+MailProperties.textos.getString("adjunto_contenido")+"</B>- ");
				
			if((fds.getFile().length()) != 0)
				sb.append("<B>"+MailProperties.textos.getString("adjunto_tamao")+"</B>"+cadenaTamao+" ");
			else
				sb.append("<B>"+MailProperties.textos.getString("adjunto_tamao")+"</B>- ");
				
			sb.append("</hmtl>");
			label.setText(sb.toString());
			panelElemento.add(label);
				
			if(tipoIcono.equalsIgnoreCase("attach"))
				panel3.add(panelElemento);
			else
				panel2.add(panelElemento);
					
		} else {
			label.setText(MailProperties.textos.getString("adjunto_sininfo"));
			panelElemento.add(label);
			
			if(tipoIcono.equalsIgnoreCase("attach"))
				panel3.add(panelElemento);
			else
				panel2.add(panelElemento);
		}
			
		if(tipoIcono.equalsIgnoreCase("attach")){
			tabbedPane.setEnabledAt(2, true);
			panel3.revalidate(); // Importante: actualiza el JPanel de adjuntos.
		} else {
			tabbedPane.setEnabledAt(1, true);
			panel2.revalidate(); // Importante: actualiza el JPanel de inlines.
		}
	}
	
	/* ---Mtodo anyadir_items--- */
	/* Aade los inlines y adjuntos definidos en los arrays al mensaje de correo. */
	private void anyadir_items(Multipart multipart) throws MessagingException{
	
		BodyPart messageBodyPart;
		DataSource dataSource;
		String[] partesCadena;
	
		// Primero los inlines.
		for(int i=0; i<listaInlines.size(); i++){
			messageBodyPart = new MimeBodyPart();
			dataSource = new FileDataSource((String) listaInlines.get(i));
			messageBodyPart.setDataHandler(new DataHandler(dataSource));
			
			partesCadena = ((String) listaInlines.get(i)).split(File.pathSeparator);
			messageBodyPart.setFileName(partesCadena[partesCadena.length-1]); // El fichero mantendr nombre original.
			messageBodyPart.setDisposition("INLINE");
			multipart.addBodyPart(messageBodyPart);
		}
	
		// Despus los attachments.
		for(int i=0; i<listaAdjuntos.size(); i++){
			messageBodyPart = new MimeBodyPart();
			dataSource = new FileDataSource((String) listaAdjuntos.get(i));
			messageBodyPart.setDataHandler(new DataHandler(dataSource));
			
			partesCadena = ((String) listaAdjuntos.get(i)).split(File.pathSeparator);
			messageBodyPart.setFileName(partesCadena[partesCadena.length-1]); // El fichero mantendr nombre original.
			messageBodyPart.setDisposition("ATTACHMENT");
			multipart.addBodyPart(messageBodyPart);
		}
	}
		
	/* ---Metodo guardar_mensaje--- */
	/* Guarda un mensaje de correo a una ruta dada en disco. Es reaprovechado tanto por
	 * la accin de Encolar, como por la de Guardar. */
	private void guardar_mensaje(String accion) throws IOException, MessagingException{
		
		String filepath = null;
		String filename = null;
		File file = null;
		
		if(accion.equalsIgnoreCase("Encolar")){
			filepath = MailProperties.path_ogre+cuentaMail.nombreCuenta+"/queued/";
			filename = "OgreMail_queued_file";
			file = new File(filepath+filename);
			for(int i=0; file.exists(); i++)
				file = new File(filepath+filename+i);
					
		} else if(accion.equalsIgnoreCase("Guardar")) {
			JFileChooser fc = new JFileChooser();
			int val = fc.showSaveDialog(this);
			if (val == JFileChooser.APPROVE_OPTION) {
				file = fc.getSelectedFile();
			} else {
				return;
			}
		}
			
		FileOutputStream fos = new FileOutputStream(file);
		BufferedOutputStream bos = new BufferedOutputStream(fos);
			
		message.writeTo(bos);
		bos.flush();
		bos.close();
		fos.close();
			
		if(accion.equalsIgnoreCase("Encolar")){
			/* Debe averiguar si el nodo queued esta seleccionado; si lo est, procede
			 * a la actualizacin de la tabla. Si no lo est, no la lleva a cabo.
			 */
			if((OgrePrincipal.node != null)&&(OgrePrincipal.node.toString().equalsIgnoreCase("queued"))) {
				omtm.fireTableDataChanged(); // NO actualiza la tabla?
				sorter.fireTableChanged(new TableModelEvent(omtm)); // Ahora SI la actualiza.
				sorter.fireTableDataChanged();
			}
		}
			
		// Cerramos la ventana.
		setVisible(false);
		dispose();
	}

}
