package gui;

import javax.mail.MessagingException;
import javax.mail.Multipart;
import javax.mail.Part;
import javax.mail.internet.MimeMessage;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextPane;
import javax.swing.JToolBar;
import javax.swing.JTree;
import javax.swing.KeyStroke;
import javax.swing.ListSelectionModel;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumn;
import javax.swing.table.TableModel;
import javax.swing.text.StyledEditorKit;
import javax.swing.text.html.HTMLEditorKit;
import javax.swing.tree.DefaultMutableTreeNode;
import base.CuentaMail;
import base.EmisorMail;
import base.GestorLocalMail;
import base.MailProperties;
import base.MainOgre;
import base.ReceptorMail;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Date;
import java.util.LinkedList;
import java.util.Timer;
import java.util.TimerTask;

/******************************************************************************
 * 																			  *
 *  Copyright 2004 Jordi Oliveras & Marcos Valerio. 						  *
 * 																			  *
 *  This file is part of Ogre.												  *
 *																			  *
 *  Ogre is free software; you can redistribute it and/or modify			  *
 *  it under the terms of the GNU General Public License as published by	  *
 *  the Free Software Foundation; either version 2 of the License, or		  *
 *  (at your option) any later version.										  *
 *																			  *
 *  Ogre is distributed in the hope that it will be useful,					  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of			  *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			  *
 *  GNU General Public License for more details.							  *
 *                       													  *
 *  You should have received a copy of the GNU General Public License         *
 *  along with Ogre; if not, write to the Free Software                       *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 * 																			  *
 ******************************************************************************
 *																	          *
 * OgrePrincipal - Constructor de la ventana principal de la aplicacin.      *      
 * 																			  *
 ******************************************************************************/

public final class OgrePrincipal {
	
	JFrame frame;
	CuentaMail cuentaMail; // = new CuentaMail(mailProperties);
	ArbolCuentas arbolCuentas;
	JTree treeCuentas;
	JTable tablaMails;
	OgreMailTableModel omtm;
	TableModel tablemodel;
	TableSorter2004 sorter;
	//OgreMenuBar menuBar;
	JTableHeader th;
	final JTextPane jtextpane, jtextpane2; // Contenido y Adjuntos.
	public static DefaultMutableTreeNode node;
	boolean switchSeleccion = true;
	String rutaAlFichero = null;
	StringBuffer sb;
	boolean esHtml, esText, partePrincipalMostrada;
	ArrayList listaAdjuntos = new ArrayList(); // ArrayList de adjuntos (guarda objetos del tipo Part).
	LinkedList listaBotones = new LinkedList(); // LinkedList de botones (guarda referencias a botones).
	LinkedList filasSeleccionadas = new LinkedList(); // LinkedList de filas seleccionadas.
	JTabbedPane tabbedPane;
	JPanel panel;
	GridBagLayout gridbag;
	GridBagConstraints constraints;
	public String opcion = null; // Indica si se copia o se corta.
	int o = 0;
	JPopupMenu tablaPopupMenu = new JPopupMenu();
	static boolean operacionCritica = false;
	boolean permitirHtml = false;
	static JButton buttonNuevo, buttonEnviar, buttonRecibir, buttonEnviarRecibir, buttonStop,
			buttonResponder, buttonReenviar, buttonGuardar, buttonEliminar, buttonCopiar,
			buttonCortar, buttonPegar;
	static JMenuItem menuItemNuevo, menuItemEnviar, menuItemRecibir, menuItemEnviarRecibir, menuItemStop,
			  menuItemResponder, menuItemReenviar, menuItemGuardar, menuItemEliminar, menuItemCopiar,
			  menuItemCortar, menuItemPegar, menuItemVerNormal, menuItemVerFuente;
	
	
	/* Constructor */
	public OgrePrincipal(JFrame aFrame, JSplitPane jsplitpane1, 
						 OgreMailTableModel aOmtm) throws IOException {
		
		frame = aFrame;
		jtextpane2 = null;
		omtm = aOmtm;
		
		cuentaMail = new CuentaMail();
		//cuentaMail.crear_cuenta_estatica(); //--> solucin espordica hasta que la gui permita crear cuentas
		
		OgreMenuBar omb = new OgreMenuBar(frame);

		desactivarBotonesCuenta();
		desactivarBotonesMail();
		
		/////////////////////////////
		// PARTE IZQUIERDA (JTree) //
		/////////////////////////////
		/* 1- Creamos el JTree izquierdo. */
		/* 2- Metemos el JTree en un JScrollPane. */
		/* 3- Creamos un JSplitPane1. */
		/* 4- Metemos el JScrollPane en la parte izquierda del JSplitpane1. */
		
		// Creamos el JTREE izquierdo (el de las cuentas).
		//JTree treeCuentas = crear_nodos_cuentas(); // ANTES!
		arbolCuentas = new ArbolCuentas(cuentaMail, omtm);
		treeCuentas = arbolCuentas.getTree();
		treeCuentas.addTreeSelectionListener(new CuentasTreeSelectionListener()); // Aadimos oyente de arboles.
		//Font fuente = treeCuentas.getFont();
		//System.out.println("Familia de la fuente del arbol: "+fuente.getFamily());
		//Font nuevaFuente = new Font("Dialog", Font.BOLD, 12);
		//treeCuentas.setFont(nuevaFuente);
		   	  
		// Creamos el JSCROLLPANE1 y le aadimos el JTree. 
		JScrollPane jscrollpane1 = new JScrollPane(treeCuentas);
		//jscrollpane1.setPreferredSize(new Dimension(140,200)); // Tamao default.		   	  
		jscrollpane1.setPreferredSize(new Dimension(140,285)); // Tamao default.
		
		// Ahora creamos el JSPLITPANE1 y aadimos el JSCrollPane al JSplitPane1.
		jsplitpane1.setLeftComponent(jscrollpane1); //jscrollpane1
		jsplitpane1.setOneTouchExpandable(true);
		
		//////////////////////////////////////////////////////
		// PARTE DERECHA (JSplitPane1 = JTree + JTextPane)  //
		//////////////////////////////////////////////////////
		/* 1- Creamos un JSplitPane2. */
		/* 2- Creamos el JTable derecho y el TableModel que se ocupar de l. */
		/* 3- Creamos un JScrollPane para esa JTable. */
		/* 4- Metemos ese JScrollPane al norte del JSplitpane2. */
		/* 5- Creamos un JEditorPane/JTextPane. */
		/* 6- Creamos un JScrollPane para ese JEditorPane/JTextPane. */
		/* 7- Creamos un JTabbedPane, al cual aadimos el JScrollPane anterior a la primera pestaa. */
		/* 8- Creamos otro JEditorPane, JScrollPane y pestaa del JTabbedPane y hacemos lo mismo. */
		/* 9- Metemos ese JTabbedPane al sur del JSplitPane2. */
		/* 10- Metemos el JSplitPane2 en la parte derecha del JSplitpane1. */
		
		// Creamos el JSPLITPANE2.
		JSplitPane jsplitpane2 = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
		jsplitpane2.setOneTouchExpandable(true);
		
		// Creamos el JTABLE derecho (el que contendra los mails).
		sorter = new TableSorter2004(omtm); /*** NEW implementacin TableSorter2004 ***/
		tablaMails = new JTable(sorter); /*** NEW implementacin TableSorter2004 ***/
		sorter.setTableHeader(tablaMails.getTableHeader()); /*** NEW implementacin TableSorter2004 ***/
		ListSelectionModel lsm = tablaMails.getSelectionModel();
		lsm.addListSelectionListener(new TablaMailsSelectionListener()); // Listener para seleccion de filas
		
		OgreTableRenderer otr = new OgreTableRenderer();
		tablaMails.setDefaultRenderer(Object.class, otr);
		tablaMails.setDefaultRenderer(Date.class, otr);
		//tablaMails.setGridColor(Color.lightGray); // <-- Cambio de colores de la rejilla... si o no?
		tablaMails.setShowGrid(false);
		
		/* JPopupMenu */
		/* Aadimos un listener a tablaPopupMenu y tablaMails, y finalmente aadimos 
		 * a tablaMails el tablaPopupMenu. */ 
		tablaPopupMenu.addMouseListener(new PopupListener());
		tablaMails.addMouseListener(new PopupListener());
		tablaMails.add(tablaPopupMenu); // Adicin de popupMenu a tablaMails.
		
		// Recorremos las columnas de la tabla para definirles unos tamaos por defecto.
		TableColumn column;
		for(int i=0; i<tablaMails.getColumnCount(); i++){
			column = tablaMails.getColumnModel().getColumn(i);
			if(i==0){ // Columna Expandir.
				column.setPreferredWidth(10);
				column.setMaxWidth(10);
			}
			else if(i==1) // Columna Asunto.
				column.setPreferredWidth(175);
			else if(i==2) // Columna De.
				column.setPreferredWidth(175);
			else // Columna Fecha.
				column.setPreferredWidth(100);
		}
		
		// Creamos el JSCROLLPANE2 y le aadimos el JTable. 
		JScrollPane jscrollpane2 = new JScrollPane(tablaMails);
		jscrollpane2.setPreferredSize(new Dimension(500,140)); // Tamao default
		
		// Aadimos el jscrollpane2 arriba del JSPLITPANE2.
		jsplitpane2.setTopComponent(jscrollpane2);
		
		// Creamos el JTEXTPANE para contenidos del mail.
		jtextpane = new JTextPane();
		jtextpane.setEditable(false);
		
		// Lo aadimos a un JSCROLLPANE3.
		JScrollPane jscrollpane3 = new JScrollPane(jtextpane);
		jscrollpane3.setPreferredSize(new Dimension(500,140)); // Tamao default.
		
		// Creamos el JTabbedPane con 2 pestaas; correo y adjuntos.
		tabbedPane = new JTabbedPane();
		tabbedPane.addTab(MailProperties.textos.getString("pestaa_contenido"), new ImageIcon(getClass().getResource("/iconos/Contenido_25x20.png")), (Component) jscrollpane3, MailProperties.textos.getString("tooltip_pestaa_contenido"));
		tabbedPane.setSelectedIndex(0);
		tabbedPane.setEnabledAt(0, false);
		
		// Este JPanel guardar cada panel que conforma cada adjunto.
		panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
		
		// Lo aadimos a un JSCROLLPANE4.
		JScrollPane jscrollpane4 = new JScrollPane(panel);
		jscrollpane4.setPreferredSize(new Dimension(500,140)); // Tamao default.
		
		// Y lo metemos en una segunda y ultima pestaa del JTabbedPane.
		tabbedPane.addTab(MailProperties.textos.getString("pestaa_adjuntos"), new ImageIcon(getClass().getResource("/iconos/Adjuntar_25x20.png")), (Component) jscrollpane4, MailProperties.textos.getString("tooltip_pestaa_adjuntos"));
		tabbedPane.setEnabledAt(1, false);
		
		// Aadimos el tabbedPane abajo del jsplitpane2.
		jsplitpane2.setBottomComponent(tabbedPane);
		
		// Y aadimos el JScrollPane2 al JSplitpane1.
		jsplitpane1.setRightComponent(jsplitpane2);
	}
	
	/////////////////////////////////////////////
	// CLASES LISTENERS (como clases privadas) //
	/////////////////////////////////////////////
	
	/* CuentasTreeSelectionListener - Oyente de seleccion del JTree derecho. */
	/* Vigila las selecciones del usuario de los nodos. */
	private class CuentasTreeSelectionListener implements TreeSelectionListener {
		
		public void valueChanged(TreeSelectionEvent e){
			
			desactivarBotonesMail();
			node = (DefaultMutableTreeNode) (e.getPath().getLastPathComponent());
			if((node.isLeaf())&&(!node.toString().equalsIgnoreCase(MailProperties.textos.getString("nodo_cuentas")))){ // El nodo seleccionado no tiene hijos (es una hoja).
				
				// Limpieza.
				filasSeleccionadas.clear(); /***NEU_14-5-2004***/
				rutaAlFichero = null; /***NEU_14-5-2004***/
				
				// Reseteo del estado del jtextpane y de las pestaas.
				jtextpane.setText("");
				tabbedPane.setEnabledAt(0, false);
				tabbedPane.setEnabledAt(1, false);
				
				activarBotonesCuenta();
				
				/* Tambin comprobamos si cambi de cuenta sin pasar por el nodo padre, 
				 * en cuyo caso cambiaremos la cuenta en la que estamos. */
				if(!node.getParent().toString().equals(cuentaMail.nombreCuenta)){
					try {
						cuentaMail.seleccionar_cuenta(node.getParent().toString());
					} catch (IOException e1) {
						desactivarBotonesCuenta();
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_dir")+e1.getLocalizedMessage()+MainOgre.mensajeErrorEstandard, "Error", JOptionPane.ERROR_MESSAGE);
						e1.printStackTrace();
					} catch (ClassNotFoundException e1) {
						desactivarBotonesCuenta();
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_dir")+e1.getLocalizedMessage()+MainOgre.mensajeErrorEstandard, "Error", JOptionPane.ERROR_MESSAGE);
						e1.printStackTrace();
					}
					cuentaMail.mostrar_cuenta(); // DEBUG
				}
				
				/* Tambin comprobamos si debemos activar la funcin de Pegar. */
				if(opcion!=null){
					if((opcion.equalsIgnoreCase("Copiar"))||(opcion.equalsIgnoreCase("Cortar"))){
						buttonPegar.setEnabled(true);
						menuItemPegar.setEnabled(true);
					}
				}	
				
				if(MainOgre.verboso) System.out.println("El nodo "+node.toString()+" es un directorio."); //DEBUG
				// Debemos mostrar el contenido del directorio.
				/* Obtenemos el contenido del directorio, lanzamos un evento
				 * para que la tabla se actualice y redibuje. */

				/* Paso de info. a OgreMailTableModel. */
				 omtm.setCuentaMail(cuentaMail);
				 
				 if(arbolCuentas.borrarCuenta==true)
					omtm.setNodo("TABLA_VACIA"); // Informamos al TableModel de la inexistencia del nodo.
				 else
				 	omtm.setNodo(node.toString()); // Informamos al TableModel del cambio de nodo.
				 
				 /* Actualizacion del contenido de la tabla. */
				 omtm.fireTableDataChanged(); // Para mostrar los mails de ese directorio.
				 
			} else {
				
				// Limpieza.
				filasSeleccionadas.clear(); /***NEU_14-5-2004***/
				rutaAlFichero = null; /***NEU_14-5-2004***/ // "Deseleccionamos" cualquier mail (fila) que pudiera haber antes.
				
				// Reseteo del estado del jtextpane y de las pestaas.
				jtextpane.setText("");
				tabbedPane.setEnabledAt(0, false);
				tabbedPane.setEnabledAt(1, false);
				
				if(node.getParent() != null){
					if(MainOgre.verboso) System.out.println("El nodo "+node.toString()+" es una Cuenta."); //DEBUG
					
					// Debemos seleccionar la cuenta.
					try {
						cuentaMail.seleccionar_cuenta(node.toString());
						activarBotonesCuenta();
					} catch (IOException e1) {
						desactivarBotonesCuenta();
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_cuenta")+e1.getLocalizedMessage()+MainOgre.mensajeErrorEstandard, "Error", JOptionPane.ERROR_MESSAGE);
						e1.getMessage();
						e1.printStackTrace();
					} catch (ClassNotFoundException e1) {
						desactivarBotonesCuenta();
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_cuenta")+e1.getLocalizedMessage()+MainOgre.mensajeErrorEstandard, "Error", JOptionPane.ERROR_MESSAGE);
						e1.getMessage();
						e1.printStackTrace();
					}
					cuentaMail.mostrar_cuenta(); // DEBUG
					
				} else {
					if(MainOgre.verboso) System.out.println("El nodo "+node.toString()+" es el nodo principal Cuentas."); // DEBUG: En este caso no hacemos nada.
					/* Si se quiere hacer esto cabe controlar que, si se est llevando a
					 * cabo alguna operacin crtica, cuando se vuelva a seleccionar esa
					 * misma cuenta, se activen slo los botones correctos al contexto, y no
					 * todos. */ 
					desactivarBotonesCuenta();
				}
				
				/* Tambin comprobamos si debemos desactivar la funcin de Pegar. */
				if(opcion!=null){
					if((opcion.equalsIgnoreCase("Copiar"))||(opcion.equalsIgnoreCase("Cortar"))){
						buttonPegar.setEnabled(false);
						menuItemPegar.setEnabled(false);
					}
				}
				
				// Limpieza tabla.
				omtm.setCuentaMail(cuentaMail); /**/
				omtm.setNodo("TABLA_VACIA"); /**/
				omtm.fireTableDataChanged(); /**/
			}
		}
	}
	
	/* TablaMailsSelectionListener - Oyente de seleccion de la tabla contenedora de los mails. */
	/* Vigila las selecciones del usuario de las filas. Tambin se encargar del visualizado
	 * del contenido de cada mail, as como de la gestin de ste visualizado. */
	private class TablaMailsSelectionListener implements ListSelectionListener {
		
		public void valueChanged(ListSelectionEvent e) {
			
			//if(switchSeleccion){ // Switch para generar 1 evento, en lugar de 2.
			
			/* Por ahora usamos esto en lugar del switch; hay que ver si sigue funcionando
			 * para mltiples selecciones (su 'else'). Deberamos permitir las mltiples 
			 * selecciones para realizar operaciones sobre un nmero indeterminado de
			 *  mensajes de correo. */
			//activarBotonesMail();
			 
			if(!e.getValueIsAdjusting()){
				o=0;
				if(MainOgre.verboso) System.out.println("!e.getValueIsAdjusting()"); //DEBUG
			
				ListSelectionModel lsm = (ListSelectionModel)e.getSource();
				//boolean isAdjunsting = e.getValueIsAdjusting();
				if (lsm.isSelectionEmpty()) {
					if(MainOgre.verboso) System.out.println("Ninguna fila seleccionada."); //DEBUG
				} else {
					activarBotonesMail();
					// Desactivamos la pestaa 'Contenidos' y 'Adjuntos'.
					tabbedPane.setEnabledAt(0, false);
					tabbedPane.setEnabledAt(1, false);
					
					int firstSelectedRow = lsm.getMinSelectionIndex();
					int lastSelectedRow = lsm.getMaxSelectionIndex();
					if(MainOgre.verboso) System.out.print("Filas seleccionadas: "); //DEBUG
					for(int i=firstSelectedRow; i<=lastSelectedRow; i++){
						if(lsm.isSelectedIndex(i)){
							filasSeleccionadas.add(new Integer(i)); // Guardamos las filas seleccionadas.			
							if(MainOgre.verboso) System.out.print(i+" "); //DEBUG
						}
					}
					
					if(MainOgre.verboso) System.out.println("Fila "+firstSelectedRow+" seleccionada.");  //DEBUG
					/* MUY IMPORTANTE: interactuamos con los datos de la tabla proporcionada 
				 	* por el sorter. Si no lo hacemos as, despus de una ordenacin de la 
				 	* tabla, cuando se selecciona una fila, su contenido no se corresponde
				 	* con lo que realmente contiene, sino con el contenido de la fila que se
				 	* hallaba en esa posicin ANTES de realizar el sort. */
					String fichero = sorter.getValueAt(firstSelectedRow, tablaMails.getColumnCount()).toString();
					//System.out.println("Nombre fichero:"+fichero); //DEBUG
					rutaAlFichero = MailProperties.path_ogre+cuentaMail.nombreCuenta+"/"+node.toString()+"/"+fichero; 
					//System.out.println("Ruta al fichero: "+rutaAlFichero); //DEBUG
					//System.out.println("*****"); //DEBUG
					// Antes de aplicar el TableSorter; ahora innecesario.
					//String rutaAlFichero = omtm.mostrarMail(selectedRow);
					//gestion_mensaje(rutaAlFichero);
					
					Runnable r = new Runnable(){
						public void run(){
							try { 
								gestion_mensaje(rutaAlFichero);
							} catch(Exception e){
								JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_gestion_correo")+MainOgre.mensajeErrorEstandard, "Error", JOptionPane.ERROR_MESSAGE);
								e.getMessage();
								e.printStackTrace();
							}
						} 
					};
					Thread t = new Thread(r);
					t.start();
					
					//gestion_mensaje(rutaAlFichero);
					//switchSeleccion = !switchSeleccion;
				}
			
			} else {
				//switchSeleccion = !switchSeleccion;
				if(MainOgre.verboso) System.out.println("e.getValueIsAdjusting()"); //DEBUG
				filasSeleccionadas.clear();
			}
		}
	}

	/* PopupListener - Oyente de clics derechos del ratn en filas de la JTable. */	
	private class PopupListener extends MouseAdapter {
		
		public void mousePressed(MouseEvent e){
			if(rutaAlFichero != null)
				maybeShowPopup(e);
		}
	
		public void mouseReleased(MouseEvent e){
			if(rutaAlFichero != null)
				maybeShowPopup(e);
		}
	
		private void maybeShowPopup(MouseEvent e){
			//if(rutaAlFichero != null){
			if(!filasSeleccionadas.isEmpty()){
				if (e.isPopupTrigger()) {
					//System.out.println("Clic del ratn para Men!"); // DEBUG
					tablaPopupMenu.show(e.getComponent(), e.getX(), e.getY());
				}
			}
		}
	}
	
	/* MiHyperlinkListener - Oyente de los enlaces de las webs mostradas en jeditorpane. */
	private class MiHyperlinkListener implements HyperlinkListener {

		public void hyperlinkUpdate(HyperlinkEvent ev) {
			HyperlinkEvent.EventType type = ev.getEventType();
			
			if(type == HyperlinkEvent.EventType.ACTIVATED){
				try {
					// Hacer que el jeditorpane abra esa web (a modo de browser).
					jtextpane.setPage(ev.getURL());
				} catch(Exception e) {
					JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_enlace")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
					e.getMessage();
					e.printStackTrace();
				}
			}
		}
		
	}
	
	/* BotonGuardarListener - Oyente de los clics a los botones de los adjuntos procesados
	 * en un mensaje. Coger la parte relacionada con el botn pulsado y abrir un dilogo 
	 * de guardar fichero para almacenarlo en el lugar y con el nombre que indique el usuario. */
	private class BotonGuardarListener implements ActionListener {

		public void actionPerformed(ActionEvent ev) {
			
			try {
				int i;
				JButton button = (JButton) ev.getSource();
				//System.out.println("listaBotones.size(): "+listaBotones.size()); //DEBUG
				
				for(i=0; i<listaBotones.size(); i++){
					
					if(((JButton) listaBotones.get(i)).equals(button)){
						//System.out.println("El adjunto relacionado con este boton es "+listaAdjuntos.get(i)); //DEBUG
						
						JFileChooser fc = new JFileChooser();
						int val = fc.showSaveDialog(null);
						if (val == JFileChooser.APPROVE_OPTION) {
							
							File file = fc.getSelectedFile();
							FileOutputStream fos = new FileOutputStream(file);
							BufferedOutputStream bos = new BufferedOutputStream(fos);
							
							InputStream is = ((Part) listaAdjuntos.get(i)).getInputStream();
							BufferedInputStream bis = new BufferedInputStream(is);
							
							// Lectura/Escritura byte a byte.
							int c;
							while((c = bis.read()) != -1){
								bos.write(c);
							}
						
							bos.flush();
							bis.close();
							bos.close();
							fos.close();
							
						} else {
							return;
						}
						
						break;	
					}
					//System.out.println("Vuelta "+i+"."); //DEBUG
				}
				
				/*if(i == listaBotones.size())
					System.out.println("Adjunto NO encontrado!"); //DEBUG*/
				
			} catch(Exception e){
				JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_guardar_adjunto")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
				e.getMessage();
				e.printStackTrace();
			}
		}
	}
	
	/////////////
	// MT0D0S //
	/////////////
		
	/* ---Mtodo gestion_mensaje--- */
	/* Se encarga de averiguar las partes de un mensaje. */
	private void gestion_mensaje(String rutaAlFichero) throws MessagingException, IOException, FileNotFoundException {
		
		if(MainOgre.verboso) System.out.println("En gestion_mensaje()..."); // DEBUG
		
		int resultado;
			
		// Limpieza arrays de datos del mensaje anterior (adjuntos y botones).
		listaAdjuntos.clear();
		listaBotones.clear();
		jtextpane.setText("");
		panel.removeAll(); // Reseteo del panel de adjuntos.
		panel.invalidate();
			
		/* Debemos mostrar el contenido del mail de esa fila. Para ello,
		 * pedimos a OgreMailTableModel la ruta a dicho fichero, construimos
		 * un MimeMessage con el, y averiguamos las partes de las cuales se compone. */
		MimeMessage message = new MimeMessage(null, new FileInputStream(rutaAlFichero));
					
		sb = new StringBuffer();
		/**/
			
		// 1 - El objeto es Multipart o no?
		Object obj = message.getContent();
		if(obj instanceof Multipart)
			resultado = gestion_multipart((Multipart) obj);
		else
			resultado = gestion_part(message);
		
		if(resultado!=0) return;
			
		// 2 - Invocamos a la gestin de adjuntos.
		gestion_adjuntos();
				
		if(!esHtml){
				
			// Activamos la pestaa 'Contenidos'.
			tabbedPane.setEnabledAt(0, true);
				
			// StyledEditorKit.
			jtextpane.setEditorKit(new StyledEditorKit());
				
			// Formas correctas de borrar el contenido del JTextPane:					
			/*1*/jtextpane.setText("");	
			/*2*///jtextpane.getDocument().remove(0, jtextpane.getDocument().getLength());
			
			jtextpane.setText(sb.toString());
			jtextpane.setCaretPosition(0);
			sb.delete(0,sb.length()); // Luego vaciamos el sb.
		}
				
		// Limpieza variables miembro.
		partePrincipalMostrada = false;
		esHtml = false;
		if(permitirHtml==true) permitirHtml = false;
	}
	
	/* ---Mtodo gestion_part--- */
	/* Se encarga de gestionar las partes del mensaje (las "indivisibles"). */
	private int gestion_part(Part part) throws MessagingException, IOException {
		
		if(MainOgre.verboso) System.out.println("En gestion_part()..."); //DEBUG
			
		Object obj = null;
		esHtml = part.isMimeType("text/html");
		esText = part.isMimeType("text/plain");
		if(MainOgre.verboso) System.out.println("part.getContentType(): "+part.getContentType()); //DEBUG
			
		try {
			
		/////////////////////////////////////////
		// Gestin de la/s parte/s del message //
	
		obj = part.getContent();	
		if(obj instanceof String){
				
			if(MainOgre.verboso) System.out.println("*String message*"); //DEBUG
						
			if(esHtml){ // A2 (html + string).
					
				if(MainOgre.verboso) System.out.println("El *String message* es html."); //DEBUG
					
				if(!partePrincipalMostrada){	
					
					// Prevencin caso que el usuario no quiera mostrar los correos html.
					if((!MailProperties.jck2)&&(permitirHtml==false)){
						ogreInformacion("html");
//						jtextpane.setText("Opcin de mostrar mensajes HTML deshabilitada. " +
//							"\n\nPuede habilitarla desde el men 'Configuracin' -> 'Preferencias' -> 'General' -> 'Cargar mensajes HTML', " +
//							"o bien puede visualizar el mensaje de correo desde el men 'Ver' -> 'Mensaje normal'.");
						return 1;
					}
					
					if(MainOgre.verboso) System.out.println("Se muestra como parte ppal."); //DEBUG
						
					// Borramos el mensaje html previo... o hacemos una cache de mensajes html?
					File file = new File(MailProperties.path_ogre+cuentaMail.nombreCuenta+"/htmlTemporal.html");
					file.delete();
						
					FileWriter fw = new FileWriter(MailProperties.path_ogre+cuentaMail.nombreCuenta+"/htmlTemporal.html");
					fw.write(obj.toString());
					fw.flush();
					fw.close();
									
					// Activamos la pestaa 'Contenidos'.
					tabbedPane.setEnabledAt(0, true);
									
					// Formas correctas de borrar el contenido del JTextPane:					
					/*1*/jtextpane.setText("");	
					/*2*///jtextpane.getDocument().remove(0, jtextpane.getDocument().getLength());
									
					// HTMLEditorKit.
					jtextpane.setEditorKit(new HTMLEditorKit());
						
					// Listener para gestionar enlaces.
					jtextpane.addHyperlinkListener(new MiHyperlinkListener());
									
					jtextpane.setPage("file:"+MailProperties.path_ogre+cuentaMail.nombreCuenta+"/htmlTemporal.html");
					jtextpane.setCaretPosition(0);
					partePrincipalMostrada = true;
					if(MainOgre.verboso) System.out.println("file:"+MailProperties.path_ogre+cuentaMail.nombreCuenta+"/htmlTemporal.html"); //DEBUG
						
				} else {
					if(MainOgre.verboso) System.out.println("Se trara como adjunto."); //DEBUG
					listaAdjuntos.add(part);
					if(MainOgre.verboso) System.out.println("Fichero "+part.getFileName()+" adjunto (es un html)."); //DEBUG
				}
					
			} else if(esText){ // B2 (text u otro + string).
					
				if(MainOgre.verboso) System.out.println("El *String message* es txt."); //DEBUG
				
				//***** if(!partePrincipalMostrada){
						
					if(MainOgre.verboso) System.out.println("Se muestra como parte ppal. al final."); //DEBUG
						
					// En lugar de introducir... guardar en buffer.
					Object obj2 = part.getContent();
					sb.append(obj2.toString());
					if(MainOgre.verboso) System.out.println("Aadimos: "+sb.toString());
						
					// Formas correctas de introducir contenido al JTextPane:
					/*1*///jtextpane.setText(obj.toString());
					/*2*///jtextpane.getDocument().insertString(0, obj.toString(), null);
						
					partePrincipalMostrada = true;
						
				/*} else {
					System.out.println("Se trara como adjunto."); //DEBUG
					listaAdjuntos.add(part);
					System.out.println("Fichero "+part.getFileName()+" adjunto (es un txt)."); //DEBUG 
				}*/ //*****
					
			} else {
				listaAdjuntos.add(part);
				if(MainOgre.verboso) System.out.println("Fichero "+part.getFileName()+" adjunto."); //DEBUG
			}
							
		} else if(obj instanceof InputStream){ // A3 y B3.
							
			if(MainOgre.verboso) System.out.println("*InputStream message*"); //DEBUG
			/* Aqu se debera buscar alguna forma de representar en el mensaje 
		 	* mostrado por el JTextPane, que hay un adjunto. */
			listaAdjuntos.add(part);
			if(MainOgre.verboso) System.out.println("Fichero "+part.getFileName()+" adjunto."); //DEBUG
						
		} else if(obj instanceof Multipart){ // A4 y B4.
				
			if(MainOgre.verboso) System.out.println("*Multipart message*"); //DEBUG
			gestion_multipart((Multipart) obj);
				
		} else // A5 y B5.
			if(MainOgre.verboso) System.out.println("No se qu tipo de objeto casa con este mensaje!"); //DEBUG
		
		} catch(UnsupportedEncodingException uexc){
			ogreInformacion(uexc.getMessage());
//			jtextpane.setText("Codificacin "+uexc.getMessage()+" no soportada; no se puede mostrar el contenido del correo. " +
//				"\n\nAn as, si lo desea, puede visualizar el contenido del mensaje de correo desde el men 'Ver' -> 'Fuente mensaje'.");
			return 1;
		} catch(IOException ioe){
			JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_mostrar_mensaje")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
			ioe.getMessage();
			ioe.printStackTrace();
		}
			
		return 0;
				
	}
			
	/* ---Mtodo gestion_multipart--- */
	/* Gestiona las diferentes partes de un mensaje. */
	private int gestion_multipart(Multipart multipart) throws MessagingException, IOException {
			
		int resultado = 0;
			
		for(int i=0; i<multipart.getCount(); i++){
			resultado = gestion_part(multipart.getBodyPart(i));
			if(resultado==1) break;
		}
			
		return resultado;
	}
			
	/* ---Mtodo gestion_adjuntos--- */
	/* Gestiona los adjuntos del mensaje. */
	private void gestion_adjuntos() throws MessagingException, IOException {
		
		if(MainOgre.verboso) System.out.println("listaAdjuntos: "+listaAdjuntos); // DEBUG
			
		panel.removeAll();
			
		if(!listaAdjuntos.isEmpty()){
			tabbedPane.setEnabledAt(1, true);

			for(int i=0; i<listaAdjuntos.size(); i++){
				
				if(MainOgre.verboso) System.out.println("Adjunto: "+ ++o+"."); // DEBUG
					
				Part part = (Part) listaAdjuntos.get(i);
				String nombre = part.getFileName();
				String descripcion = part.getDescription();
				String contenido = part.getContentType();
				int tamao = part.getSize();
				String icono;
				String cadenaTamao;
					
				// Pequeo clculo de tamao.
				if(tamao<1024){
					cadenaTamao = new String(tamao+" byte/s");
				} else if(tamao<1048576){
					cadenaTamao = new String(tamao/1024+" Kbyte/s");
				} else {
					cadenaTamao = new String(tamao/1048576+" Mbyte/s");
				}
					
				// Este panel(panelElemento) guarda el dueto boton + descripcion de un adjunto.
				FlowLayout fl = new FlowLayout(FlowLayout.LEFT);
				fl.setHgap(5);
				fl.setVgap(5);
				JPanel panelElemento = new JPanel(fl);
					
				// Identificacin tipo mime del adjunto para representar el icono.
				if(part.isMimeType("text/*")){
					if(part.isMimeType("text/plain"))
						icono = "text_plain";
					else if(part.isMimeType("text/richtext"))
						icono = "text_rich";
					else if(part.isMimeType("text/html"))
						icono = "text_html";
					else
						icono = "text_plain";
				}
				else if(part.isMimeType("image/*"))
					icono = "image";
				else if(part.isMimeType("audio/*"))
					icono = "audio";
				else if(part.isMimeType("video/*"))
					icono = "video";
				else if(part.isMimeType("application/*")){
					if((part.isMimeType("application/arj"))||
					(part.isMimeType("application/x-bzip"))||
					(part.isMimeType("application/x-bzip2"))||
					(part.isMimeType("application/x-compressed"))||
					(part.isMimeType("application/x-gzip"))||
					(part.isMimeType("application/x-tar"))||
					(part.isMimeType("application/gnutar"))||
					(part.isMimeType("application/x-zip-compressed"))||
					(part.isMimeType("application/zip"))||
					(part.isMimeType("application/rar")))
						icono = "application_compressed";
					else if(part.isMimeType("application/pgp-signature"))
						icono = "application_signature";
					else
						icono = "application";
				}
				else
					icono = "unknown";
					
				JButton button = new JButton(new ImageIcon(getClass().getResource("/images/"+icono)));
				button.setPreferredSize(new Dimension(55,70));
				button.setBorder(BorderFactory.createEmptyBorder());
				button.setToolTipText(MailProperties.textos.getString("tooltip_clic"));
				button.setBorder(BorderFactory.createLineBorder(Color.BLACK));
				button.setBorder(BorderFactory.createRaisedBevelBorder());
				button.addActionListener(new BotonGuardarListener());
				panelElemento.add(button);
				listaBotones.add(button); // Almacenamiento botones en una linkedlist.
					
				// Posicionamiento de la informacin del archivo.
				JLabel label = new JLabel();
				if(!((nombre == null)&&(descripcion == null)&&(contenido == null))){
					
					StringBuffer sb = new StringBuffer();
					sb.append("<html>");
					if(nombre != null)
						sb.append("<B>"+MailProperties.textos.getString("adjunto_nombre")+"</B> "+nombre+" <br>");
					else
						sb.append("<B>"+MailProperties.textos.getString("adjunto_nombre")+"</B>- <br>");
					
					if(descripcion != null)
						sb.append("<B>"+MailProperties.textos.getString("adjunto_descripcion")+"</B>"+descripcion+" <br>");
					else
						sb.append("<B>"+MailProperties.textos.getString("adjunto_descripcion")+"</B>- <br>");
					
					if(contenido != null)
						sb.append("<B>"+MailProperties.textos.getString("adjunto_contenido")+"</B>"+contenido+" <br>");
					else
						sb.append("<B>"+MailProperties.textos.getString("adjunto_contenido")+"</B>- ");
						
					if(tamao != 0)
						sb.append("<B>"+MailProperties.textos.getString("adjunto_tamao")+"</B>"+cadenaTamao+" ");
					else
						sb.append("<B>"+MailProperties.textos.getString("adjunto_tamao")+"</B>- ");
							
					sb.append("</hmtl>");
					label.setText(sb.toString());
					panelElemento.add(label);
					panel.add(panelElemento);
				} else {
					label.setText(MailProperties.textos.getString("adjunto_sininfo"));
					panelElemento.add(label);
					panel.add(panelElemento);
				}
			}
			
		} else {
			tabbedPane.setEnabledAt(1, false);
		}
		panel.revalidate(); // Importante: actualiza el JPanel de adjuntos.
	}
	
	/* ---Mtodo ogreInformacion--- */
	/* Muestra una informacin 'contextual' en HTML por el jtextpane. Esto es til en
	 * tanto que distingue aquella informacin que presenta la aplicacin al usuario del 
	 * contenido HTML que puedan tener otros mensajes (lo hacen estndard y familiar
	 * para el usuario). */
	private void ogreInformacion(String contexto) throws IOException{
		
		String mensaje;
		
		// HTMLEditorKit.
		jtextpane.setEditorKit(new HTMLEditorKit());
						
		// Listener para gestionar enlaces.
		jtextpane.addHyperlinkListener(new MiHyperlinkListener());
		
		if(contexto.equalsIgnoreCase("html")){

			mensaje = "<html>" +
					  "<body>" +
					  "<h1><font color=red>"+MailProperties.textos.getString("ogreinfo")+"</font></h1>" +
					  MailProperties.textos.getString("ogreinfo_html") +
					  "</body>" +
					  "</html>";
			
		} else {

			mensaje = "<html>" +
					  "<body>" +
					  "<h1><font color=red>"+MailProperties.textos.getString("ogreinfo")+"</font></h1>" +
					  MailProperties.textos.getString("ogreinfo_charset") + contexto +
					  MailProperties.textos.getString("ogreinfo_charset2") +
					  "</body>" +
					  "</html>";
		}
		
		// Borramos el mensaje html previo... o hacemos una cache de mensajes html?
		File file = new File(MailProperties.path_ogre+cuentaMail.nombreCuenta+"/htmlTemporal.html");
		file.delete();
		FileWriter fw = new FileWriter(file);
		fw.write(mensaje);
		fw.close();
		
		// Activamos la pestaa 'Contenidos'.
		tabbedPane.setEnabledAt(0, true);
		
		jtextpane.setPage("file:"+MailProperties.path_ogre+cuentaMail.nombreCuenta+"/htmlTemporal.html");
		jtextpane.setCaretPosition(0);
		
	}
	
	/* ---Mtodo desactivacionParar--- */
	public static void desactivacionParar(){
		buttonStop.setEnabled(false);
		menuItemStop.setEnabled(false);
	}
		
	/* ---Mtodo activacionParar--- */
	public static  void activacionParar(){
		buttonStop.setEnabled(true);
		menuItemStop.setEnabled(true);
	}
		
	/* ---Mtodo desactivacionBotonesCriticos--- */
	/* Desactiva botones que pueden ser crticos dejar activos mientras alguno de ellos
	 * est llevando a cabo alguna operacin. Garantizaremos as la secuencialidad de
	 * las operaciones de stos. Tambin activa el flag indicador de una operacin 
	 * crtica en curso. */
	public static void desactivacionBotonesCriticos(){
		operacionCritica = true; // Para avisar a OgreNuevoMail.
		buttonEnviar.setEnabled(false);
		buttonRecibir.setEnabled(false);
		buttonEnviarRecibir.setEnabled(false);
		menuItemEnviar.setEnabled(false);
		menuItemRecibir.setEnabled(false);
		menuItemEnviarRecibir.setEnabled(false);
	}
		
	/* ---Mtodo activacionBotonesCriticos--- */
	/* Vuelve a activar los botones que fueron desactivados por seguridad, una vez que
	 * uno de los botones crticos ha acabado con su operacin y desactiva el flag
	 * indicador de una operacin crtica en curso.*/
	public static void activacionBotonesCriticos(){
		buttonEnviar.setEnabled(true);
		buttonRecibir.setEnabled(true);
		buttonEnviarRecibir.setEnabled(true);
		menuItemEnviar.setEnabled(true);
		menuItemRecibir.setEnabled(true);
		menuItemEnviarRecibir.setEnabled(true);
		operacionCritica = false; // Para avisar a OgreNuevoMail.
	}
	
	/* ---Mtodo activarBotonesCuenta--- */
	/* Activa aquellos botones que necesitan de una cuenta para operar. */
	private void activarBotonesCuenta(){
		buttonNuevo.setEnabled(true);
		buttonStop.setEnabled(true);
		menuItemNuevo.setEnabled(true);
		menuItemStop.setEnabled(true);
		
		if((EmisorMail.enviando == false)&&(ReceptorMail.recibiendo == false)){
			buttonEnviar.setEnabled(true);
			buttonRecibir.setEnabled(true);
			buttonEnviarRecibir.setEnabled(true);
			menuItemEnviar.setEnabled(true);
			menuItemRecibir.setEnabled(true);
			menuItemEnviarRecibir.setEnabled(true);
		}
	}
	
	/* ---Mtodo desactivarBotonesCuenta--- */
	/* Desactiva aquellos botones que necesitan de una cuenta para operar. */
	private void desactivarBotonesCuenta(){
		buttonNuevo.setEnabled(false);
		buttonEnviar.setEnabled(false);
		buttonRecibir.setEnabled(false);
		buttonEnviarRecibir.setEnabled(false);
		buttonStop.setEnabled(false);
		menuItemNuevo.setEnabled(false);
		menuItemEnviar.setEnabled(false);
		menuItemRecibir.setEnabled(false);
		menuItemEnviarRecibir.setEnabled(false);
		menuItemStop.setEnabled(false);
	}
	
	/* ---Mtodo activarBotonesMail--- */
	/* Activa aquellos botones que necesitan de una seleccin de mail para operar. */
	private void activarBotonesMail(){
		buttonResponder.setEnabled(true);
		buttonReenviar.setEnabled(true);
		buttonGuardar.setEnabled(true);
		buttonEliminar.setEnabled(true);
		buttonCopiar.setEnabled(true);
		buttonCortar.setEnabled(true);
		//buttonPegar.setEnabled(true);
		menuItemResponder.setEnabled(true);
		menuItemReenviar.setEnabled(true);
		menuItemGuardar.setEnabled(true);
		menuItemEliminar.setEnabled(true);
		menuItemCopiar.setEnabled(true);
		menuItemCortar.setEnabled(true);
		menuItemVerNormal.setEnabled(true);
		menuItemVerFuente.setEnabled(true);
		//menuItemPegar.setEnabled(true);
	}
	
	/* ---Mtodo desactivarBotonesMail--- */
	/* Desactiva aquellos botones que necesitan de una seleccin de mail para operar. */
	private void desactivarBotonesMail(){
		buttonResponder.setEnabled(false);
		buttonReenviar.setEnabled(false);
		buttonGuardar.setEnabled(false);
		buttonEliminar.setEnabled(false);
		buttonCopiar.setEnabled(false);
		buttonCortar.setEnabled(false);
		//buttonPegar.setEnabled(false);
		menuItemResponder.setEnabled(false);
		menuItemReenviar.setEnabled(false);
		menuItemGuardar.setEnabled(false);
		menuItemEliminar.setEnabled(false);
		menuItemCopiar.setEnabled(false);
		menuItemCortar.setEnabled(false);
		menuItemVerNormal.setEnabled(false);
		menuItemVerFuente.setEnabled(false);
		//menuItemPegar.setEnabled(false);
	}
	
	//////////////////////////////////////
	// CLASES INTERNAS de OgrePrincipal //
	//////////////////////////////////////

	/*
	 * OgreMenuBar - Constructor de la barra de menu y la de herramientas de la ventana principal.
	 */
	/*private*/ final class OgreMenuBar implements ActionListener {
	
		String nodo;
		LinkedList arrayRutasFichero = new LinkedList(); // Array de rutas a los ficheros de las filas seleccionadas.
		String[] cuentasMostrables;
		TaskAutomatizar taskAutomatizar;

		/* Constructor */
		public OgreMenuBar(JFrame aFrame) {
			
			//if(MainOgre.verboso) { System.out.println("En OgreMenuBar()"); } //DEBUG
	
			JFrame frame = aFrame;
			JMenuBar menuBar;
			JToolBar toolBar;
			JMenu menu = null, submenu;
			JMenuItem menuItem, copiaMenuItem;
			JButton button;
			Action accion;
			ZonaBotonListener botonListener = new ZonaBotonListener();
		
			if(MailProperties.jck5) // Lo primero, comprobamos y lanzamos autoenvio/recogida.
				lanzarTareaAutomatizada();
			
			// Creamos la barra de menu y la barra de herramientas.
			menuBar = new JMenuBar();
			toolBar = new JToolBar();
			//tablaMails.add(tablaPopupMenu); // Adicin de popupMenu a tablaMails.
			frame.setJMenuBar(menuBar);
		
			// Construimos los menus...
			// ...Archivo.
			//*** menu = new JMenu("Archivo");
			menu = new JMenu(MailProperties.textos.getString("menu_archivo"));
			menu.setMnemonic('a');
			menuBar.add(menu);
		
		
			// Menuitem y boton de NUEVO.
			Action accionNuevo = new AbstractAction(MailProperties.textos.getString("menuitem_nuevo"), new ImageIcon(getClass().getResource("/iconos/Nuevo_25x20.png"))) {
				public void actionPerformed(ActionEvent e) {
					try {
						if(cuentaMail.nombreCuenta != null)
							componerNuevoMail();
						else
							JOptionPane.showMessageDialog(null, "Para componer un correo, debe seleccionar una cuenta antes.", "Atencin", JOptionPane.WARNING_MESSAGE);							
					} catch (IOException e1) {
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_componer_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
						e1.getMessage();
						e1.printStackTrace();
					} catch (MessagingException e1) {
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_componer_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
						e1.getMessage();
						e1.printStackTrace();
					}
				}
			};
			buttonNuevo = toolBar.add(accionNuevo);
			buttonNuevo.addMouseListener(botonListener); // EN FASE DE PRUEBA!
			buttonNuevo.setBorderPainted(false); // EN FASE DE PRUEBA!
			buttonNuevo.setRolloverEnabled(true);
			buttonNuevo.setRolloverIcon(new ImageIcon(getClass().getResource("/iconos/Nuevo_roll_25x20.png")));
			buttonNuevo.setToolTipText(MailProperties.textos.getString("tooltip_nuevo"));
			menuItemNuevo = menu.add(accionNuevo);
			menuItemNuevo.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, InputEvent.CTRL_DOWN_MASK));
			menuItemNuevo.setIcon(new ImageIcon(getClass().getResource("/iconos/Nuevo_15x.png"))); // Para no usar icono en el menu pasarle null.
		
		
			// Menuitem y boton de RESPONDER.
			Action accionResponder = new AbstractAction(MailProperties.textos.getString("menuitem_responder"), new ImageIcon(getClass().getResource("/iconos/Responder_25x20.png"))) {
				public void actionPerformed(ActionEvent e) {
					try {
						responderMail();
					} catch(FileNotFoundException e1){
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_responder_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
						e1.printStackTrace();
					} catch(MessagingException e1){
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_responder_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
						e1.getMessage();
						e1.printStackTrace();
					} catch (IOException e1) {
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_responder_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
						e1.getMessage();
						e1.printStackTrace();
					}
				}
			};
			buttonResponder = toolBar.add(accionResponder);
			buttonResponder.addMouseListener(botonListener);
			buttonResponder.setBorderPainted(false);
			buttonResponder.setRolloverEnabled(true);
			buttonResponder.setRolloverIcon(new ImageIcon(getClass().getResource("/iconos/Responder_roll_25x20.png")));
			buttonResponder.setToolTipText(MailProperties.textos.getString("tooltip_responder"));
			menuItemResponder = menu.add(accionResponder);
			//menuItem = tablaPopupMenu.add(accionResponder); // Para el popup.
			menuItemResponder.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_R, InputEvent.CTRL_DOWN_MASK));
			menuItemResponder.setIcon(new ImageIcon(getClass().getResource("/iconos/Responder_15x.png")));
			copiaMenuItem = new JMenuItem(accionResponder); // Para el popup...
			copiaMenuItem.setIcon(new ImageIcon(getClass().getResource("/iconos/Responder_15x.png")));
			tablaPopupMenu.insert(copiaMenuItem, 0);
		
		
			// Menuitem y boton de REENVIAR.
			Action accionReenviar = new AbstractAction(MailProperties.textos.getString("menuitem_reenviar"), new ImageIcon(getClass().getResource("/iconos/Reenviar_25x20.png"))) {
				public void actionPerformed(ActionEvent e) {
					try {
						reenviarMail();
					} catch (IOException e1) {
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_reenviar_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
						e1.getMessage();
						e1.printStackTrace();
					} catch (MessagingException e1) {
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_reenviar_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
						e1.getMessage();
						e1.printStackTrace();
					}
				}
			};
			buttonReenviar = toolBar.add(accionReenviar);
			buttonReenviar.addMouseListener(botonListener);
			buttonReenviar.setBorderPainted(false);
			buttonReenviar.setRolloverEnabled(true);
			buttonReenviar.setRolloverIcon(new ImageIcon(getClass().getResource("/iconos/Reenviar_roll_25x20.png")));
			buttonReenviar.setToolTipText(MailProperties.textos.getString("tooltip_reenviar"));
			menuItemReenviar = menu.add(accionReenviar);
			//menuItem = tablaPopupMenu.add(accionReenviar); // Para el popup.
			menuItemReenviar.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F, InputEvent.CTRL_DOWN_MASK));
			menuItemReenviar.setIcon(new ImageIcon(getClass().getResource("/iconos/Reenviar_15x.png")));
			copiaMenuItem = new JMenuItem(accionReenviar); // Para el popup...
			copiaMenuItem.setIcon(new ImageIcon(getClass().getResource("/iconos/Reenviar_15x.png")));
			tablaPopupMenu.insert(copiaMenuItem, 1);
		
		
			// Menuitem y boton de ABRIR.
			Action accionAbrir = new AbstractAction(MailProperties.textos.getString("menuitem_abrir"), new ImageIcon(getClass().getResource("/iconos/Abrir_25x20.png"))) {
				public void actionPerformed(ActionEvent e) {
					try {
						abrirMail();
					} catch(FileNotFoundException e1){
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_abrir_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
						e1.getMessage();
						e1.printStackTrace();
					} catch(MessagingException e1){
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_abrir_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
						e1.getMessage();
						e1.printStackTrace();
					} catch(IOException e1){
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_abrir_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
						e1.getMessage();
						e1.printStackTrace();
					}
				}
			};
			button = toolBar.add(accionAbrir);
			button.addMouseListener(botonListener);
			button.setBorderPainted(false);
			button.setRolloverEnabled(true);
			button.setRolloverIcon(new ImageIcon(getClass().getResource("/iconos/Abrir_roll_25x20.png")));
			button.setToolTipText(MailProperties.textos.getString("tooltip_abrir"));
			menuItem = menu.add(accionAbrir);
			menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O, InputEvent.CTRL_DOWN_MASK));
			menuItem.setIcon(new ImageIcon(getClass().getResource("/iconos/Abrir_15x.png")));


			// Menuitem y boton de GUARDAR MENSAJE.
			Action accionGuardar = new AbstractAction(MailProperties.textos.getString("menuitem_guardar"), new ImageIcon(getClass().getResource("/iconos/Guardar_25x20.png"))) {
				public void actionPerformed(ActionEvent e) {
					try {
						guardarMail();
					} catch(IOException e1){
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_guardar_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
						e1.getMessage();
						e1.printStackTrace();
					} catch(MessagingException e1){
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_guardar_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
						e1.getMessage();
						e1.printStackTrace();
					}
				}
			};
			buttonGuardar = toolBar.add(accionGuardar);
			buttonGuardar.addMouseListener(botonListener);
			buttonGuardar.setBorderPainted(false);
			buttonGuardar.setRolloverEnabled(true);
			buttonGuardar.setRolloverIcon(new ImageIcon(getClass().getResource("/iconos/Guardar_roll_25x20.png")));
			buttonGuardar.setToolTipText(MailProperties.textos.getString("tooltip_guardar"));
			menuItemGuardar = menu.add(accionGuardar);
			//menuItem = tablaPopupMenu.add(accionGuardar); // Para el popup.
			menuItemGuardar.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, InputEvent.CTRL_DOWN_MASK));
			menuItemGuardar.setIcon(new ImageIcon(getClass().getResource("/iconos/Guardar_15x.png")));
			tablaPopupMenu.insert(new JPopupMenu.Separator(), 6); // Para el popup...
			copiaMenuItem = new JMenuItem(accionGuardar);
			copiaMenuItem.setIcon(new ImageIcon(getClass().getResource("/iconos/Guardar_15x.png")));
			tablaPopupMenu.insert(copiaMenuItem, 7);


			// Menuitem y boton de ELIMINAR MENSAJE.
			Action accionEliminarMensaje = new AbstractAction(MailProperties.textos.getString("menuitem_eliminar"), new ImageIcon(getClass().getResource("/iconos/Eliminar_mensaje_25x20.png"))) {
				public void actionPerformed(ActionEvent e) {
					eliminarMail();
				}
			};
			buttonEliminar = toolBar.add(accionEliminarMensaje);
			buttonEliminar.addMouseListener(botonListener);
			buttonEliminar.setBorderPainted(false);
			buttonEliminar.setRolloverEnabled(true);
			buttonEliminar.setRolloverIcon(new ImageIcon(getClass().getResource("/iconos/Eliminar_mensaje_roll_25x20.png")));
			buttonEliminar.setToolTipText(MailProperties.textos.getString("tooltip_eliminar"));
			menuItemEliminar = menu.add(accionEliminarMensaje);
			//menuItem = tablaPopupMenu.add(accionEliminarMensaje); // Para el popup.
			menuItemEliminar.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_T, InputEvent.CTRL_DOWN_MASK));
			menuItemEliminar.setIcon(new ImageIcon(getClass().getResource("/iconos/Eliminar_mensaje_15x.png")));		
			copiaMenuItem = new JMenuItem(accionEliminarMensaje); // Para el popup...
			copiaMenuItem.setIcon(new ImageIcon(getClass().getResource("/iconos/Eliminar_mensaje_15x.png")));
			tablaPopupMenu.insert(copiaMenuItem, 8);
		
			menu.addSeparator(); // Separador de menu.
		
			menuItem = new JMenuItem(MailProperties.textos.getString("menuitem_salir"));
			menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Q, InputEvent.CTRL_DOWN_MASK));
			menuItem.addActionListener(this);
			menu.add(menuItem);
		
			toolBar.add(new JToolBar.Separator()); // Separador de barra de herramientas.
		
			// ...Editar.
			menu = new JMenu(MailProperties.textos.getString("menu_editar"));
			menu.setMnemonic('e');
			menuBar.add(menu);
		
		
			// Menuitem y boton de COPIAR.
			Action accionCopiar = new AbstractAction(MailProperties.textos.getString("menuitem_copiar"), new ImageIcon(getClass().getResource("/iconos/Copiar_25x20.png"))) {
				 public void actionPerformed(ActionEvent e) {
					opcion = "Copiar";
					copiarCortarMail();
					
					// Activamos el botn/men de Pegar.
					buttonPegar.setEnabled(true);
					menuItemPegar.setEnabled(true);
				 }
			};
			buttonCopiar = toolBar.add(accionCopiar);
			buttonCopiar.addMouseListener(botonListener);
			buttonCopiar.setBorderPainted(false);
			buttonCopiar.setRolloverEnabled(true);
			buttonCopiar.setRolloverIcon(new ImageIcon(getClass().getResource("/iconos/Copiar_roll_25x20.png")));
			buttonCopiar.setToolTipText(MailProperties.textos.getString("tooltip_copiar"));
			menuItemCopiar = menu.add(accionCopiar);
			//menuItem = tablaPopupMenu.add(accionCopiar); // Para el popup.
			menuItemCopiar.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, InputEvent.ALT_DOWN_MASK));
			menuItemCopiar.setIcon(new ImageIcon(getClass().getResource("/iconos/Copiar_15x.png")));
			tablaPopupMenu.insert(new JPopupMenu.Separator(), 2); // Para el popup...
			copiaMenuItem = new JMenuItem(accionCopiar);
			copiaMenuItem.setIcon(new ImageIcon(getClass().getResource("/iconos/Copiar_15x.png")));
			tablaPopupMenu.insert(copiaMenuItem, 3);
		
		
			// Menuitem y boton de CORTAR.
			Action accionCortar = new AbstractAction(MailProperties.textos.getString("menuitem_cortar"), new ImageIcon(getClass().getResource("/iconos/Cortar_25x20.png"))) {
				public void actionPerformed(ActionEvent e) {
					opcion = "Cortar"; 
					copiarCortarMail();
					
					// Activamos el botn/men de Pegar.
					buttonPegar.setEnabled(true);
					menuItemPegar.setEnabled(true);
				}
			};
			buttonCortar = toolBar.add(accionCortar);
			buttonCortar.addMouseListener(botonListener);
			buttonCortar.setBorderPainted(false);
			buttonCortar.setRolloverEnabled(true);
			buttonCortar.setRolloverIcon(new ImageIcon(getClass().getResource("/iconos/Cortar_roll_25x20.png")));
			buttonCortar.setToolTipText(MailProperties.textos.getString("tooltip_cortar"));
			menuItemCortar = menu.add(accionCortar);
			//menuItem = tablaPopupMenu.add(accionCortar); // Para el popup.
			menuItemCortar.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, InputEvent.ALT_DOWN_MASK));
			menuItemCortar.setIcon(new ImageIcon(getClass().getResource("/iconos/Cortar_15x.png")));
			copiaMenuItem = new JMenuItem(accionCortar); // Para el popup...
			copiaMenuItem.setIcon(new ImageIcon(getClass().getResource("/iconos/Cortar_15x.png")));
			tablaPopupMenu.insert(copiaMenuItem, 4);
		
		
			// Menuitem y boton de PEGAR.
			Action accionPegar = new AbstractAction(MailProperties.textos.getString("menuitem_pegar"), new ImageIcon(getClass().getResource("/iconos/Pegar_25x20.png"))) {
				public void actionPerformed(ActionEvent e) {
					try {
						pegarMail();
						opcion = null;
					} catch(IOException e1){
						JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_pegar_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
						e1.getMessage();
						e1.printStackTrace();
					}
				}
			};
			buttonPegar = toolBar.add(accionPegar);
			buttonPegar.addMouseListener(botonListener);
			buttonPegar.setBorderPainted(false);
			buttonPegar.setRolloverEnabled(true);
			buttonPegar.setRolloverIcon(new ImageIcon(getClass().getResource("/iconos/Pegar_roll_25x20.png")));
			buttonPegar.setToolTipText(MailProperties.textos.getString("tooltip_pegar"));
			buttonPegar.setEnabled(false);
			menuItemPegar = menu.add(accionPegar);
			//menuItem = tablaPopupMenu.add(accionPegar); // Para el popup.
			menuItemPegar.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, InputEvent.ALT_DOWN_MASK));
			menuItemPegar.setIcon(new ImageIcon(getClass().getResource("/iconos/Pegar_15x.png")));
			menuItemPegar.setEnabled(false);
			copiaMenuItem = new JMenuItem(accionPegar);  // Para el popup...
			copiaMenuItem.setIcon(new ImageIcon(getClass().getResource("/iconos/Pegar_15x.png")));
			tablaPopupMenu.insert(copiaMenuItem, 5);
		
			toolBar.add(new JToolBar.Separator()); // Separador de barra de herramientas.
		
		
			// ...Ver.
			menu = new JMenu(MailProperties.textos.getString("menu_ver"));
			menu.setMnemonic('v');
			menuBar.add(menu);
			
			// Menuitem MENSAJE NORMAL.
			Action accionVerNormal = new AbstractAction(MailProperties.textos.getString("menuitem_ver_normal"), new ImageIcon(getClass().getResource("/iconos/Mensaje_Normal_15x.png"))) {
				public void actionPerformed(ActionEvent e) {
					
					if(rutaAlFichero != null){
					
						Runnable r = new Runnable(){
							public void run(){
								try {
									permitirHtml = true;	
									gestion_mensaje(rutaAlFichero);
								} catch (Exception e1){
									JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_mostrar_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
									e1.getMessage();
									e1.printStackTrace();
								}
							} 
						};
						Thread t = new Thread(r);
						t.start();
					}
				}
			};
			menuItemVerNormal = menu.add(accionVerNormal);
			menuItemVerNormal.setEnabled(false);
			
			// Menuitem FUENTE MENSAJE.
			Action accionVerFuente = new AbstractAction(MailProperties.textos.getString("menuitem_ver_fuente"), new ImageIcon(getClass().getResource("/iconos/Mensaje_Fuente_15x.png"))) {
				public void actionPerformed(ActionEvent e) {
					
					if(rutaAlFichero != null){
					
						Runnable r = new Runnable(){
							public void run(){
								try { 
									tabbedPane.setEnabledAt(0, true);
									mostrarFuenteMensaje();
								} catch (Exception e1){
									JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_mostrar_fuente_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
									e1.getMessage();
									e1.printStackTrace();
								}
							} 
						};
						Thread t = new Thread(r);
						t.start();		 					
					}
				}
			};
			menuItemVerFuente = menu.add(accionVerFuente);
			menuItemVerFuente.setEnabled(false);
			
		
			// ...Acciones.
			menu = new JMenu(MailProperties.textos.getString("menu_acciones"));
			menu.setMnemonic('c');
			menuBar.add(menu);
		
			// Menuitem y boton de ENVIAR CORREO.
			Action accionEnviar = new AbstractAction(MailProperties.textos.getString("menuitem_enviar"), new ImageIcon(getClass().getResource("/iconos/Enviar_25x20.png"))) {
				public void actionPerformed(ActionEvent e) {
					 
					if(cuentaMail.nombreCuenta != null){
						  
						Runnable r = new Runnable(){
							public void run(){
								try {
									EmisorMail.enviando = true;
									desactivacionBotonesCriticos();
									enviarMail();
									EmisorMail.enviando = false;
									activacionBotonesCriticos();
									activacionParar();			
								} catch(Exception e1){
									EmisorMail.enviando = false;
									activacionBotonesCriticos();
									activacionParar();
									OgreProgressBar.setDesactiva(); // Fin progressbar.
									JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_enviar_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
									e1.getMessage();
									e1.printStackTrace();
								}
							} 
						};
						Thread t = new Thread(r);
						t.start();
					} else
						JOptionPane.showMessageDialog(null, "Para enviar correo, debe seleccionar una cuenta antes.", "Atencin", JOptionPane.WARNING_MESSAGE);
				}
			};
			buttonEnviar = toolBar.add(accionEnviar);
			buttonEnviar.addMouseListener(botonListener);
			buttonEnviar.setBorderPainted(false);
			buttonEnviar.setRolloverEnabled(true);
			buttonEnviar.setRolloverIcon(new ImageIcon(getClass().getResource("/iconos/Enviar_roll_25x20.png")));
			buttonEnviar.setToolTipText(MailProperties.textos.getString("tooltip_enviar"));
			menuItemEnviar = menu.add(accionEnviar);
			menuItemEnviar.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F10, 0));
			menuItemEnviar.setIcon(new ImageIcon(getClass().getResource("/iconos/Enviar_15x.png")));
		
	
			// Menuitem y boton de RECIBIR CORREO.
			Action accionRecibir = new AbstractAction(MailProperties.textos.getString("menuitem_recibir"), new ImageIcon(getClass().getResource("/iconos/Recibir_25x20.png"))) {
				 public void actionPerformed(ActionEvent e) {
					
					if(cuentaMail.nombreCuenta != null){
						  
						Runnable r = new Runnable(){
							public void run(){
						  		try { 
									OgreProgressBar.setActiva("Recibiendo"); // Inicio progressbar.
									ReceptorMail.recibiendo = true;
									desactivacionBotonesCriticos();
									recibirMail();
									ReceptorMail.recibiendo = false;
									activacionBotonesCriticos();
									activacionParar();
						  		} catch(Exception e1){
									ReceptorMail.recibiendo = false;
									activacionBotonesCriticos();
									activacionParar();
									OgreProgressBar.setDesactiva(); // Fin progressbar.
									JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_recibir_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
									e1.getMessage();
						  			e1.printStackTrace();
						  		}
							} 
						};
						Thread t = new Thread(r);
						t.start();
					} else
						JOptionPane.showMessageDialog(null, "Para recibir correo, debe seleccionar una cuenta antes.", "Atencin", JOptionPane.WARNING_MESSAGE);
				}
			};
			buttonRecibir = toolBar.add(accionRecibir);
			buttonRecibir.addMouseListener(botonListener);
			buttonRecibir.setBorderPainted(false);
			buttonRecibir.setRolloverEnabled(true);
			buttonRecibir.setRolloverIcon(new ImageIcon(getClass().getResource("/iconos/Recibir_roll_25x20.png")));
			buttonRecibir.setToolTipText(MailProperties.textos.getString("tooltip_recibir"));
			menuItemRecibir = menu.add(accionRecibir);
			menuItemRecibir.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F11, 0));
			menuItemRecibir.setIcon(new ImageIcon(getClass().getResource("/iconos/Recibir_15x.png")));
		
		
			// Menuitem y boton de ENVIAR-RECIBIR CORREO.
			Action accionEnviarRecibir = new AbstractAction(MailProperties.textos.getString("menuitem_enviar_recibir"), new ImageIcon(getClass().getResource("/iconos/EnviarRecibir_25x20.png"))) {
				public void actionPerformed(ActionEvent e) {

				   if(cuentaMail.nombreCuenta != null){
					Runnable r = new Runnable(){
						public void run(){
							try {
								OgreProgressBar.setActiva("Enviando"); // Inicio progressbar.
								EmisorMail.enviando = true;
								desactivacionBotonesCriticos();
								enviarMail();
								EmisorMail.enviando = false;
								OgreProgressBar.setActiva("Recibiendo"); // Inicio progressbar.
								ReceptorMail.recibiendo = true;
								recibirMail();
								ReceptorMail.recibiendo = false;
								activacionBotonesCriticos();
								activacionParar();
								buttonStop.setEnabled(true);
							} catch(Exception e1){
								EmisorMail.enviando = false;
								ReceptorMail.recibiendo = false;
								activacionBotonesCriticos();
								activacionParar();
								OgreProgressBar.setDesactiva(); // Fin progressbar.
								JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_enviar_recibir_correo")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
								e1.getMessage();
								e1.printStackTrace();
							}
						} 
					};
					Thread t = new Thread(r);
					t.start();
				   } else
						JOptionPane.showMessageDialog(null, "Para enviar y recibir correo, debe seleccionar una cuenta antes.", "Atencin", JOptionPane.WARNING_MESSAGE);
				}
			};
			buttonEnviarRecibir = toolBar.add(accionEnviarRecibir);
			buttonEnviarRecibir.addMouseListener(botonListener);
			buttonEnviarRecibir.setBorderPainted(false);
			buttonEnviarRecibir.setRolloverEnabled(true);
			buttonEnviarRecibir.setRolloverIcon(new ImageIcon(getClass().getResource("/iconos/EnviarRecibir_roll_25x20.png")));
			buttonEnviarRecibir.setToolTipText(MailProperties.textos.getString("tooltip_enviar_recibir"));
			menuItemEnviarRecibir = menu.add(accionEnviarRecibir);
			menuItemEnviarRecibir.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F12, 0));
			menuItemEnviarRecibir.setIcon(new ImageIcon(getClass().getResource("/iconos/EnviarRecibir_15x.png")));
		
			// MenuItem y boton de STOP.
			Action accionStop = new AbstractAction(MailProperties.textos.getString("menuitem_parar"), new ImageIcon(getClass().getResource("/iconos/Stop_25x20.png"))) {
				public void actionPerformed(ActionEvent e) {
					if((cuentaMail.nombreCuenta != null)&&((EmisorMail.enviando==true)||(ReceptorMail.recibiendo==true))){
						Runnable r = new Runnable(){
							public void run(){
								desactivacionParar();		
								if(EmisorMail.enviando==true){
									OgreProgressBar.setActiva(MailProperties.textos.getString("parando_envio"));
									EmisorMail.enviando=false;
								} else if(ReceptorMail.recibiendo==true){
									OgreProgressBar.setActiva(MailProperties.textos.getString("parando_recepcion"));
									ReceptorMail.recibiendo=false;
								}
							}
						};
						Thread t = new Thread(r);
						t.start();
					}
				}
			};
			buttonStop = toolBar.add(accionStop);
			buttonStop.addMouseListener(botonListener);
			buttonStop.setBorderPainted(false);
			buttonStop.setRolloverEnabled(true);
			buttonStop.setRolloverIcon(new ImageIcon(getClass().getResource("/iconos/Stop_roll_25x20.png")));
			buttonStop.setToolTipText(MailProperties.textos.getString("tooltip_parar"));
			menuItemStop = menu.add(accionStop);
			menuItemStop.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P, InputEvent.CTRL_DOWN_MASK));
			menuItemStop.setIcon(new ImageIcon(getClass().getResource("/iconos/Stop_15x.png")));
			
			menu.addSeparator();
			toolBar.add(new JToolBar.Separator()); // Separador de barra de herramientas.
		
			// Menuitem y boton de CUENTAS.
			Action accionCuentas = new AbstractAction(MailProperties.textos.getString("menuitem_cuentas"), new ImageIcon(getClass().getResource("/iconos/Cuentas_25x20.png"))) {
				 public void actionPerformed(ActionEvent e) {
					OgreCuenta oc = new OgreCuenta(cuentaMail, arbolCuentas);
				 }
			};
			button = toolBar.add(accionCuentas);
			button.addMouseListener(botonListener);
			button.setBorderPainted(false);
			button.setRolloverEnabled(true);
			button.setRolloverIcon(new ImageIcon(getClass().getResource("/iconos/Cuentas_roll_25x20.png")));
			button.setToolTipText(MailProperties.textos.getString("tooltip_cuentas"));
			menuItem = menu.add(accionCuentas);
			menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_E, InputEvent.CTRL_DOWN_MASK));
			menuItem.setIcon(new ImageIcon(getClass().getResource("/iconos/Cuentas_15x.png")));

		
			// Menuitem y boton de AGENDA.
			Action accionAgenda = new AbstractAction(MailProperties.textos.getString("menuitem_agenda"), new ImageIcon(getClass().getResource("/iconos/Agenda_25x20.png"))) {
				public void actionPerformed(ActionEvent e) {
					//displayResult("Action for this button/menu item", e);
				}
			};
			button = toolBar.add(accionAgenda);
			button.addMouseListener(botonListener);
			button.setBorderPainted(false);
			button.setRolloverEnabled(true);
			button.setRolloverIcon(new ImageIcon(getClass().getResource("/iconos/Agenda_roll_25x20.png")));
			button.setToolTipText(MailProperties.textos.getString("tooltip_agenda"));
			button.setEnabled(false); // Boton desactivado.
			menuItem = menu.add(accionAgenda);
			menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A, InputEvent.CTRL_DOWN_MASK));
			menuItem.setIcon(new ImageIcon(getClass().getResource("/iconos/Agenda_15x.png")));
			menuItem.setEnabled(false); // MenuItem desactivado.
		
		
			// ...Configurar.
			menu = new JMenu(MailProperties.textos.getString("menu_configuracion"));
			menu.setMnemonic('f');
			menuBar.add(menu);
		
			// Menuitem PREFERENCIAS.
			Action accionPreferencias = new AbstractAction(MailProperties.textos.getString("menuitem_preferencias"), new ImageIcon(getClass().getResource("/iconos/Preferencias_15x.png"))) {
				public void actionPerformed(ActionEvent e) {
						
					Runnable r = new Runnable(){
						public void run(){
					
							try {
								
								OgreConfiguracion oc = new OgreConfiguracion();
								
								/* Con esto pretendemos detener la consecucin de la ejecucin 
								* para poder coger la cifra de miliseconds correctos. Si se 
								* quedara clavado, cabra estudiar el uso de un thread para 
								* esta tarea. */
								while(!oc.terminado){
									Thread.sleep(1000);
									if(MainOgre.verboso) System.out.println("Comprobando si se termin...");
								}
								
								if(oc.guardado){

									if(MailProperties.jck5){
										
										lanzarTareaAutomatizada();
										
//										// Arrancar un thread con un Timer "scheduledAtFixedRate".
//										Timer timer = new Timer();
//										// Eliminamos, si la hay, la anterior tarea programada....
//										if(taskAutomatizar != null){
//											boolean result = taskAutomatizar.cancel();
//											if(result){
//												if(MainOgre.verboso) System.out.println("Tarea CANCELADA.");
//											}
//										}
										
										//TODO//
										/* En lugar de tener que cojer los miliseconds as, podemos cojerlos
										 * directamente de MailProperties.jcb1, pues tiene el valor ms actual.
										 * Lo nico que har falta es transformar ese label (p.ej.1 hora) en
										 * la cifra de miliseconds. Esta misma funcin de transformacin del
										 * label a miliseconds la usar tambin el mtodo de comprobacin que al
										 * inicio de Ogre mire si debe arrancar un thread para el envio/recogida
										 * de correo automtico cada X tiempo.
										 * 
										 * O mejor an: en OgreConfiguracion hacer un mtodo esttico (p.ej.
										 * obtener_tiempo) para devolver los milisegundos asociados a un label
										 * determinado. Parece mejor solucin para no sobrecargar de cdigo
										 * esta clase, y a la vez, para estructurar mejor las clases. */
										//long miliseconds = oc.getMiliseconds();
//										long miliseconds = OgreConfiguracion.getTiempo(MailProperties.jcb1);
//										if(MainOgre.verboso) System.out.println("miliseconds: "+miliseconds);
//										
//										// ...y creamos la nueva.
//										taskAutomatizar = new TaskAutomatizar(timer);
//										timer.scheduleAtFixedRate(taskAutomatizar, miliseconds, miliseconds);
									
									} else {
										// Eliminamos, si la hay, la anterior tarea programada.
										if(taskAutomatizar != null){
											boolean result = taskAutomatizar.cancel();
											if(result){
												if(MainOgre.verboso) System.out.println("Tarea CANCELADA.");
											}
										}
									}
								}
									
							} catch (Exception e1) {
								JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_preferencias")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
								e1.getMessage();
								e1.printStackTrace();
							}								
						}
					};
					Thread t = new Thread(r);
					t.start();		
				}
			};
			menuItem = menu.add(accionPreferencias);
			menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P, InputEvent.CTRL_DOWN_MASK));
		
		
			// ...Ayuda.
			menu = new JMenu(MailProperties.textos.getString("menu_ayuda"));
			menu.setMnemonic('y');
			menuBar.add(menu);
		
			menuItem = new JMenuItem(MailProperties.textos.getString("menuitem_temas"));
			menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_H, InputEvent.CTRL_DOWN_MASK));
			menuItem.addActionListener(this);
			menu.add(menuItem);
		
			menuItem = new JMenuItem(MailProperties.textos.getString("menuitem_acerca"));
			menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F12, InputEvent.CTRL_DOWN_MASK));
			menuItem.addActionListener(this);
			menu.add(menuItem);
		
			toolBar.setFloatable(false);
			frame.getContentPane().add(toolBar, BorderLayout.NORTH); // Aade la Toolbar al frame.
			
		}
	
		///////////////
		// LISTENERS //
		///////////////
	
		/* Listener de los eventos sobre los JMenuItems. ATENCIN: Todos los que tengan
		 * botn en la toolbar no usan este actionPerformed, sino el suyo propio definido
		 * para cada botn. As pues, aqu slo entran las acciones de los menes que no 
		 * tengan botn asociado en la barra de herramientas. */
		public void actionPerformed(ActionEvent e){
			JMenuItem source = (JMenuItem)(e.getSource());
			//System.out.println("Generador del evento: "+source.getText()); // DEBUG
		
			if(source.getText().equalsIgnoreCase(MailProperties.textos.getString("menuitem_salir"))){
				System.exit(0);
			}
			else if(source.getText().equalsIgnoreCase(MailProperties.textos.getString("menuitem_temas"))){
				Runnable r = new Runnable(){
					public void run(){
						try { 
							mostrarManual();
						} catch(Exception e1){
							JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_temas_ayuda")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
							e1.getMessage();
							e1.printStackTrace();
						}
					} 
				};
				Thread t = new Thread(r);
				t.start();
			}
			else if(source.getText().equalsIgnoreCase(MailProperties.textos.getString("menuitem_acerca"))){
				try {
					OgreAbout oa = new OgreAbout();
				} catch (IOException e1) {
					JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_acerca_de")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
					e1.getMessage();
					e1.printStackTrace();
				}
			}	
		}
	
		///////////////////
		// OTROS MT0D0S //
		///////////////////
		
		/* ---Mtodo mostrarManual--- */
		private void mostrarManual() throws IOException {
				
			// Formas correctas de borrar el contenido del JTextPane:					
			/*1*/jtextpane.setText("");	
			/*2*///jtextpane.getDocument().remove(0, jtextpane.getDocument().getLength());
				
			// HTMLEditorKit.
			jtextpane.setEditorKit(new HTMLEditorKit());
							
			// Listener para gestionar enlaces.
			jtextpane.addHyperlinkListener(new MiHyperlinkListener());
										
			jtextpane.setPage(getClass().getResource("/ayuda/ManualdeUsuario.html"));
			jtextpane.setCaretPosition(0);
		}
	
		/* ---Mtodo componerNuevoMail--- */
		/* Lanza la ventana de OgreNuevoMail (esto es, crea una instancia). */
		private void componerNuevoMail() throws IOException, MessagingException{
			OgreNuevoMail onm = new OgreNuevoMail(cuentaMail, omtm, sorter, null, null);
		}
	
		/* ---Mtodo responderMail--- */
		private void responderMail() throws IOException, MessagingException {
			// Si realmente hay un mail(fila) seleccionado, es posible continuar.
			if(rutaAlFichero != null){
				/* Construimos un mensaje y se lo pasamos a OgreNuevoMail para que
				 * lo formatee (le ponga Re:, aada el cuerpo debajo de lo que el 
				 * usuario responda, aada tabs...). OgreNuevoMail ya se encargar 
				 * de dotarlo de una sesin para poder enviarlo. */
				MimeMessage replyMessage = new MimeMessage(null, new FileInputStream(rutaAlFichero));
				OgreNuevoMail onm = new OgreNuevoMail(cuentaMail, omtm, sorter, replyMessage, null);
			} else
				JOptionPane.showMessageDialog(null, "Para responder un correo, debe seleccionar uno antes.", "Atencin", JOptionPane.WARNING_MESSAGE);
		}

		/* ---Mtodo reenviarMail--- */
		private void reenviarMail() throws IOException, MessagingException{
			// Si realmente hay un mail(fila) seleccionado, es posible continuar.
			if(rutaAlFichero != null){
				OgreNuevoMail onm = new OgreNuevoMail(cuentaMail, omtm, sorter, null, rutaAlFichero);
			} else
				JOptionPane.showMessageDialog(null, "Para reenviar un correo, debe seleccionar uno antes.", "Atencin", JOptionPane.WARNING_MESSAGE);
		}
		
		/* ---Mtodo abrirMail--- */
		/* Abre un dilogo de apertura de ficheros para abrir un mail. La duda est en
		 * si ser mostrado en una ventana a parte, o bien en el JTextPane de OgrePrincipal
		 * (aunque tal y como est estructurado ahora, eso sera complicado). Otra posibilidad
		 * es desestimar esta opcin; todos los mails que podrn visualizarse sern los que se
		 * hallen en los directorios de las cuentas configuradas en Ogre. */
		private void abrirMail() throws FileNotFoundException, MessagingException, IOException {
			JFileChooser fc = new JFileChooser();
			int val = fc.showOpenDialog(frame);

			if (val == JFileChooser.APPROVE_OPTION) {
				File file = fc.getSelectedFile();
				// Cdigo de apertura del mensaje.
				gestion_mensaje(file.getAbsolutePath());
			} 
		}
	
		/* ---Mtodo mostrarFuenteMensaje--- */
		/* Muestra el fuente del mensaje por el jtextpane. */
		private void mostrarFuenteMensaje() throws IOException, FileNotFoundException {
			
			if(rutaAlFichero != null){
					
				FileReader fr = new FileReader(rutaAlFichero);
				BufferedReader br = new BufferedReader(fr);
					
				// Lectura linea a linea.
				String S, S2 = new String();
				while((S = br.readLine()) != null){
					S2 += S + "\n";
				}
						
				br.close();
				fr.close();
					
				// Formas correctas de borrar el contenido del JTextPane:					
				/*1*/jtextpane.setText("");	
				/*2*///jtextpane.getDocument().remove(0, jtextpane.getDocument().getLength());
				
				// StyledEditorKit.
				jtextpane.setEditorKit(new StyledEditorKit());
										
				jtextpane.setText(S2);
				jtextpane.setCaretPosition(0);
			} else
				JOptionPane.showMessageDialog(null, "Para mostrar el fuente de un correo, debe seleccionar uno antes.", "Atencin", JOptionPane.WARNING_MESSAGE);
		}
	
		/* ---Mtodo guardarMail--- */
		/* Guarda en la ruta de disco indicada el correo seleccionado. */
		private void guardarMail() throws IOException, MessagingException {
			
			if(rutaAlFichero != null){
				
				JFileChooser fc = new JFileChooser();
				int val = fc.showSaveDialog(frame);
		
				if (val == JFileChooser.APPROVE_OPTION) {
					File file = fc.getSelectedFile();
						
					// Cdigo de almacenado del mensaje.
					FileOutputStream fos = new FileOutputStream(file);
					BufferedOutputStream bos = new BufferedOutputStream(fos);
					MimeMessage message = new MimeMessage(null, new FileInputStream(rutaAlFichero));
			
					message.writeTo(bos);
					bos.flush();
					bos.close();
					fos.close();
				}
			} else
				JOptionPane.showMessageDialog(null, "Para guardar un correo, debe seleccionar uno antes.", "Atencin", JOptionPane.WARNING_MESSAGE);
		}
	
		/* ---Mtodo eliminarMail--- */
		/* Mueve el correo seleccionado al 'trash' de la respectiva cuenta. */
		private void eliminarMail(){

			//if(rutaAlFichero != null){
			if(!filasSeleccionadas.isEmpty()){

				//try {
					
					if(MainOgre.verboso) System.out.println("filasSeleccionadas.size(): "+filasSeleccionadas.size()); //DEBUG
					 
					for(int i=0; i<filasSeleccionadas.size(); i++){
						
						String fichero = sorter.getValueAt(((Integer) filasSeleccionadas.get(i)).intValue(), tablaMails.getColumnCount()).toString();
						if(MainOgre.verboso) System.out.println("Nombre fichero:"+fichero); //DEBUG
						rutaAlFichero = MailProperties.path_ogre+cuentaMail.nombreCuenta+"/"+node.toString()+"/"+fichero; 
						if(MainOgre.verboso) System.out.println("Ruta al fichero: "+rutaAlFichero); //DEBUG
						
						// Cambio de posicin del fichero al 'trash' de la cuenta actual.
						File file = new File(rutaAlFichero);
						
						if(node.toString().equalsIgnoreCase("trash"))
							file.delete();
						else {
							File file2 = new File(MailProperties.path_ogre+cuentaMail.nombreCuenta+"/trash/"+"OgreMail_trash_file");
							for(int j=0; file2.exists(); j++){
								file2 = new File(MailProperties.path_ogre+cuentaMail.nombreCuenta+"/trash/"+"OgreMail_trash_file"+j);
							}
							file.renameTo(file2);
						}	
					}
					 
					// Limpieza.
					rutaAlFichero = null;
					filasSeleccionadas.clear();
					arrayRutasFichero.clear();
					omtm.fireTableDataChanged();
					
					// Reseteo del estado del jtextpane y de las pestaas.
					jtextpane.setText("");
					tabbedPane.setEnabledAt(0, false);
					tabbedPane.setEnabledAt(1, false);
				
				/*} catch(Exception e){
					// Limpieza.
					rutaAlFichero = null;
					filasSeleccionadas.clear();
					arrayRutasFichero.clear();
					omtm.fireTableDataChanged();
					
					// Reseteo del estado del jtextpane y de las pestaas.
					jtextpane.setText("");
					tabbedPane.setEnabledAt(0, false);
					tabbedPane.setEnabledAt(1, false);
					
					JOptionPane.showMessageDialog(null, e.getMessage(), "Error en eliminarMail()", JOptionPane.ERROR_MESSAGE);
					//System.out.println("Error en gestion_multipart(): "+e.getMessage());
					e.printStackTrace();
				}*/
			} else
				JOptionPane.showMessageDialog(null, "Para borrar correo, debe seleccionarlo antes.", "Atencin", JOptionPane.WARNING_MESSAGE);
		}
		
		/* ---Mtodo copiarCortarMail--- */
		/* Establece una referencia al fichero del correo seleccionado. */
		private void copiarCortarMail(){ 
			
			if(!filasSeleccionadas.isEmpty()){
					
				// Limpieza.
				arrayRutasFichero.clear();
				
				// Desactivacin del que no se usa.
				if(opcion.equalsIgnoreCase("Copiar")){
					buttonCortar.setEnabled(false);
					menuItemCortar.setEnabled(false);
				} else {
					buttonCopiar.setEnabled(false);
					menuItemCopiar.setEnabled(false);
				}
					
				// Guardamos en un array las rutas a los ficheros de cada fila seleccionada.
				if(MainOgre.verboso) System.out.println("filasSeleccionadas.size(): "+filasSeleccionadas.size()); //DEBUG
				for(int i=0; i<filasSeleccionadas.size(); i++){
					String fichero = sorter.getValueAt(((Integer) filasSeleccionadas.get(i)).intValue(), tablaMails.getColumnCount()).toString();
					//System.out.println("Nombre fichero:"+fichero); //DEBUG
					rutaAlFichero = MailProperties.path_ogre+cuentaMail.nombreCuenta+"/"+node.toString()+"/"+fichero; 
					if(MainOgre.verboso) System.out.println("Ruta al fichero: "+rutaAlFichero); //DEBUG
					if(!arrayRutasFichero.contains(rutaAlFichero))
						arrayRutasFichero.add(rutaAlFichero);
					else
						if(MainOgre.verboso) System.out.println(rutaAlFichero+" no aadido (repetido!)."); //DEBUG
				}
					
				// Limpieza.
				filasSeleccionadas.clear();
					
			} else
				JOptionPane.showMessageDialog(null, "Para copiar/cortar correo, debe seleccionarlo antes.", "Atencin", JOptionPane.WARNING_MESSAGE);
		}
		
		/* ---Mtodo pegarMail--- */
		/* Crea un fichero con la referencia creada por copiarCortarMail. Dependiendo de 
		 * si la operacion fue de copiar o cortar, no eliminara la referencia de la ruta 
		 * original o si, respectivamente. */
		private void pegarMail() throws IOException{
			
			if(!arrayRutasFichero.isEmpty()){
					
					File file = null;
					File file2 = null;
					
					if(opcion.equalsIgnoreCase("Copiar")){ // La accin previa fue Copiar.
						
						//System.out.println("opcion: "+opcion); //DEBUG
						
						FileInputStream fis = null;
						BufferedInputStream bis = null;
						FileOutputStream fos = null;
						BufferedOutputStream bos = null;
						
						for(int i=0; i<arrayRutasFichero.size(); i++){ 
							if(MainOgre.verboso) System.out.println("Ruta al fichero: "+(String) arrayRutasFichero.get(i)); //DEBUG
							file = new File(((String) arrayRutasFichero.get(i)));
							fis = new FileInputStream(file);
							bis = new BufferedInputStream(fis);
							file2 = new File(MailProperties.path_ogre+cuentaMail.nombreCuenta+"/"+node.toString()+"/"+file.getName());
							for(int j=0; file2.exists(); j++){
								file2 = new File(MailProperties.path_ogre+cuentaMail.nombreCuenta+"/"+node.toString()+"/"+file.getName()+j);	
							}
							
							fos = new FileOutputStream(file2);
							bos = new BufferedOutputStream(fos);
							
							// Lectura/Escritura byte a byte... es lo ms eficiente?
							int c;
							while((c = bis.read()) != -1){
								bos.write(c);
							}
							
							bos.flush();
							bis.close();
							bos.close();
							fos.close();
							fis.close();
						}
						
						// Activar boton Cortar.
						buttonCortar.setEnabled(true);
						menuItemCortar.setEnabled(true);
						
					} else if(opcion.equalsIgnoreCase("Cortar")){ // La accin previa fue Cortar.
						
						for(int i=0; i<arrayRutasFichero.size(); i++){
							if(MainOgre.verboso) System.out.println("Ruta al fichero: "+(String) arrayRutasFichero.get(i)); //DEBUG
							file = new File(((String) arrayRutasFichero.get(i)));
							file2 = new File(MailProperties.path_ogre+cuentaMail.nombreCuenta+"/"+node.toString()+"/"+file.getName());
							for(int j=0; file2.exists(); j++){
								file2 = new File(MailProperties.path_ogre+cuentaMail.nombreCuenta+"/"+node.toString()+"/"+file.getName()+j);
							}
	
							file.renameTo(file2);
						}
						
						// Activar boton Copiar.
						buttonCopiar.setEnabled(true);
						menuItemCopiar.setEnabled(true);
					}
				
					// Desactivamos el botn/men de Pegar.
					buttonPegar.setEnabled(false);
					menuItemPegar.setEnabled(false);
				
					omtm.fireTableDataChanged();
				
					// No hacemos limpieza, as podremos repetir el Pegar.
					opcion = null;
					//arrayRutasFichero.clear();
			
			} else
				JOptionPane.showMessageDialog(null, "Nada que pegar. Copi o cort correo antes?", "Atencin", JOptionPane.WARNING_MESSAGE);
		}
	
		/* ---Mtodo recibirMail--- */
		/* Recibe los mails del servidor. */
		private void recibirMail() throws Exception{
			if(cuentaMail.nombreCuenta != null){
				
				CuentaMail[] arrayCuentasMail = {cuentaMail};
				
				/** EXPERIMENTAL **/
				if(MailProperties.jck4){
					obtenerNombresCuentas();
					arrayCuentasMail = new CuentaMail[cuentasMostrables.length];
					for(int i=0; i<cuentasMostrables.length; i++){
						CuentaMail unaCuentaMail = new CuentaMail();
						unaCuentaMail.seleccionar_cuenta(cuentasMostrables[i]);
						arrayCuentasMail[i] = unaCuentaMail;
					}
				}
				/** EXPERIMENTAL **/
				
				for(int i=0; i<arrayCuentasMail.length; i++){ /****/
				
					//String nombreCuentaReceptora = cuentaMail.nombreCuenta;
					String nombreCuentaReceptora = arrayCuentasMail[i].nombreCuenta;
					//ReceptorMail receptorMail = new ReceptorMail(cuentaMail);
					ReceptorMail receptorMail = new ReceptorMail(arrayCuentasMail[i]);
					
					/* Debe averiguar si el nodo inbox de la propia cuenta est seleccionado;
				 	* si lo est, procede a la actualizacin de la tabla. Si no lo est, no
				 	* la lleva a cabo.
				 	*/
					if((node != null)&&(node.toString().equalsIgnoreCase("inbox"))&&(node.getParent().toString().equals(nombreCuentaReceptora))){
						//System.out.println("node: "+node); //DEBUG
						omtm.fireTableDataChanged(); // NO actualiza la tabla?
						sorter.fireTableChanged(new TableModelEvent(omtm)); // Ahora SI la actualiza.
						sorter.fireTableDataChanged();
					}
				
				} /****/

				OgreProgressBar.setDesactiva(); // Fin progressbar.
			}
		}
		
		/* ---Mtodo enviarMail--- */
		/* Envia los mails que estn en el directorio (en estado de) queued. */
		private void enviarMail() throws MessagingException, IOException, ClassNotFoundException{
			if(cuentaMail.nombreCuenta != null){
					
				File file, file2;
				CuentaMail[] arrayCuentasMail = {cuentaMail};
				
				/** EXPERIMENTAL **/
				if(MailProperties.jck4){
					obtenerNombresCuentas();
					arrayCuentasMail = new CuentaMail[cuentasMostrables.length];
					for(int i=0; i<cuentasMostrables.length; i++){
						CuentaMail unaCuentaMail = new CuentaMail();
						unaCuentaMail.seleccionar_cuenta(cuentasMostrables[i]);
						arrayCuentasMail[i] = unaCuentaMail;
					}
				}
				/** EXPERIMENTAL **/
				
				for(int i=0; i<arrayCuentasMail.length; i++){ /****/
				
				/* 1) Enviar los correos encolados, ir quitando los mandados de queued
				 * y ponindolos en outbox. */
				//String[] mailsQueued = GestorLocalMail.recuperar_mail_local(cuentaMail, "queued");
				String[] mailsQueued = GestorLocalMail.recuperar_mail_local(arrayCuentasMail[i], "queued");
				if(MainOgre.verboso){
					System.out.println("Cuenta "+arrayCuentasMail[i].nombreCuenta+".");
					System.out.println(mailsQueued.length+" correos pendientes.");
				}
				
				if(mailsQueued.length > 0){
						
					OgreProgressBar.setActiva(MailProperties.textos.getString("progressbar_enviando")); // Inicio progressbar.
					
					/* Array de MimeMessage's de tantos mensajes como haya en 'queued'. Se 
				 	* trata de un array corriente que alberga objetos; esta es la reserva 
				 	* de memoria para el tamao del array. */			
					MimeMessage[] arrayMensajes = new MimeMessage[mailsQueued.length];		
					for(int j=0; j<mailsQueued.length; j++){
						MimeMessage message = new MimeMessage(null, new FileInputStream(MailProperties.path_ogre+arrayCuentasMail[i].nombreCuenta+"/queued/"+mailsQueued[j]));
						//arrayMensajes[i] = message;
						arrayMensajes[j] = new MimeMessage(message); // Y esta la segunda reserva para cada elemento a aadir al array. 
						file = new File(MailProperties.path_ogre+arrayCuentasMail[i].nombreCuenta+"/queued/"+mailsQueued[j]);
						file2 = new File(MailProperties.path_ogre+arrayCuentasMail[i].nombreCuenta+"/outbox/"+file.getName());
						for(int k=0; file2.exists(); k++){
							file2 = new File(MailProperties.path_ogre+arrayCuentasMail[i].nombreCuenta+"/outbox/"+file.getName()+k);
						}
						
						file.renameTo(file2);
					}
					
					String nombreCuentaEmisora = arrayCuentasMail[i].nombreCuenta;	
					EmisorMail em = new EmisorMail(arrayCuentasMail[i], arrayMensajes);
						
					/* 2) Debe averiguar si el nodo queued o outbox estan seleccionados, adems de si
					 * la cuenta es la emisora; si lo es, y si alguno de ambos nodos est seleccionado,
				 	* procede a la actualizacin de la tabla. Sino, no la lleva a cabo.
				 	*/
					if(node != null){
						if(((node.toString().equalsIgnoreCase("queued"))||(node.toString().equalsIgnoreCase("outbox")))&&(node.getParent().toString().equals(nombreCuentaEmisora))){
							omtm.fireTableDataChanged(); // NO actualiza la tabla?
							sorter.fireTableChanged(new TableModelEvent(omtm)); // Ahora SI la actualiza.
							sorter.fireTableDataChanged();
						}
					}
						
					//OgreProgressBar.setDesactiva(); // Fin progressbar.
				}
				
				} /****/
				
				OgreProgressBar.setDesactiva(); // Fin progressbar.
			}
		}
		
		/* ---Mtodo obtenerNombresCuentas--- */
		/* Obtiene un listado de las Cuentas existentes. */
		private void obtenerNombresCuentas(){
		
			String[] cuentas = cuentaMail.descubrir_cuentas();
			cuentasMostrables = new String[cuentas.length];
			for(int i=0; i<cuentas.length; i++){
				// Cogemos el nombre real de cada cuenta.
				String item = cuentas[i].replaceAll("_config", "");
				String unItem = item.replace('.', ' ');
				String otroItem = unItem.trim();
				//cuentas[i] = otroItem;
				//cuentasMostrables.add(i, otroItem);
				cuentasMostrables[i] = new String(otroItem);
			}
			if(MainOgre.verboso) System.out.println("cuentas.length: "+cuentas.length);
		}
		
		/* ---Mtodo lanzarTareaAutomatizada--- */
		/* Lanza un thread temporizado para la tarea de recoger/enviar mail. Previamente 
		 * examina si ya existe un thread programado para esa tarea, en cuyo caso lo 
		 * destruye. Posteriormente obtiene el tiempo de temporizacin y lanza rl thread 
		 * temporaizado. */
		public void lanzarTareaAutomatizada(){
			// Arrancar un thread con un Timer "scheduledAtFixedRate".
			Timer timer = new Timer();
			// Eliminamos, si la hay, la anterior tarea programada....
			if(taskAutomatizar != null){
				boolean result = taskAutomatizar.cancel();
				if(result){
					if(MainOgre.verboso) System.out.println("Tarea CANCELADA.");
				}
			}
			
			//long miliseconds = oc.getMiliseconds();
			long miliseconds = OgreConfiguracion.getTiempo(MailProperties.jcb1);
			/*if(MainOgre.verboso)*/ System.out.println("miliseconds: "+miliseconds);
			
			// ...y creamos la nueva.
			taskAutomatizar = new TaskAutomatizar(timer);
			timer.scheduleAtFixedRate(taskAutomatizar, miliseconds, miliseconds);
		}
		
		////////////////////////////////////
		// CLASES INTERNAS de OgreMenuBar //
		////////////////////////////////////
	
		/* TaskAutomatizar- Representa una clase interna de OgreMenuBar que define la tarea
		 * a realizar por el Timer, en un hilo de ejecucin separado. */
		private class TaskAutomatizar extends TimerTask {
		
			Timer timer;
		
			TaskAutomatizar(Timer unTimer){
				timer = unTimer;
			}
		
			// Auto-enviar/recibir cada X tiempo.
			public void run(){
				
				try {
					OgreProgressBar.setActiva(MailProperties.textos.getString("progressbar_enviando")); // Inicio progressbar.
					EmisorMail.enviando = true;
					desactivacionBotonesCriticos();
					enviarMail();
					EmisorMail.enviando = false;
					OgreProgressBar.setActiva(MailProperties.textos.getString("progressbar_recibiendo")); // Inicio progressbar.
					ReceptorMail.recibiendo = true;
					recibirMail();
					ReceptorMail.recibiendo = false;
					activacionBotonesCriticos();
					activacionParar();
					buttonStop.setEnabled(true);
				} catch (Exception e1) {
					EmisorMail.enviando = false;
					ReceptorMail.recibiendo = false;
					activacionBotonesCriticos();
					activacionParar();
					OgreProgressBar.setDesactiva(); // Fin progressbar.
					JOptionPane.showMessageDialog(null, MailProperties.textos.getString("fallo_enviar_recibir_auto")+MainOgre.mensajeErrorEstandard, MailProperties.textos.getString("error"), JOptionPane.ERROR_MESSAGE);
					e1.getMessage();
					e1.printStackTrace();
				}
				
			}
		}	
		
	}

}
