package gui;

import java.awt.Dimension;
import javax.swing.JPanel;
import javax.swing.JProgressBar;

/******************************************************************************
 * 																			  *
 *  Copyright 2004 Jordi Oliveras & Marcos Valerio. 						  *
 * 																			  *
 *  This file is part of Ogre.												  *
 *																			  *
 *  Ogre is free software; you can redistribute it and/or modify			  *
 *  it under the terms of the GNU General Public License as published by	  *
 *  the Free Software Foundation; either version 2 of the License, or		  *
 *  (at your option) any later version.										  *
 *																			  *
 *  Ogre is distributed in the hope that it will be useful,					  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of			  *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			  *
 *  GNU General Public License for more details.							  *
 *                       													  *
 *  You should have received a copy of the GNU General Public License         *
 *  along with Ogre; if not, write to the Free Software                       *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 * 																			  *
 ******************************************************************************
 * 																			  *
 * OgreProgressBar - Clase que representa la barra de progreso que mantiene   *
 * informado al usuario acerca de aquellas operaciones de media-larga		  *
 * duracin que realiza la aplicacin.										  *
 * 																			  *
 ******************************************************************************/

public class OgreProgressBar extends JPanel {
	
	private static JProgressBar progressBar;
	
	public OgreProgressBar(){
		
		progressBar = new JProgressBar();
		progressBar.setPreferredSize(new Dimension(130,15));
		progressBar.setValue(0);
		progressBar.setVisible(false);/***/
		
		add(progressBar);
		setPreferredSize(new Dimension(130,20));
		setMaximumSize(new Dimension(130,20));
		
	}
	
	/* ---Mtodo setActiva--- */
	/* Activa la barra de progreso para una tarea definida por 'causa'. */
	public static void setActiva(String causa){
		progressBar.setString(causa);
		progressBar.setVisible(true);/***/
		progressBar.setStringPainted(true);
		progressBar.setIndeterminate(true);
		/*progressBar.setMinimum(0);
		progressBar.setMaximum(max);
		progressBar.setValue(0);
		progressBar.setStringPainted(true);*/
	}
	
	/* ---Mtodo setDesactiva--- */
	public static void setDesactiva(){
		progressBar.setVisible(false);/***/
		progressBar.setStringPainted(false);
		progressBar.setIndeterminate(false);
	}

}
