package gui;

import java.awt.Color;
import java.awt.Component;
import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;

/******************************************************************************
 * 																			  *
 *  Copyright 2004 Jordi Oliveras & Marcos Valerio. 						  *
 * 																			  *
 *  This file is part of Ogre.												  *
 *																			  *
 *  Ogre is free software; you can redistribute it and/or modify			  *
 *  it under the terms of the GNU General Public License as published by	  *
 *  the Free Software Foundation; either version 2 of the License, or		  *
 *  (at your option) any later version.										  *
 *																			  *
 *  Ogre is distributed in the hope that it will be useful,					  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of			  *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			  *
 *  GNU General Public License for more details.							  *
 *                       													  *
 *  You should have received a copy of the GNU General Public License         *
 *  along with Ogre; if not, write to the Free Software                       *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 * 																			  *
 ******************************************************************************
 * 																			  *
 * OgreTableRenderer - Tabla que modifica el renderizador de la tabla que se  *
 * encarga de mostrar los mails por pantalla, para que destaque filas pares e *
 * impares. nicamente es una mejora en la visualizacin de las filas que     *
 * representa cada correo, sin tener que recurrir a la menos esttica         *
 * parrilla por defecto de la tabla.                                          *
 * 																		      *
 ******************************************************************************/

public class OgreTableRenderer extends DefaultTableCellRenderer {
	
	public Component getTableCellRendererComponent(JTable table, java.lang.Object value, boolean isSelected, boolean hasFocus, int row, int column) {
	   if( !isSelected ) {
		  Color c = table.getBackground();
		  if(((row%2)==0) && (c.getRed()>20) && (c.getGreen()>20) && (c.getBlue()>20))
			 setBackground(new Color(c.getRed()-20, c.getGreen()-20, c.getBlue()-20));
		  else
			 setBackground(c);
	   }
	   return super.getTableCellRendererComponent(table,value,isSelected,hasFocus,row,column);
	}
	
}
